#include <stdio.h>
#include <conc.h>
#include <node.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <sys/time.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <errno.h>
#include <signal.h>
#include <conc.h>
#include "pvm3.h"
#include "global.h"
#include "ddpro.h"
#include "tdpro.h"
#include "protoglarp.h"
#include "pvmalloc.h"
#include "host.h"
#include "pvmfrag.h"
#include "mesg.h"
#include "pkt.h"
#include "task.h"
#include "listmac.h"
#include "pvmdmp.h"
#include "pvmmimd.h"
#include "bfunc.h"
#include "queue.h"
#include "t9defs.h"
#include "inmos.h"
#include "isocket.h"
#include "iserver.h"

#if 0
#define ISERVER_CONNECTED		1
#endif
#define PVMBOOT			1

#ifndef MAXPATHLEN
#define MAXPATHLEN  CANBSIZ
#endif
#define	CINDEX(s,c)	strchr(s,c)

#define QLEN			10
#define PVMBINPATH		"pvm3/bin"

#ifndef min
#define min(a,b)	((a)<(b)?(a):(b))
#endif

char *getenv();
_Semaphore ServerSemaphore;
char *IserverStack[MAX_NODES][MAX_TASKS];
int TaskRunning[MAX_NODES][MAX_TASKS];
StdIOStruct *PendingStdIO = NULL;
_Semaphore StdIOSemaphore;
int ExecDaemon = -1;

/* global */

extern void     pvmbailout();
extern int      debugmask;		/* from pvmd.c */
extern char 	**epaths;   	/* from pvmd.c */
extern int 		myhostpart;		/* from pvmd.c */
extern int 		myndf;			/* from pvmd.c */
extern struct htab *hosts;		/* from pvmd.c */
extern int		tidhmask;		/* from lpvm.c */
extern struct task *locltasks;	/* from task.c */
extern int 		log_fd;			/* from pvmlog.c */
extern int		ourudpmtu;		/* from pvmd.c */

int tidtmask = TIDPTYPE;     	/* mask for cube field of tids */
int tidnmask = TIDNODE;   		/* mask for node field of tids */

struct nodeset *busynodes = 0;	/* allocated cubes */


/* private */

static char rcsid[] = "$Id: pvmdmimd.c,v 1.3 1994/06/03 20:54:44 manchek Exp $";
static char     etext[512];		/* scratch for error log */
static long 	isendmid = -1;	/* msg ID returned by isend() */
static struct pkt *outpkt = 0;	/* packet being sent */
extern PVMD_PARAMETERS *pvmd_info;
extern int myhostpart;
extern void IserverFilter(), IserverRouter();
extern int NUM_NODES;
extern Channel *MIN_PVM_INTERNAL_CHANNEL;

#define IserverChan( VChan, NodeId, TaskId ) {			\
	if ( NodeId == 0 ){					\
		VChan= ((unsigned long)MIN_PVM_INTERNAL_CHANNEL + (MAX_TASKS * MAX_TASKS + (TaskId-1)*2 ) * BYTES_PER_INTERNAL_CHANNEL+4 );	\
	} else {						\
		VChan= ((unsigned long)MIN_PVM_VIRTUAL_CHANNEL + (MAX_TASKS * MAX_TASKS * (NUM_NODES-1) + (NodeId -1)*MAX_TASKS + TaskId)* BYTES_PER_VIRTUAL_CHANNEL );	\
	}							\
}

#define LoaderChan( VChan, NodeId ) {				\
	if ( NodeId == 0 ){					\
		VChan= ((unsigned long)MIN_PVM_INTERNAL_CHANNEL + (MAX_TASKS * MAX_TASKS + (MAX_TASKS-1)*2 ) * BYTES_PER_INTERNAL_CHANNEL+4 );	\
	} else {						\
		VChan= ((unsigned long)MIN_PVM_VIRTUAL_CHANNEL + (MAX_TASKS * MAX_TASKS * (NUM_NODES-1) + ( NUM_NODES-1)*MAX_TASKS + (NodeId -1))* BYTES_PER_VIRTUAL_CHANNEL );	\
	}							\
}
void
mpp_init(argc, argv)
	int *argc;
	char **argv;
{
	int pvminfo[SIZEHINFO];
	int NumTasks;
	int i, j;
	int mysetpart, ptid;
	struct task *tp;
	int TaskId;
	int *ParameterBlock;
	int *MDL, *ThreadStack;
	int cmdindex = 0;

	_init_pvm();
	ptid = 0;
	TaskRunning[0][0] = 1;
	for ( i = 0; i < pvmd_info->NumNodes; i++ ){
		NumTasks =  pvmd_info->NumTasksLoaded[i];
		for ( j = 0; j < NumTasks; j++ ){
			if (( i == 0 )&&( j == 0 )) continue;/* PVMD */
			TaskId = j;
			TaskRunning[i][j] = 1;
			mysetpart = ((myhostpart & TIDHOST)+((TaskId << (ffs(TID_TASKID)-1)& TID_TASKID)+(i & TID_NODEID))) | TIDONNODE;
			tp = task_new(mysetpart);
			tp->t_a_out = ""; /*STRALLOC(name): FIXME */
			tp->t_ptid = ptid;
			tp->t_flag |= TF_CONN;

#ifndef ISERVER_CONNECTED
			ThreadStack = (int *)MEM_ALLOCATE( DEFAULT_ISERVER_STACKSIZE );
			IserverStack[i][j] = (char *)ThreadStack;
			ThreadStack += (DEFAULT_ISERVER_STACKSIZE/sizeof(int) - 20 );
			ParameterBlock = ThreadStack + 10;
			ParameterBlock[0] = 3 * sizeof(long);
			IserverChan(ParameterBlock[1], i, j);
			ParameterBlock[2] = i;
			ParameterBlock[3] = (int)_get_param(13+cmdindex); cmdindex++;

			ThreadStack[0] = 0;
			Get_MDL(&(ThreadStack[1]));
			ThreadStack[2] = (int)&(ParameterBlock[1]);
			ThreadStack[3] = 0;
			ThreadRunHigh( ThreadStack, IserverRouter );
#endif


			_SemSignal( &ServerSemaphore );
			pvminfo[0] = 0; pvminfo[1] = 0;
			pvminfo[2] = 0; pvminfo[3] = 0;
			pvminfo[4] = 0; /* Not environment passed */
			if (_async_send(PMTHOST, pvminfo, SIZEHINFO*sizeof(int), i, TaskId ) < 0)
				pvmlogperror("mpp_init(): csend");
			pvminfo[0] = TDPROTOCOL;
			pvminfo[1] =  TIDONNODE;
			pvminfo[2] = ptid;
			pvminfo[3] = MAXFRAGSIZE;
			pvminfo[4] = myndf;
			if (_async_send(PMTHOST, pvminfo, sizeof(pvminfo), i, TaskId ) < 0)
				pvmlogperror("mpp_init(): csend");
			_SemWait( &ServerSemaphore );
			PerformLoclStOut();
		}
	}

}

void delete_task( int nodeid, int taskid )
{
	int i;
	pvmd_info->NumTasksLoaded[nodeid]--;
	TaskRunning[nodeid][taskid] = 0;
	free( IserverStack[nodeid][taskid]);
	for ( i = 0; i < pvmd_info->NumNodes; i++ ){
		if ((( i == 0) && (pvmd_info->NumTasksLoaded[i] > 1 ))||
			(( i != 0 )&&( pvmd_info->NumTasksLoaded[i] > 0 ))){
			return;
		}
	}
}

void
mpp_free(tid)
	int tid;
{
	int nodeid, taskid;

	nodeid = t9_nodeid(tid);
	taskid = t9_taskid(tid);
	_kill_receiver( nodeid, taskid );
	delete_task( nodeid, taskid );
}

t9_load(flags, name, argv, count, tids, ptid, tpp, taskparams, env)
    int flags;              /* exec options */
    char *name;             /* executable */
    char **argv;            /* arg list (argv[-1] must be there) */
    int count;              /* how many */
    int tids[];             /* array to store new tids */
    int ptid;               /* parent task ID */
    struct task **tpp;
    int *taskparams;
    char **env;
{
	char path[MAXPATHLEN];
	struct stat sb;
	char **ep, **eplist;
	int err;
	struct nodeset *sp;
	int mysetpart;
	int i;
	struct task *tp;
	static char *nullep[] = { "", 0 };


	eplist = CINDEX(name, '/') ? nullep : epaths;
	for (ep = eplist; *ep; ep++) {
#if 0
		if ((*ep)[0] != '/') {
			(void) strcpy(path, getenv("HOME"));	/* needs absolute path */
			(void) strcat(path, "/");
			(void) strcat(path, *ep);
		} else
#endif
			(void) strcpy(path, *ep);
		if ( path[0] )
		(void) strcat(path, "/");
		(void) strncat(path, name, sizeof(path) - strlen(path) - 1);

		/* FIXME : stat always returns -1 */
		if (stat(path, &sb) == -1
		    || ((sb.st_mode & S_IFMT) != S_IFREG)
		    || !(sb.st_mode & S_IEXEC)) {
			continue;
		}

		/* file found */
		if ( _load(path, flags, argv, count, tids, ptid, tpp, taskparams, env ) < count ) {
			err = PvmOutOfRes;
			goto done;

		}
		if (debugmask & PDMTASK) {
			sprintf(etext, "mpp_load() %d node#%d... ptid=%d\n", 
				count, tids[0]-mysetpart, ptid);
			pvmlogerror(etext);
		}
		return 0;
	}
	if (debugmask & PDMTASK) {
		sprintf(etext, "mpp_load() didn't find <%s> in %s\n", name, *epaths);
		pvmlogerror(etext);
	}
	err = PvmNoFile;

done:
	for (i = 0; i < count; i++)
		tids[i] = err;
	return err;
}


/* input from node tasks */
void
mpp_input()
{
	char *cp;
	struct pkt *pp = 0;
	int hdrdiff = 0;                /* extra space needed for DD frag header
	*/
	int len;

	if ((len = _infocount()) < 0)
		pvmlogerror("mpp_input() infocount");
	if (DDFRAGHDR > TDFRAGHDR)
		hdrdiff = DDFRAGHDR - TDFRAGHDR;
	pp = pk_new(len + hdrdiff);
	pp->pk_len = len;
	pp->pk_dat += hdrdiff;
	if (_blocked_receive(-1,-1,-1, pp->pk_dat, (long)len, NULL) < 0)
		pvmlogperror("mpp_input() crecv");
	else
		loclinpkt(0, pp);
}


/* use csend() to multicast */
/* XXX cannot mcast to multiple cubes or tasks running on frontend */
int
mpp_mcast(pp, tids, ntask)
	struct pkt *pp;	/* packet to send */
	int tids[];		/* target tasks */
	int ntask;		/* how many */
{
	int i, j;
	char *cp;
	static int TaskList[MAX_NODES][MAX_TASKS];
	int TaskCount[MAX_NODES];
	int nodeid;

	for ( i = 0; i < MAX_NODES; i++ ) TaskCount[i] = 0;
	for (i = 0; i < ntask; i++) {
		if ((tids[i] & tidhmask) != myhostpart)
			continue;
		if (!TIDISNODE(tids[i])) {
		    struct pkt *pp2;
		    struct task *tp;

		    if (tp = task_find(tids[i])) {
			pp2 = pk_new(0);
			pp2->pk_src = pp->pk_src;
			pp2->pk_dst = pp->pk_dst;
			pp2->pk_flag = pp->pk_flag;
			pp2->pk_buf = pp->pk_buf;
			pp2->pk_max = pp->pk_max;
			pp2->pk_dat = pp->pk_dat;
			pp2->pk_len = pp->pk_len;
			da_ref(pp->pk_buf);
			pkt_to_task(tp, pp2);
		    }
			continue;
		}
		nodeid = t9_nodeid(tids[i]);
		TaskList[nodeid][TaskCount[nodeid]] = t9_taskid(tids[i]);
		TaskCount[nodeid]++;
	}
	cp = (pp->pk_dat -= TDFRAGHDR);
	pvmput32(cp, pp->pk_dst);
	pvmput32(cp + 4, pp->pk_src);
	pvmput32(cp + 8, pp->pk_len);
	pvmput8(cp + 12, pp->pk_flag & (FFSOM|FFEOM));
	pp->pk_len += TDFRAGHDR;
	for( i = 0; i < MAX_NODES; i++ ) {
		if (TaskCount[i]) {
			for (j = 0; j < TaskCount[i]; j++){
				if (_async_send(PMTPACK, pp->pk_dat, (long)pp->pk_len, i, TaskList[i][j])
						< 0)
					pvmlogperror("mpp_mcast() csend");
			}
			if (debugmask & PDMMESSAGE) {
				sprintf(etext, "mpp_mcast() pkt from t%x len=%d to node=%d \n",
					pp->pk_src, pp->pk_len, i);
				pvmlogerror(etext);
			}
		}
	}
	return 0;
}


/* output to node tasks */
void
mpp_output(tp, pp)
	struct task *tp;
	struct pkt *pp;
{
	char *cp;
	long nodeid;
	long taskid;

	nodeid = t9_nodeid(tp->t_tid);
	taskid = t9_taskid(tp->t_tid);

        if (debugmask & PDMPACKET) {
                sprintf(etext,
                        "mpp_output() src t%x dst t%x ff %x len %d \n",
                        pp->pk_src, pp->pk_dst, pp->pk_flag & (FFSOM|FFEOM),
                        pp->pk_len);
                pvmlogerror(etext);
        }
        cp = (pp->pk_dat -= TDFRAGHDR);
        pvmput32(cp, pp->pk_dst);
        pvmput32(cp + 4, pp->pk_src);
        pvmput32(cp + 8, pp->pk_len);
        pvmput8(cp + 12, pp->pk_flag & (FFSOM|FFEOM));
        pp->pk_len += TDFRAGHDR;

        if (isendmid >= 0) {
                _async_wait(isendmid);
                if (outpkt) {
                        pk_free(outpkt);
                        outpkt = 0;
                }
        }
        if ((isendmid = _async_send(PMTPACK, cp, (long)pp->pk_len, nodeid, taskid)) < 0) {
                sprintf(etext,"mpp_output() can't send to t%x", tp->t_tid);
                pvmlogperror(etext);
                pk_free(pp);
                mpp_free(tp->t_tid);
                tp = tp->t_rlink;
                task_cleanup(tp->t_link);
                task_free(tp->t_link);
        } else
                outpkt = pp;

done:
        if (tp->t_flag & TF_CLOSE) {
            mpp_free(tp->t_tid);
                tp = tp->t_rlink;
/* XXX tm_exit() also calls task_cleanup(); should only be done once */
                task_cleanup(tp->t_link);
                task_free(tp->t_link);
        }
}

/* probe for messages from node tasks */
int
mpp_probe()
{
	struct nodeset *sp;
	return( _probe(-1, -1, -1));
}

void
mpp_kill(tp, signum)
	struct task *tp;
	int signum;
{

	if (TIDISNODE(tp->t_tid)) {
		if (signum == SIGKILL || signum == SIGTERM) {
			if (_kill_task(t9_nodeid(tp->t_tid), t9_taskid(tp->t_tid)) < 0)
				pvmlogperror("mpp_kill() kill_task");
			if (debugmask & PDMNODE) {
				sprintf(etext, "mpp_kill() zap t%x \n", tp->t_tid );
				pvmlogerror(etext);
			}
			delete_task(t9_nodeid(tp->t_tid), t9_taskid(tp->t_tid));
			tp = tp->t_rlink;
/* XXX tm_exit() also calls task_cleanup(); should only be done once */
			task_cleanup(tp->t_link);
			task_free(tp->t_link);
		} else {
			sprintf(etext,"mpp_kill() signal %d to node t%x ignored\n",
				signum, tp->t_tid);
			pvmlogerror(etext);
		}
	} 
}


#undef htons
tcp_open(int port )
{
  struct hostent *hostent;
  struct sockaddr_in sockaddr;
  int tmp;
  static  char hostname[100];
  struct protoent *protoent;
  int fd;
  int Len, i, j;
  char *TclCmd;

  gethostname( hostname, 98 );

  hostent = gethostbyname (hostname);

  if (!hostent)
    {
      fprintf(stderr, "%s: unknown host\n", hostname);
      errno = ENOENT;
      return -1;
    }

  fd = socket (AF_INET, SOCK_STREAM, 0);
  if (fd < 0)
    return -1;

  /* Allow rapid reuse of this port. */
  tmp = 1;
  setsockopt (fd, SOL_SOCKET, SO_REUSEADDR, (char *)&tmp, sizeof(tmp));

  /* Enable TCP keep alive process. */
  tmp = 1;
  setsockopt (fd, SOL_SOCKET, SO_KEEPALIVE, (char *)&tmp, sizeof(tmp));

  sockaddr.sin_family = AF_INET;
  sockaddr.sin_port = htons(port);
  memcpy (&sockaddr.sin_addr.s_addr, hostent->h_addr,
          sizeof (struct in_addr));

  if (connect (fd, &sockaddr, sizeof(sockaddr)))
    {
      close(fd);
      fd = -1;
      return -1;
    }
  return fd;
}

#undef ntohs
#undef htons

/*{{{  _load*/
/*
 *------------------------------------------------------------------------
 *
 *      _load :
 *		Load a COFF file <count> times
 *	Parameters :
 *		name : name of COFF file
 *		argv : arguments to the task
 *		count : number of tasks to be created
 *		tids : array to return task ids
 *		ptid : Parent taskid
 *
 *      Return value :
 *		Returns the taskids of the tasks created in <tids>
 *
 *------------------------------------------------------------------------
 */
_load(name, flags, argv, count, tids, ptid,tpp, taskparams, env  )
    char *name;             /* executable */
    int flags;
    char **argv;            /* arg list (argv[-1] must be there) */
    int count;              /* how many */
    int tids[];             /* array to store new tids */
    int ptid;               /* parent task ID */
    struct task **tpp;		/* return task context */
    int *taskparams;
    char **env;
{
	int i, j, least_loaded;
	static char TclCmdBuf[MAX_TCL_COMMAND];
	char DebugOption[50];
	int tcl_sock;
	char *TclCmd;
	int NumLoaded = 0;
	int TaskId;
	int mysetpart;
	struct task *tp;
	int pvminfo[SIZEHINFO];
	int HeaderIndex;
	static int TaskIndex = MAX_TASKS;
	unsigned long HeapSize, StackSize;
	char *p, *buf;
	extern char *debugger;
	char *DebugCommand;
	int *ParameterBlock;
	int *MDL, *ThreadStack;
	struct {
		int TaskId;
		int Command;
	}TaskLoad;
	unsigned char TaskParams[8];
	Channel *LoaderOutChan, *LoaderInChan;

	if ( flags & PvmTaskDebug ){
		if (p = getenv( "PVM_DEBUGGER" )){
			sprintf( DebugOption, "-debug %s", p );
			DebugCommand = p;
		}
		else {
			sprintf( DebugOption, "-debug %s", debugger );
			DebugCommand = debugger;
		}
	} else
		DebugOption[0] = '\0';
	for ( j = 0; j < count; j++ ){
		least_loaded = 0;
		for ( i = 0; i < pvmd_info->NumNodes; i++ ){
			if ( pvmd_info->NumTasksLoaded[i] == 0 ){
				least_loaded = i;
				break;
			}
			if ( pvmd_info->NumTasksLoaded[i] < pvmd_info->NumTasksLoaded[least_loaded] ){
				least_loaded = i;
			}
		}
		if ( pvmd_info->NumTasksLoaded[least_loaded] == MAX_TASKS )
			return(NumLoaded);
		else
			NumLoaded++;
		for ( i = 0; i < MAX_TASKS; i++ ){
			if ( !TaskRunning[least_loaded][i] ){
				TaskId = i; 
				TaskRunning[least_loaded][i] = 1;
				break;
			}
		}
		HeaderIndex = TaskId* pvmd_info->NumNodes + least_loaded ; 
		TclCmd = &(TclCmdBuf[4] );
		if ( isatty(0)) fprintf( stderr, "Spawning %s on node %d\n", name, least_loaded );
		HeapSize =  *(unsigned long *)_get_param(10);
		StackSize = *(unsigned long *)_get_param(12);
		if ( argv != NULL ){
			i = 0;
			while ( argv[i] != NULL ){
				if ( strcmp( argv[i], "-heap" )== 0 )
					HeapSize = atoi(argv[i+1]);
				else if ( strcmp( argv[i], "-stack" )== 0 )
					StackSize = atoi(argv[i+1]);
				i++;
			}
		}

#ifndef PVMBOOT
#ifndef ISERVER_CONNECTED
		sprintf( TclCmd, "\nvcpsend %s %s -data 0x%xl.0x0l\nrun #coffserver %s %s %s %s -sc %s -heap %d -stack %d %s\nvcpsend %s %s -data 2.1.0x%x.4.0x%xl\n",
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			TaskId /*TaskIndex*/,
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			pvmd_info->Header[least_loaded],
			name, HeapSize, StackSize, DebugOption,
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			*(char *)_get_param(1), *(int *)_get_param(2));
#else
		sprintf( TclCmd, "\nvcpsend %s %s -data 0x%xl.0x0l\nrun #coffserver %s %s %s %s -sc %s -heap %d -stack %d %s\nvcpsend %s %s -data 2.1.0x%x.4.0x%xl\n run #coffserver %s %s %s %s -bind { vcpsend %s %s -data 0x%xl.0x1l } -ss %s -heap %d -stack %d %s",
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			TaskId,
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			pvmd_info->Header[least_loaded],
			name, HeapSize, StackSize, DebugOption,
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			*(char *)_get_param(1), *(int *)_get_param(2),
			pvmd_info->ServHeader[HeaderIndex],
			pvmd_info->ServAckHeader[HeaderIndex],
			pvmd_info->ServAckHeader[HeaderIndex],
			pvmd_info->ServHeader[HeaderIndex],
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded],
			TaskId,
			name, HeapSize, StackSize, DebugOption );
#endif
		AddTclCommand( TclCmd );
#else
		LoaderChan( LoaderInChan, least_loaded );
		if ( least_loaded == 0 )
			LoaderOutChan = (char *)LoaderInChan-4;
		else 
			LoaderOutChan = (char *)LoaderInChan+4;
		if ( least_loaded == 0 ){
			int Chan;
			IserverChan(Chan, least_loaded, TaskId);
			*(int *)(Chan) = NOT_PROCESS;
			*(int *)(Chan-4) = NOT_PROCESS;
		}
		TaskLoad.TaskId = TaskId; TaskLoad.Command = 0;
		_VChanOut( LoaderOutChan, &TaskLoad, sizeof(TaskLoad));
		CoffLoadT9000( name, LoaderOutChan, LoaderInChan, HeapSize, StackSize, flags & PvmTaskDebug, DebugCommand );
		TaskParams[0] = 2; TaskParams[1] = 1; 
		TaskParams[2] = *(char *)_get_param(1);
		TaskParams[3] = 4;
		blockmove(TaskParams+4, (char *)_get_param(2), 4 );
		_VChanOut( LoaderOutChan, &TaskParams, sizeof(TaskParams));
#endif
		mysetpart = ((myhostpart & TIDHOST)+((TaskId << (ffs(TID_TASKID)-1)& TID_TASKID))) | TIDONNODE;
		tids[j] = mysetpart + least_loaded;
		tp = task_new(tids[j]);
		tp->t_a_out = STRALLOC(name);
		tp->t_ptid = ptid;
		tp->t_flag |= TF_CONN;

#ifndef ISERVER_CONNECTED
		ThreadStack = (int *)MEM_ALLOCATE( DEFAULT_ISERVER_STACKSIZE );
		IserverStack[least_loaded][TaskId] = (char *)ThreadStack;
		ThreadStack += (DEFAULT_ISERVER_STACKSIZE/sizeof(int) - 24 );
		ParameterBlock = ThreadStack + 10;
		ParameterBlock[0] = 9 * sizeof(long);
		ParameterBlock[1] = tp;
		IserverChan(ParameterBlock[2], least_loaded, TaskId);

		sprintf( TclCmd, "vcpsend %s %s -data 0x%xl.0x1l\n", 
			pvmd_info->Header[least_loaded],
			pvmd_info->AckHeader[least_loaded], TaskId/*TaskIndex*/ );
		ParameterBlock[3] = STRALLOC(TclCmd);
		sprintf( TclCmd, "coffserver -sb %s",name );
		if (( argv != NULL )&&(argv[0] != NULL )){
			i = 1;
			while ( argv[i] != NULL ){
				strcat( TclCmd, " " );
				strcat( TclCmd, argv[i++] );
			}
		}
		strcat( TclCmd, "\n" );
		ParameterBlock[4] = STRALLOC(TclCmd);
		ParameterBlock[5] = STRALLOC(TclCmd);
		ParameterBlock[6] = MEM_ALLOCATE(TRANSACTION_BUFFER_SIZE);
		ParameterBlock[7] = MEM_ALLOCATE(TRANSACTION_BUFFER_SIZE);
		ParameterBlock[8] = least_loaded;
		ParameterBlock[9] = TaskId;

		ThreadStack[0] = 0;
		Get_MDL(&(ThreadStack[1]));
		ThreadStack[2] = (int)&(ParameterBlock[1]);
		ThreadStack[3] = 0;
		ThreadRunHigh( ThreadStack, IserverFilter );
#endif

		pvmd_info->NumTasksLoaded[least_loaded]++;
		TaskIndex++;
		_SemSignal( &ServerSemaphore );
		if (_async_send(PMTHOST, taskparams, SIZEHINFO*sizeof(int), (long)least_loaded, TaskId) < 0)
			pvmlogperror("mpp_init(): csend");
		pvminfo[0] = TDPROTOCOL;
		pvminfo[1] = mysetpart;
		pvminfo[2] = ptid;
		pvminfo[3] = MAXFRAGSIZE;
		pvminfo[4] = myndf;

		tpp[j] = tp;
		if (_async_send(PMTHOST, pvminfo, sizeof(pvminfo), (long)least_loaded, TaskId) < 0)
			pvmlogperror("csend");
		for ( i = 0; i < taskparams[4]; i++ ){
			int envlen = strlen(env[i])+1;
			if (_async_send(PMTHOST, &envlen, sizeof(int), (long)least_loaded, TaskId) < 0)
			pvmlogperror("csend");
			if (_async_send(PMTHOST, env[i],envlen, (long)least_loaded, TaskId) < 0)
			pvmlogperror("csend");
		}
		_SemWait( &ServerSemaphore );
		PerformLoclStOut();
	}
	return(NumLoaded);
}
/*}}}*/



/*{{{  ProcessTBuf*/
/*	Execute a serve request. Returns 1 if successful, and
	0 otherwise
*/
int ProcessTBuf( int NodeId, int TaskId, struct task *tp, unsigned char *SendBuf, unsigned char *RecvBuf,  int *Count, int *TerminateFlag, char *RealCommandLine, char *DoctoredCommandLine)
{
	int SockId;
	int Length, i;
	FILE *SockFP;
	int ret = 0;

	if ( SendBuf[0] == SP_EXIT ){
		*TerminateFlag = TRUE;
		*Count = 1; 
		RecvBuf[0] = SP_SUCCESS;
		return(1);
	}
	if ( SendBuf[0] == SP_COMMAND ){
		/*{{{  return command line*/
		RecvBuf[0] = SP_SUCCESS;
		if ( SendBuf[1] ){
			strcpy( &(RecvBuf[3]), RealCommandLine );
			Length = strlen( RealCommandLine );
		}
		else {
			strcpy( &(RecvBuf[3]), DoctoredCommandLine );
			Length = strlen( DoctoredCommandLine );
		}
		RecvBuf[1] = Length%256;
		RecvBuf[2] = Length/256;
		*Count = Length+3;
		return(1);
		/*}}}*/
	}
	if (( SendBuf[0] == SP_SOCKMODE1 )&&( SendBuf[1] == SP_SOCKCLOSE )){
		/* Donot close std files */
		READ_INT32( &(SendBuf[2]), SockId );
		if (( SockId >=0 )&&( SockId <= 2 )){
			*Count = 1; 
			RecvBuf[0] = SP_SUCCESS;
			return( 1 );
		}
	}
	if ( SendBuf[0] == SP_CLOSE ){
		/* Donot close std files */
		READ_INT32( &(SendBuf[1]), SockId );
		if (( SockId >=0 )&&( SockId <= 2 )){
			*Count = 1; 
			RecvBuf[0] = SP_SUCCESS;
			return( 1 );
		}
	}
	if (( SendBuf[0] == SP_SOCKMODE1 )||( SendBuf[0] == SP_SOCKMODE2 )){
		/*{{{  replace socket id for stdin, stdout and stderr*/
		if (( SendBuf[1] == SP_FCNTL )||
		    ( SendBuf[1] == SP_IOCTL )||
		    ( SendBuf[1] == SP_SOCKWRITE )||
		    ( SendBuf[1] == SP_SOCKWRITEV )||
		    ( SendBuf[1] == SP_WRITESEGSTART )||
		    ( SendBuf[1] == SP_WRITESEGMORE )||
		    ( SendBuf[1] == SP_SOCKSEEK )){
			READ_INT32( &(SendBuf[2]), SockId );
			if (( SockId != 1 )&&( SockId != 2 )) 
				return(0);
		}
		else
			return(0);
		if ( SendBuf[1] == SP_WRITESEGSTART ){
			Length = SendBuf[10] + SendBuf[11] * 256;
			SendBuf[Length+12] = '\0';
			t9_loclstout( NodeId, TaskId, tp, &(SendBuf[12]), Length ); 
			*Count = 17;
			RecvBuf[0] = SP_SUCCESS;
			WRITE_INT32( &(RecvBuf[1]), 0 );
			WRITE_INT32( &(RecvBuf[5]), 0 );
			WRITE_INT32( &(RecvBuf[9]), Length );
			WRITE_INT32( &(RecvBuf[13]), 1 );
			return(1);
		}
		if ( SendBuf[1] == SP_WRITESEGMORE ){	
			Length = SendBuf[6] + SendBuf[7] * 256;
			SendBuf[Length+8] = '\0';
			t9_loclstout( NodeId, TaskId, tp, &(SendBuf[8]), Length ); 
			*Count = 13;
			RecvBuf[0] = SP_SUCCESS;
			WRITE_INT32( &(RecvBuf[1]), 0 );
			WRITE_INT32( &(RecvBuf[5]), 0 );
			WRITE_INT32( &(RecvBuf[9]), Length );
			return(1);
		}
		if ( SendBuf[1] == SP_SOCKWRITE ){	
			READ_INT32( &(SendBuf[14]), Length );
			*Count = 13;
			RecvBuf[0] = SP_SUCCESS;
			WRITE_INT32( &(RecvBuf[1]), 0 );
			WRITE_INT32( &(RecvBuf[5]), 0 );
			WRITE_INT32( &(RecvBuf[9]), Length );
			return(1);
		}
		return(0);
		/*}}}*/
	}
	if (( SendBuf[0] == SP_CLOSE )||
	    ( SendBuf[0] == SP_READ )||
	    ( SendBuf[0] == SP_WRITE )||
	    ( SendBuf[0] == SP_GETBLOCK )||
	    ( SendBuf[0] == SP_PUTBLOCK )||
	    ( SendBuf[0] == SP_GETS )||
	    ( SendBuf[0] == SP_PUTS )||
	    ( SendBuf[0] == SP_FLUSH )||
	    ( SendBuf[0] == SP_SEEK )||
	    ( SendBuf[0] == SP_TELL )||
	    ( SendBuf[0] == SP_EOF )||
	    ( SendBuf[0] == SP_ERROR )){
			/*{{{  perform file operations for stdin, stdout and stderr*/
			/*{{{  get corresponding file pointer*/
			READ_INT32( &(SendBuf[1]), SockId );
			if (( SockId != 1 )&&( SockId != 2 )) 
				return(0);
			/*}}}*/
			switch ( SendBuf[0] ){
			case SP_PUTS :
				/*{{{  write to new file pointer*/
				{
					Length = SendBuf[5] + SendBuf[6] * 256;
					SendBuf[7+Length] = '\n';
					t9_loclstout( NodeId, TaskId, tp, &(SendBuf[7]), Length ); 
					*Count = 1;
					RecvBuf[0] = SP_SUCCESS;
					ret = 1; 
					break;
				}
				/*}}}*/
			case SP_WRITE :
			case SP_PUTBLOCK:
				/*{{{  write to new file pointer*/
				{
					Length = SendBuf[5] + SendBuf[6] * 256;
					t9_loclstout( NodeId, TaskId, tp, &(SendBuf[7]), Length ); 
					*Count = 3;
					RecvBuf[0] = SP_SUCCESS;
					RecvBuf[1] = Length%256;
					RecvBuf[2] = Length/256;
					ret = 1; 
					break;
				}
				/*}}}*/
			case SP_CLOSE :
				/*{{{  will be closed later by ServerExit*/
				*Count = 1;
				RecvBuf[0] = SP_SUCCESS;
				return(1);
				/*}}}*/
			default :
				break;
			}
			/*}}}*/
		}
	return(ret);
}
/*}}}*/

/*{{{  ServerThread*/

void IserverRouter(Channel *InChan, int NodeId, char *CommandLine)
{
	int Count;
	Channel *OutChan;
	unsigned char *SendBuf, *RecvBuf;

	if ( NodeId == 0 )
		OutChan = (Channel *)((unsigned long )InChan - 4); /* Internal channel */
	else
		OutChan = (Channel *)((unsigned long )InChan + 4);
	SendBuf = (char *)MEM_ALLOCATE( TRANSACTION_BUFFER_SIZE );
	RecvBuf = (char *)MEM_ALLOCATE( TRANSACTION_BUFFER_SIZE );
	while ( 1 ){
		Count = _VChanIn( InChan, SendBuf, TRANSACTION_BUFFER_SIZE );
		if ( SendBuf[0] == SP_COMMAND ){
			RecvBuf[0] = SP_SUCCESS;
			strcpy( &(RecvBuf[3]), CommandLine );
			Count = strlen( CommandLine );
			RecvBuf[1] = Count%256;
			RecvBuf[2] = Count/256;
			Count += 3;
		}
		else if ( Count > 0 ){
			Count = server_transaction( SendBuf, Count, RecvBuf );
		}
		if ( Count > 0 )
			_VChanOut(OutChan, RecvBuf, Count );
	}
	free( SendBuf ); free( RecvBuf );
	StopThread();
}

void IserverFilter(  struct task *tp, Channel *InChan,  char *BoundCommand, char *RealCommandLine, char *DoctoredCommandLine, unsigned char *SendBuf, unsigned char *RecvBuf, int NodeId, int TaskId )
{
	int Count;
	int TerminateFlag = 0;
	Channel *OutChan;
	struct {
		int TaskId;
		int Command;
	}TaskLoad;
	Channel *LoaderOutChan, *LoaderInChan;

	LoaderChan( LoaderInChan, NodeId );
	if ( NodeId == 0 ){
		OutChan = (Channel *)((unsigned long )InChan - 4); /* Internal channel */
		LoaderOutChan = (char *)LoaderInChan-4;
	}
	else {
		OutChan = (Channel *)((unsigned long )InChan + 4);
		LoaderOutChan = (char *)LoaderInChan+4;
	}
	while ( !TerminateFlag ){
		Count = _VChanIn( InChan, SendBuf, TRANSACTION_BUFFER_SIZE );
		if ( Count > 0 ){
			if ( !ProcessTBuf( NodeId, TaskId, tp, SendBuf, RecvBuf, &Count, &TerminateFlag, RealCommandLine, DoctoredCommandLine))
				Count = server_transaction( SendBuf, Count, RecvBuf );
			_VChanOut(OutChan, RecvBuf, Count );
		}
	}
	_SemWait( &ServerSemaphore );
#ifdef PVMBOOT
	TaskLoad.TaskId = TaskId; TaskLoad.Command = 1;
	_VChanOut( LoaderOutChan, &TaskLoad, sizeof(TaskLoad));
#else
	AddTclCommand( BoundCommand );
#endif
	_SemSignal( &ServerSemaphore );
	free( BoundCommand ); free( RealCommandLine );
	free( DoctoredCommandLine );
	free( SendBuf ); free( RecvBuf );
	StopThread();
}
/*}}}*/

AddTclCommand( char *TclCmd )
{
	int tcl_sock, ret;
	char *buf = MEM_ALLOCATE( strlen(TclCmd)+5);
	*(int *)buf = strlen(TclCmd)+1;
	strcpy( buf+4, TclCmd );
	tcl_sock = tcp_open( pvmd_info->TclSocket );
	ret = write ( tcl_sock, buf, strlen(TclCmd)+5 );
	free(buf);
	close(tcl_sock);
}



#define SET_HEADERS( NumHeaders, HeaderPtr, HeaderList ){		\
	int HeaderLen, i, j;						\
	unsigned char *tptr = HeaderPtr;				\
	for ( i = 0; i < NumHeaders; i++ ){				\
		HeaderLen = *(tptr+1);					\
		HeaderList[i] = (char *)MEM_ALLOCATE( (HeaderLen+1)*4*sizeof(char));\
		sprintf( HeaderList[i], "l%d", *tptr );			\
		for ( j = 0; j < HeaderLen; j++ ){			\
			sprintf( HeaderList[i], "%s.%d", HeaderList[i], *(tptr+j+2));\
		}							\
		tptr += HeaderLen+2;					\
	}								\
}

#define INIT_SEMAPHORE( sema ){					\
	sema.sBack = sema.sFront = NOT_PROCESS; 		\
	sema.sCount=1;						\
}

#undef ntohs
int CreateSocket( struct sockaddr_in *name )
{
        int sock;
        int length;

        sock = socket( AF_INET, SOCK_STREAM, 0 );
        if ( sock < 0 ){
                fprintf( stderr, "Cannot create socket for exec daemon, err %d\n", errno
 );
                return( -1 );
        }
        bzero((char *)name, sizeof(struct sockaddr_in));
        name->sin_family = AF_INET;
        name->sin_addr.s_addr = INADDR_ANY;
        name->sin_port = 0;
        if ( bind( sock, (struct sockaddr *)name, sizeof(struct sockaddr_in)) < 0 ){
                fprintf( stderr, "Cannot bind socket to port for exec daemon, err %d\n",
 errno );
                return( -1 );
        }
        length = sizeof(struct sockaddr_in);
        if ( getsockname( sock, (struct sockaddr *)name, &length) < 0 ){
                fprintf( stderr, "error getting socket name\n" );
                return(-1);
        }

        if ( listen(sock , QLEN ) < 0 ){
                fprintf( stderr, "Cannot listen to exec daemon port, err %d\n", errno );
                return( -1 );
        }
	return(sock);
}

int CreateExecDaemon()
{
	char ExecCmd[50];
	int length, sock;
	struct sockaddr_in name;

	sock = CreateSocket( &name );
        length = sizeof(name);
	sprintf( ExecCmd, "execd %d &\n", ntohs(name.sin_port));
	system( ExecCmd );
        ExecDaemon = accept( sock, (struct sockaddr *)&name, &length );
        if ( ExecDaemon < 0 )
                fprintf( stderr, "Could not connect to exec daemon\n" );
        return ( ExecDaemon );

}

_init_pvmd()
{
	int i, j;
	unsigned char *ptr;
	extern char *_get_param(int);

	CreateExecDaemon();
	INIT_SEMAPHORE( ServerSemaphore );
	_SemWait(&ServerSemaphore);
	INIT_SEMAPHORE( StdIOSemaphore );
	for ( i = 0; i < MAX_NODES; i++ )
		for ( j = 0; j < MAX_TASKS; j++ ){
			TaskRunning[i][j] = 0;
		}
	pvmd_info = (PVMD_PARAMETERS *)MEM_ALLOCATE(sizeof(PVMD_PARAMETERS));
	pvmd_info->NumNodes = *(char *)_get_param(1);
	ptr  = _get_param(3);
	pvmd_info->TclSocket = *ptr + (*(ptr+1) << 8 ) + (*(ptr+2) << 16 ) + (*(ptr+3) << 24 );	/* Parameters are not aligned on word boundary */
	ptr = (char *)_get_param(4);
	pvmd_info->NumTasksLoaded = (char *)MEM_ALLOCATE( pvmd_info->NumNodes * sizeof(char));
	for ( i = 0; i < pvmd_info->NumNodes; i++ )
		pvmd_info->NumTasksLoaded[i] = *ptr++;
	pvmd_info->Header = (char **)MEM_ALLOCATE( pvmd_info->NumNodes * sizeof(char *));
	pvmd_info->AckHeader = (char **)MEM_ALLOCATE( pvmd_info->NumNodes * sizeof(char *));
	pvmd_info->ServHeader = (char **)MEM_ALLOCATE(( pvmd_info->NumNodes * MAX_TASKS ) * sizeof(char *));
	pvmd_info->ServAckHeader = (char **)MEM_ALLOCATE(( pvmd_info->NumNodes * MAX_TASKS ) * sizeof(char *));
	ptr = (char *)_get_param(5);
	SET_HEADERS( pvmd_info->NumNodes, ptr, pvmd_info->Header );
	ptr = (char *)_get_param(6);
	SET_HEADERS( pvmd_info->NumNodes, ptr, pvmd_info->AckHeader );
	ptr = (char *)_get_param(7);
	SET_HEADERS( pvmd_info->NumNodes*MAX_TASKS, ptr, pvmd_info->ServHeader );
	ptr = (char *)_get_param(8);
	SET_HEADERS( pvmd_info->NumNodes*MAX_TASKS, ptr, pvmd_info->ServAckHeader );
}

SendMessage( StdIOStruct *StdIO )
{
	struct mesg *mp;
	mp = mesg_new(0);
	mp->m_cod = StdIO->cod;
	mp->m_dst = StdIO->dst;
	if ( StdIO->len < 1 ){
		pkint(mp, StdIO->tid);
		pkint(mp, 0);
		if ( mp->m_cod == DM_TASKOUT ){
			if (!(mp->m_dst & tidhmask) || (mp->m_dst & tidhmask) == myhostpart) 	/* to local */{
				mp->m_ref++;
				mesg_rewind(mp);
				dm_taskout(NULL, mp );
				mesg_unref(mp);
			}
			else 
				sendmessage(mp);
		}
		else
			sendmessage(mp);
	} else {
		pkint(mp, StdIO->tid);
		pkint(mp, StdIO->len);
		bytepk(mp, StdIO->buf, StdIO->len, 1, 1);
		if ( mp->m_cod == DM_TASKOUT ){
			if (!(mp->m_dst & tidhmask) || (mp->m_dst & tidhmask) == myhostpart) 	/* to local */{
				mp->m_ref++;
				mesg_rewind(mp);
				dm_taskout(NULL, mp );
				mesg_unref(mp);
			}
			else
				sendmessage(mp);
		}
		else
			sendmessage(mp);
	}
}


t9_loclstout(NodeId, TaskId, tp, buf, n)
	int NodeId, TaskId;
	struct task *tp;
	char *buf;
	int n;
{
	StdIOStruct *tempIO;
	int i;

	if (( n < 1)&&( !tp->t_outtid ))
		return 0;
	tempIO = (StdIOStruct *)MEM_ALLOCATE( sizeof(StdIOStruct));

	tempIO->tid = tp->t_tid;
	tempIO->len = n;
	if (n < 1) {
		if (tp->t_outtid) {
			tempIO->cod = tp->t_outcod;
			tempIO->dst = tp->t_outtid;
			tp->t_outtid = 0;
			_SemWait( &StdIOSemaphore );
			EnQueue( PendingStdIO, tempIO );
			_SemSignal( &StdIOSemaphore );
		}

	} else {
#if 0
		i = 0; while(( i < n )&&( buf[i] != '\0' )&&( buf[i] != '\n' )) i++;
		i += 3;
		tempIO->buf = malloc(i*sizeof(char));
		i = 0; while((i < n)&&( buf[i] != '\0' )&&( buf[i] != '\n' )){ tempIO->buf[i] = buf[i]; i++;}
		tempIO->buf[i++] = '\n'; tempIO->buf[i++] = '\0';
#else
		tempIO->buf = malloc((n+2)*sizeof(char));
		i = 0; while(i < n){ tempIO->buf[i] = buf[i]; i++;}
		if ( tempIO->buf[i-1] != '\n' )tempIO->buf[i++] = '\n';
		tempIO->buf[i++] = '\0';
#endif
		if (tp->t_outtid) {
			tempIO->cod = tp->t_outcod;
			tempIO->dst = tp->t_outtid;
		} else {
			tempIO->cod = DM_TASKOUT;
			tempIO->dst = hosts->ht_hosts[hosts->ht_cons]->hd_hostpart | TIDPVMD;
		}
		_SemWait( &StdIOSemaphore );
		EnQueue( PendingStdIO, tempIO );
		_SemSignal( &StdIOSemaphore );
	}
	return 0;
}

PerformLoclStOut()
{
	StdIOStruct *tempIO;

	while ( !QEmpty( PendingStdIO )){
		_SemWait( &StdIOSemaphore );
		DeQueue( PendingStdIO, tempIO );
		_SemSignal( &StdIOSemaphore );
		if ( tempIO != NULL ){
			SendMessage(tempIO );
			if ( tempIO->len > 0 )
				free( tempIO->buf );
			free( tempIO );
		}
	}
	_SemSignal( &ServerSemaphore );
	_SemWait( &ServerSemaphore );
}


#define MAX_COMMAND_LEN         1024
#define EXIT_COMMAND            0
#define EXECV_COMMAND           1
#define EXECVP_COMMAND          2


pvm_execv( char *path, char *argv[], int nenv, char **env, int ioport )
{
	static char ExecCmd[MAX_COMMAND_LEN];
	int i, num_args;
	char *ptr = (char *)&ioport;
	int pid;
	unsigned char len;

	ExecCmd[0] = EXECV_COMMAND;
	num_args = 0;
	while ( argv[num_args] != NULL )num_args++;
	ExecCmd[1] = num_args;
	ExecCmd[2] = nenv;
	for ( i = 0; i < 4; i++ )
		ExecCmd[i+3] = *ptr++;
	sprintf( &(ExecCmd[7]), "%s", path );
	len = strlen(path)+8; write( ExecDaemon, &len, 1 );
	write( ExecDaemon, ExecCmd, strlen(path)+8);
	for ( i = 0; i < num_args; i++ ){
		len = strlen(argv[i])+1; write( ExecDaemon, &len, 1 );
		write( ExecDaemon, argv[i], strlen(argv[i])+1);
	}
	for ( i = 0; i < nenv; i++ ){
		len = strlen(env[i])+1; write( ExecDaemon, &len, 1 );
		write( ExecDaemon, env[i], strlen(env[i])+1);
	}
	read( ExecDaemon, ExecCmd, 4 );
	ptr = &pid;
	for ( i = 0; i < 4; i++ )
		*ptr++ = ExecCmd[i];
	return(pid);
}


pvm_execvp( char *file, char *argv[], int nenv, char **env, int ioport )
{
	static char ExecCmd[MAX_COMMAND_LEN];
	int i, num_args;
	char *ptr = (char *)&ioport;
	int pid;

	ExecCmd[0] = EXECV_COMMAND;
	num_args = 0;
	while ( argv[num_args] != NULL )num_args++;
	ExecCmd[1] = num_args;
	ExecCmd[2] = nenv;
	for ( i = 0; i < 4; i++ )
		ExecCmd[i+3] = *ptr++;
	sprintf( &(ExecCmd[7]), "%s", file );
	write( ExecDaemon, ExecCmd, strlen(file)+8);
	for ( i = 0; i < num_args; i++ )
		write( ExecDaemon, argv[i], strlen(argv[i])+1);
	for ( i = 0; i < nenv; i++ ){
		write( ExecDaemon, env[i], strlen(env[i])+1);
	}
	read( ExecDaemon, ExecCmd, 4 );
	ptr = &pid;
	for ( i = 0; i < 4; i++ )
		*ptr++ = ExecCmd[i];
	return(pid);
}
