#include	<sys/transp.h>
#include	<sys/crt.h>

/*	Assembly routines to support suspending and resuming of
	processes and altering process priorities
*/

#define T9_WORKAROUND


.text
.globl	_ProcSleep

_ProcSleep:
	ldlp 	0
	ldpri
	or
	ldl	SYS_fnent_argptr
	ldnl	0
	stnl	0
	stopp
	ret


.globl _ProcAwaken

_ProcAwaken:
	ldl	SYS_fnent_argptr		
	ldnl	0
#ifdef T9_WORKAROUND
	nop
	nop
#endif
	runp
	ret

.globl _ProcGetPri

_ProcGetPri:
	ldpri
	ldl	SYS_fnent_argptr
	ldnl	0
	stnl	0
	ret

.globl	_ProcToLow

_ProcToLow:
	ldlp	0
	ldc	1
	or
#ifdef T9_WORKAROUND
	nop
	nop
#endif
	runp
	stopp
	ret

.globl	_ProcToHigh

_ProcToHigh:
	ldc	.L3-.L1
	.align	4
	ldpi
.L1:
	stl 	-1
	ldth
	stl	-3
	ldlp	0
	ldc	-1
	and
#ifdef T9_WORKAROUND
	nop
	nop
#endif
	runp
	ldc	.L3-.L2
	ldpi
.L2:
	gajw
	stopp
	.align	4
	.word	0x20202020
	.word 	0x20202020
	.word 	0x20202020
	.word 	0x20202020
	.word 	0x20202020
.L3:
	ret

	.globl __VChanIn
__VChanIn :
	ldl     SYS_fnent_argptr
	ldnl    1
	ldl     SYS_fnent_argptr
	ldnl    0
	ldl     SYS_fnent_argptr
	ldnl    2
#ifdef T9_WORKAROUND
	nop
	nop
#endif
	vin
	ldcnt
	ret

	.globl __VChanOut
__VChanOut :
	ldl     SYS_fnent_argptr
	ldnl    1
	ldl     SYS_fnent_argptr
	ldnl    0
	ldl     SYS_fnent_argptr
	ldnl    2
#ifdef T9_WORKAROUND
	nop
	nop
#endif
	vout
	ret



.globl _ThreadRun

_ThreadRun:
	ldl	SYS_fnent_argptr
	ldnl	1
	ldc	.L101-.L100
	ldpi
.L100:
	diff
	ldl	SYS_fnent_argptr
	ldnl	0
#ifdef T9_WORKAROUND
	nop
	nop
#endif
	startp
.L101:
	ret

.globl _StopThread
_StopThread:
	stopp
	ret


.globl _Get_MDL
_Get_MDL:
	ldl	1
	ldl	SYS_fnent_argptr
	ldnl	0
	stnl	0
	ret
	


.globl __SemWait
__SemWait:
	ldl     SYS_fnent_argptr
	ldnl    0
	wait
	ret


.globl __SemSignal
__SemSignal:
	ldl     SYS_fnent_argptr
	ldnl    0
#ifdef T9_WORKAROUND
	nop
	nop
#endif
	signal
	ret

.globl _ThreadStop
_ThreadStop:
	stopp
	ret

.globl _ReadTime

_ReadTime:
	ldtimer
	ret

.globl _ResetChannel
_ResetChannel:
	ldl     SYS_fnent_argptr
	ldnl    0
	resetch
	ret


.globl _StopChannel
_StopChannel:
	ldl     SYS_fnent_argptr
	ldnl    0
	stopch
	ret


.globl _GetTHDS
_GetTHDS:
	ldth
	ret

