#
# $Id: procs.tcl,v 2.310 1994/07/18 18:18:33 kohl Exp $
#

#
# XPVM TCL Procs
#

proc canvas_handle { view action x y } \
{
	#debug_proc canvas_handle entry

	global st_canvas_height
	global ut_canvas_height
	global st_labels_width
	global border_space
	global frame_border
	global st_label_ht
	global scale_stack
	global timeid_prim
	global main_width
	global st_cheight
	global st_cwidth
	global ut_cwidth
	global st_timeid
	global ut_timeid
	global task_list
	global fg_color
	global zoom_x1
	global zoom_x2
	global zoomid
	global ntask
	global scale

	set ST .xpvm.space_time

	if { $view == "ST" } \
	{
		global st_xview
		global st_yview

		set canvx [ expr $x + $st_xview ]
		set canvy [ expr $y + $st_yview ]

		set PRIM_C $ST.canvas

		set ALT_C .utilization.frame.canvas

		set prim_height $st_canvas_height
		set alt_height $ut_canvas_height

		set prim_timeid $st_timeid
		set alt_timeid $ut_timeid

		set timeid_prim "ST"

		set prim_cwidth $st_cwidth
	} \

	elseif { $view == "UT" } \
	{
		global ut_xview

		set canvx [ expr $x + $ut_xview ]
		set canvy $y

		set PRIM_C .utilization.frame.canvas

		set ALT_C $ST.canvas

		set prim_height $ut_canvas_height
		set alt_height $st_canvas_height

		set prim_timeid $ut_timeid
		set alt_timeid $st_timeid

		set timeid_prim "UT"

		set prim_cwidth $ut_cwidth
	}

	if { $action == "query_press" } \
	{
		if { $prim_timeid != -1 } \
		{
			$PRIM_C delete $prim_timeid

			set prim_timeid -1
		}

		if { $alt_timeid != -1 } \
		{
			$ALT_C delete $alt_timeid

			set alt_timeid -1
		}

		set_query_time -1

		set id [ $ST.canvas find closest $canvx $canvy ]

		set tindex1 [ expr ( $canvy - ($st_label_ht / 2) \
				- $border_space ) \
			/ $st_label_ht ]

		if { $tindex1 < 0 } \
			{ set tindex1 0 }

		set tindex2 [ expr ( $canvy + ($st_label_ht / 2) \
				- $border_space ) \
			/ $st_label_ht ]

		if { $tindex2 >= $ntask } \
			{ set tindex2 [ expr $ntask - 1 ] }

		st_query_info $id $tindex1 $tindex2
	} \

	elseif { $action == "query_motion" } \
	{
		if { $x >= 0 && $x < $st_cwidth \
			&& $y >= 0 && $y < $st_cheight } \
		{
			set id [ $ST.canvas find closest $canvx $canvy ]

			set tindex1 [ expr ( $canvy - ($st_label_ht / 2) \
				- $border_space ) / $st_label_ht ]

			if { $tindex1 < 0 } \
				{ set tindex1 0 }

			set tindex2 [ expr ( $canvy + ($st_label_ht / 2) \
				- $border_space ) / $st_label_ht ]

			if { $tindex2 >= $ntask } \
				{ set tindex2 [ expr $ntask - 1 ] }

			st_query_info $id $tindex1 $tindex2
		} \

		else \
		{
			st_query_info -1 -1 -1
		}
	} \

	elseif { $action == "query_release" } \
	{
		st_query_info -1 -1 -1

		set prim_timeid [ $PRIM_C create line \
			$canvx 0 $canvx $prim_height -fill blue ]

		set alt_timeid [ $ALT_C create line \
			$canvx 0 $canvx $alt_height -fill blue ]

		set_query_time $canvx
	} \

	elseif { $action == "enter" } \
	{
		set prim_timeid [ $PRIM_C create line \
			$canvx 0 $canvx $prim_height -fill blue ]

		set alt_timeid [ $ALT_C create line \
			$canvx 0 $canvx $alt_height -fill blue ]

		set_query_time $canvx
	} \

	elseif { $action == "time" } \
	{
		if { $prim_timeid != -1 } \
		{
			$PRIM_C coords $prim_timeid $canvx 0 $canvx $prim_height
			$PRIM_C raise $prim_timeid
		} \

		else \
		{
			set prim_timeid [ $PRIM_C create line \
				$canvx 0 $canvx $prim_height -fill blue ]
		}

		if { $alt_timeid != -1 } \
		{
			$ALT_C coords $alt_timeid $canvx 0 $canvx $alt_height
			$ALT_C raise $alt_timeid
		} \

		else \
		{
			set alt_timeid [ $ALT_C create line \
				$canvx 0 $canvx $alt_height -fill blue ]
		}

		set_query_time $canvx
	} \

	elseif { $action == "leave" } \
	{
		if { $prim_timeid != -1 } \
		{
			$PRIM_C delete $prim_timeid

			set prim_timeid -1
		}

		if { $alt_timeid != -1 } \
		{
			$ALT_C delete $alt_timeid

			set alt_timeid -1
		}

		set_query_time -1
	} \

	elseif { $action == "zoom_press" } \
	{
		set zoom_x1 $canvx
		set zoom_x2 $canvx

		set zoomid [ $PRIM_C create rectangle \
			$canvx 0 $canvx $prim_height -outline blue ]
	} \

	elseif { $action == "zoom_motion" } \
	{
		set zoom_x2 $canvx

		if { $zoom_x1 < $zoom_x2 } \
		{
			set x1 $zoom_x1
			set x2 $zoom_x2
		} \

		else \
		{
			set x1 $zoom_x2
			set x2 $zoom_x1
		}

		$PRIM_C coords $zoomid $x1 0 $x2 $prim_height
	} \

	elseif { $action == "zoom_release" } \
	{
		$PRIM_C delete $zoomid

		setMsg "Zooming..."

		set zoom_x2 $canvx

		if { $zoom_x1 != $zoom_x2 } \
		{
			if { $zoom_x1 < $zoom_x2 } \
			{
				set x1 $zoom_x1
				set x2 $zoom_x2
			} \

			else \
			{
				set x1 $zoom_x2
				set x2 $zoom_x1
			}

			set t1 [ expr $x1 * $scale ]
			set t2 [ expr $x2 * $scale ]

			set new_scale [ expr ( $t2 - $t1 ) / $prim_cwidth ]

			zoomScrollingViews $new_scale $t1 $view

			set scale_stack [ linsert $scale_stack 0 $scale ]

			set scale $new_scale

			if { $view == "ST" } \
				{ set newx [ expr $x + $st_xview ] } \

			elseif { $view == "UT" } \
				{ set newx [ expr $x + $ut_xview ] }

			$PRIM_C coords $prim_timeid $newx 0 $newx $prim_height
			$PRIM_C raise $prim_timeid

			$ALT_C coords $alt_timeid $newx 0 $newx $alt_height
			$ALT_C raise $alt_timeid

			set_query_time $newx

			setMsg "Zooming Done."
		} \

		else \
		{
			setMsg "Error - Infinite Zoom"
		}
	} \

	elseif { $action == "unzoom" } \
	{
		setMsg "Unzooming..."

		set new_scale [ lindex $scale_stack 0 ]

		if { $new_scale != "empty" } \
		{
			set scale_stack [ lreplace $scale_stack 0 0 ]
		} \

		else \
		{
			set new_scale [ expr 2 * $scale ]
		}

		set start_time [ expr ( $canvx * $scale ) \
			- ( $prim_cwidth * $new_scale / 2 ) ]

		if { $start_time < 0 } \
			{ set start_time 0 }

		zoomScrollingViews $new_scale $start_time $view

		set scale $new_scale

		if { $view == "ST" } \
			{ set newx [ expr $x + $st_xview ] } \

		elseif { $view == "UT" } \
			{ set newx [ expr $x + $ut_xview ] }

		$PRIM_C coords $prim_timeid $newx 0 $newx $prim_height
		$PRIM_C raise $prim_timeid

		$ALT_C coords $alt_timeid $newx 0 $newx $alt_height
		$ALT_C raise $alt_timeid

		set_query_time $newx

		setMsg "Unzooming Done."
	} \

	elseif { $action == "label_press" } \
	{
		set tindex [ expr ( $canvy - $border_space ) / $st_label_ht ]

		if { $tindex >= 0 && $tindex < $ntask } \
		{
			set t $task_list($tindex)

			set host [ lindex [ lindex $t 0 ] 0 ]

			set task [ lindex $t 1 ]
			set tid [ lindex $t 2 ]

			set str "$host:$task TID=$tid"

			label .xpvm.st_label_query -text $str \
				-bd 2 -relief raised -foreground $fg_color

			set lx [ expr [winfo x $ST.labels] + [winfo x $ST] \
				+ $border_space - $frame_border ]

			set ly [ expr [winfo y $ST.labels] + [winfo y $ST] \
				+ ( $tindex * $st_label_ht ) + $border_space ]

			place .xpvm.st_label_query -x $lx -y $ly -anchor nw
		}
	} \

	elseif { $action == "label_motion" } \
	{
		set tindex [ expr ( $canvy - $border_space ) / $st_label_ht ]

		if { $tindex >= 0 && $tindex < $ntask \
			&& $x >= 0 && $x < $st_labels_width } \
		{
			set t $task_list($tindex)

			set host [ lindex [ lindex $t 0 ] 0 ]

			set task [ lindex $t 1 ]
			set tid [ lindex $t 2 ]

			set str "$host:$task TID=$tid"

			set upck [ winfo exists .xpvm.st_label_query ]

			if { $upck == 1 } \
				{ .xpvm.st_label_query configure -text $str } \

			else \
			{
				label .xpvm.st_label_query -text $str \
					-bd 2 -relief raised -foreground $fg_color
			}

			set lx [ expr [winfo x $ST.labels] + [winfo x $ST] \
				+ $border_space - $frame_border ]

			set ly [ expr [winfo y $ST.labels] + [winfo y $ST] \
				+ ( $tindex * $st_label_ht ) + $border_space ]

			place .xpvm.st_label_query -x $lx -y $ly -anchor nw
		} \

		else \
		{
			set upck [ winfo exists .xpvm.st_label_query ]

			if { $upck == 1 } \
				{ destroy .xpvm.st_label_query }
		}
	} \

	elseif { $action == "label_release" } \
	{
		set upck [ winfo exists .xpvm.st_label_query ]

		if { $upck == 1 } \
			{ destroy .xpvm.st_label_query }
	}

	if { $view == "ST" } \
	{
		set st_timeid $prim_timeid
		set ut_timeid $alt_timeid
	} \

	elseif { $view == "UT" } \
	{
		set ut_timeid $prim_timeid
		set st_timeid $alt_timeid
	}

	#debug_proc canvas_handle exit
}

proc set_query_time { x } \
{
	#debug_proc set_query_time entry

	global timeidx
	global scale

	set ST .xpvm.space_time

	if { $x != -1 } \
	{
		set qt [ expr $x * $scale ]

		set qts [ expr $qt / 1000000 ]

		set qtus [ expr $qt - ( $qts * 1000000 ) ]

		set pqtus [ pad $qtus 6 ]

		set qtstr "Query Time: $qts.$pqtus"
	} \

	else \
	{
		set qtstr ""
	}

	$ST.query configure -text "View Info:   $qtstr"

	set timeidx $x

	#debug_proc set_query_time exit
}

proc st_query_info { id tindex1 tindex2 } \
{
	#debug_proc st_query_info entry

	global st_highlight_type
	global st_highlight_id
	global task_list
	global comm_list
	global ntask
	global ncomm

	set ST .xpvm.space_time

	#
	# Un-Highlight Last Query
	#

	if { $st_highlight_id != -1 } \
	{
		if { $st_highlight_type == "state" } \
		{
			$ST.canvas itemconfigure $st_highlight_id -width 1
		} \

		elseif { $st_highlight_type == "comm" } \
		{
			$ST.canvas itemconfigure $st_highlight_id \
				-arrow none -width 1
		}

		set st_highlight_type ""

		set st_highlight_id -1
	}

	#
	# Just return if release
	#

	if { $id == -1 } \
	{
		$ST.query configure -text "View Info:"

		return
	}

	#
	# Search for Query Item & Dump Info String
	#

	for { set i $tindex1 } { $i <= $tindex2 } { set i [expr $i + 1] } \
	{
		set t $task_list($i)

		set s [ lindex $t 4 ]

		foreach state $s \
		{
			set rectid [ lindex $state 0 ]

			if { $rectid == $id } \
			{
				#
				# Highlight State Rectangle
				#

				$ST.canvas itemconfigure $id -width 3

				set st_highlight_type "state"

				set st_highlight_id $id

				#
				# Construct Info Message
				#

				set tid [ lindex $t 2 ]

				set taskstr "TID=$tid"

				set ssec	[ lindex $state 2 ]
				set susec	[ lindex $state 3 ]
				set esec	[ lindex $state 4 ]
				set eusec	[ lindex $state 5 ]

				set psusec [ pad $susec 6 ]
				set peusec [ pad $eusec 6 ]

				set timestr "<$ssec.$psusec - $esec.$peusec>"

				set callstr [ lindex $state 6 ]

				$ST.query configure \
					-text "View Info:   $taskstr: $callstr $timestr"

				return
			}
		}
	}

	for { set i 0 } { $i < $ncomm } { set i [ expr $i + 1 ] } \
	{
		set c $comm_list($i)

		set lineid [ lindex $c 8 ]

		if { $lineid == $id } \
		{
			#
			# Highlight Comm Line
			#

			$ST.canvas itemconfigure $id -arrow last -width 3

			set st_highlight_type "comm"

			set st_highlight_id $id

			#
			# Construct Info Message
			#

			set src [ lindex $c 0 ]
			set dst [ lindex $c 1 ]

			set nbytes [ lindex $c 2 ]
			set msgtag [ lindex $c 3 ]

			set ssec	[ lindex $c 4 ]
			set susec	[ lindex $c 5 ]
			set dsec	[ lindex $c 6 ]
			set dusec	[ lindex $c 7 ]

			set taskstr "from $src to $dst"

			set timestr "$ssec.$susec to $dsec.$dusec"

			set infostr "code=$msgtag nbytes=$nbytes"

			set msgstr "Message: $taskstr, $timestr, $infostr"

			$ST.query configure -text "View Info:   $msgstr"

			return
		}
	}

	$ST.query configure -text "View Info:"

	#debug_proc st_query_info exit
}

proc zoomScrollingViews { new_scale start_time view } \
{
	#debug_proc zoomScrollingViews entry

	global st_canvas_height
	global st_scroll_mark
	global ut_scroll_mark
	global frame_border
	global st_timeline
	global comm_list
	global st_cwidth
	global ut_cwidth
	global task_list
	global ut_state
	global st_xview
	global ut_xview
	global st_usec
	global st_sec
	global ncomm
	global ntask
	global timex

	set ST_C .xpvm.space_time.canvas

	set ST_SBH .xpvm.space_time.horiz_sb

	set UT_C .utilization.frame.canvas

	set UT_SBH .utilization.frame.horiz_sb

	#
	# Re-Position Space-Time State Rectangles
	#

	for { set i 0 } { $i < $ntask } { set i [ expr $i + 1 ] } \
	{
		set t $task_list($i)

		set s [ lindex $t 4 ]

		foreach state $s \
		{
			set rectid [ lindex $state 0 ]

			set ssec	[ lindex $state 2 ]
			set susec	[ lindex $state 3 ]
			set esec	[ lindex $state 4 ]
			set eusec	[ lindex $state 5 ]

			set x1 [ x_of_time $ssec $susec $new_scale ]
			set x2 [ x_of_time $esec $eusec $new_scale ]

			set_x_coords $ST_C $rectid $x1 $x2
		}
	}

	#
	# Re-Position Space-Time Comm Lines
	#

	for { set i 0 } { $i < $ncomm } { set i [ expr $i + 1 ] } \
	{
		set c $comm_list($i)

		set ssec	[ lindex $c 4 ]
		set susec	[ lindex $c 5 ]
		set dsec	[ lindex $c 6 ]
		set dusec	[ lindex $c 7 ]

		set x1 [ x_of_time $ssec $susec $new_scale ]
		set x2 [ x_of_time $dsec $dusec $new_scale ]

		set lineid [ lindex $c 8 ]

		set_x_coords $ST_C $lineid $x1 $x2
	}

	#
	# Re-Position Utilization Rectangles
	#

	foreach state $ut_state \
	{
		if { "$state" != "none" } \
		{
			set valid [ lindex $state 10 ]

			if { $valid == 1 } \
			{
				set ssec	[ lindex $state 0 ]
				set susec	[ lindex $state 1 ]
				set esec	[ lindex $state 2 ]
				set eusec	[ lindex $state 3 ]

				set x1 [ x_of_time $ssec $susec $new_scale ]
				set x2 [ x_of_time $esec $eusec $new_scale ]

				set rrectid [ lindex $state 7 ]

				if { $rrectid != -1 } \
					{ set_x_coords $UT_C $rrectid $x1 $x2 }

				set srectid [ lindex $state 8 ]

				if { $srectid != -1 } \
					{ set_x_coords $UT_C $srectid $x1 $x2 }

				set irectid [ lindex $state 9 ]

				if { $irectid != -1 } \
					{ set_x_coords $UT_C $irectid $x1 $x2 }
			}
		}
	}

	#
	# Adjust View Parameters
	#

	set timex [ x_of_time $st_sec $st_usec $new_scale ]

	if { $st_scroll_mark != 0 } \
	{
		set st_scroll_mark [ expr $timex - $st_cwidth \
			+ (2 * $frame_border) ]

		if { $st_scroll_mark < 0 } \
			{ set st_scroll_mark 0 }
	}

	if { $ut_scroll_mark != 0 } \
	{
		set ut_scroll_mark [ expr $timex - $ut_cwidth \
			+ (2 * $frame_border) ]

		if { $ut_scroll_mark < 0 } \
			{ set ut_scroll_mark 0 }
	}

	#
	# Re-Position Space-Time Time Line
	#

	$ST_C coords $st_timeline $timex 0 $timex $st_canvas_height

	#
	# Align Canvases to Proper Starting Time
	#

	set x1 [ expr $start_time / $new_scale ]

	if { $view == "ST" } \
	{
		set maxvalue [ expr $timex - $st_cwidth + (2 * $frame_border) ]

		if { $maxvalue > 0 } \
		{
			if { $x1 > $maxvalue } \
				{ set x1 $maxvalue } \

			elseif { $x1 < 0 } \
				{ set x1 0 }
		} \

		else \
			{ set x1 0 }

		$ST_C xview $x1

		set st_xview $x1

		scrollSet $ST_SBH $timex $st_cwidth $x1

		#
		# Align Other View's Canvas
		#

		if { $timex != $st_cwidth } \
		{
			set utx1 [ expr $x1 \
				- ( $x1 * ( $ut_cwidth - $st_cwidth ) \
					/ ( $timex - $st_cwidth ) ) ]
		} \

		else \
		{
			set utx1 [ expr $x1 \
				- ( $x1 * ( $ut_cwidth - $st_cwidth ) ) ]
		}

		$UT_C xview $utx1

		set ut_xview $utx1

		scrollSet $UT_SBH $timex $ut_cwidth $utx1
	} \

	elseif { $view == "UT" } \
	{
		set maxvalue [ expr $timex - $ut_cwidth + (2 * $frame_border) ]

		if { $maxvalue > 0 } \
		{
			if { $x1 > $maxvalue } \
				{ set x1 $maxvalue } \

			elseif { $x1 < 0 } \
				{ set x1 0 }
		} \

		else \
			{ set x1 0 }

		$UT_C xview $x1

		set ut_xview $x1

		scrollSet $UT_SBH $timex $ut_cwidth $x1

		#
		# Align Other View's Canvas
		#

		if { $timex != $ut_cwidth } \
		{
			set stx1 [ expr $x1 \
				+ ( $x1 * ( $ut_cwidth - $st_cwidth) \
					/ ( $timex - $ut_cwidth ) ) ]
		} \

		else \
		{
			set stx1 [ expr $x1 \
				+ ( $x1 * ( $ut_cwidth - $st_cwidth ) ) ]
		}

		$ST_C xview $stx1

		set st_xview $stx1

		scrollSet $ST_SBH $timex $st_cwidth $stx1
	}

	#debug_proc zoomScrollingViews exit
}

proc network { x y } \
{
	#debug_proc network entry

	global net_scroll
	global net_xview
	global net_yview
	global host_list
	global net_size
	global nhost

	set ns2 [ expr $net_size / 2 ]

	set canvx [ expr $x + ( $net_xview * $net_scroll ) - $ns2 ]
	set canvy [ expr $y + ( $net_yview * $net_scroll ) - $ns2 ]

	set NET_C .xpvm.network.canvas

	set found 0

	for { set i 0 } { ( $i < $nhost ) && ( $found == 0 ) } \
		{ set i [ expr $i + 1 ] } \
	{
		set h $host_list($i)

		set state [ lindex $h 4 ]

		if { $state == "ON" } \
		{
			set boxid [ lindex $h 11 ]

			set coords [ $NET_C coords $boxid ]

			set x1 [ lindex $coords 0 ]
			set y1 [ lindex $coords 1 ]
			set x2 [ lindex $coords 2 ]
			set y2 [ lindex $coords 3 ]

			if { ( $canvx >= $x1 ) && ( $canvx <= $x2 ) \
				&& ( $canvy >= $y1 ) && ( $canvy <= $y2 ) } \
			{
				set host [ lindex $h 0 ]

				# puts "Host $host found"

				set found 1
			}
		}
	}

	#debug_proc network exit
}

proc ct_canvas_handle { action x y } \
{
	#debug_proc ct_canvas_handle entry

	global ct_labels_width
	global ct_query_index
	global border_space
	global frame_border
	global st_label_ht
	global task_list
	global fg_color
	global ntask

	set CT_L .call_trace.frame.labels

	set CT_C .call_trace.frame.canvas

	if { $action == "query_press" } \
	{
		set tindex [ expr ( $y - $border_space ) / $st_label_ht ]

		if { $tindex >= 0 && $tindex < $ntask } \
		{
			set t $task_list($tindex)

			set s [ lindex $t 4 ]

			set state [ lindex $s 0 ]

			set sec [ lindex $state 2 ]
			set usec [ lindex $state 3 ]

			set str "Time Stamp: $sec.[ pad $usec 6 ]"

			.call_trace.frame.query configure -text $str

			set ct_query_index $tindex
		}
	} \

	elseif { $action == "query_motion" } \
	{
		set tindex [ expr ( $y - $border_space ) / $st_label_ht ]

		if { $tindex >= 0 && $tindex < $ntask \
			&& $x >= 0 && $x < $ct_labels_width } \
		{
			set t $task_list($tindex)

			set s [ lindex $t 4 ]

			set state [ lindex $s 0 ]

			set sec [ lindex $state 2 ]
			set usec [ lindex $state 3 ]

			set str "Time Stamp: $sec.[ pad $usec 6 ]"

			.call_trace.frame.query configure -text $str

			set ct_query_index $tindex
		} \

		else \
		{
			.call_trace.frame.query configure -text ""

			set ct_query_index -1
		}
	} \

	elseif { $action == "query_release" } \
	{
		.call_trace.frame.query configure -text ""

		set ct_query_index -1
	} \

	elseif { $action == "label_press" } \
	{
		set tindex [ expr ( $y - $border_space ) / $st_label_ht ]

		if { $tindex >= 0 && $tindex < $ntask } \
		{
			set t $task_list($tindex)

			set host [ lindex [ lindex $t 0 ] 0 ]

			set task [ lindex $t 1 ]
			set tid [ lindex $t 2 ]

			set str "$host:$task TID=$tid"

			label .call_trace.label_query -text $str \
				-bd 2 -relief raised -foreground $fg_color

			set lx [ expr [ winfo x $CT_L ] \
				+ $border_space - $frame_border ]

			set ly [ expr [ winfo y $CT_L ] \
				+ ( $tindex * $st_label_ht ) + $border_space ]

			place .call_trace.label_query -x $lx -y $ly -anchor nw
		}
	} \

	elseif { $action == "label_motion" } \
	{
		set tindex [ expr ( $y - $border_space ) / $st_label_ht ]

		if { $tindex >= 0 && $tindex < $ntask \
			&& $x >= 0 && $x < $ct_labels_width } \
		{
			set t $task_list($tindex)

			set host [ lindex [ lindex $t 0 ] 0 ]

			set task [ lindex $t 1 ]
			set tid [ lindex $t 2 ]

			set str "$host:$task TID=$tid"

			set upck [ winfo exists .call_trace.label_query ]

			if { $upck == 1 } \
				{ .call_trace.label_query configure -text $str } \

			else \
			{
				label .call_trace.label_query -text $str \
					-bd 2 -relief raised -foreground $fg_color
			}

			set lx [ expr [ winfo x $CT_L ] \
				+ $border_space - $frame_border ]

			set ly [ expr [ winfo y $CT_L ] \
				+ ( $tindex * $st_label_ht ) + $border_space ]

			place .call_trace.label_query -x $lx -y $ly -anchor nw
		} \

		else \
		{
			set upck [ winfo exists .call_trace.label_query ]

			if { $upck == 1 } \
				{ destroy .call_trace.label_query }
		}
	} \

	elseif { $action == "label_release" } \
	{
		set upck [ winfo exists .call_trace.label_query ]

		if { $upck == 1 } \
			{ destroy .call_trace.label_query }
	}

	#debug_proc ct_canvas_handle exit
}

proc updateCallTrace { } \
{
	#debug_proc updateCallTrace entry

	global task_list
	global ntask

	set CT_C .call_trace.frame.canvas

	for { set i 0 } { $i < $ntask } { set i [ expr $i + 1 ] } \
	{
		set t $task_list($i)

		set active [ lindex $t 6 ]

		if { $active == 1 } \
		{
			set s [ lindex $t 4 ]

			set state [ lindex $s 0 ]

			set callstr [ lindex $state 6 ]
		} \

		else \
			{ set callstr "(Task Exited)" }

		set ct_callstrid [ lindex $t 8 ]

		$CT_C itemconfigure $ct_callstrid -text "$callstr"
	}

	#debug_proc updateCallTrace exit
}

proc updateUtilization { old new sec usec } \
{
	#debug_proc updateUtilization entry

	global ut_running_color
	global ut_system_color
	global ut_idle_color
	global ut_cheight
	global ut_active
	global ut_timeid
	global ut_state
	global scale
	global timex

	set UT_C .utilization.frame.canvas

	set HT $ut_cheight

	set state [ lindex $ut_state 0 ]

	if { $ut_active == "FALSE" } \
	{
		if { "$state" != "none" } \
		{
			#
			# Generate Count Deltas
			#

			set rdelta 0
			set sdelta 0
			set idelta 0

			if { $old == "running" } \
				{ set rdelta [ expr $rdelta - 1 ] } \
			elseif { $old == "pvm_call" } \
				{ set sdelta [ expr $sdelta - 1 ] } \
			elseif { $old == "idle" } \
				{ set idelta [ expr $idelta - 1 ] }

			if { $new == "running" } \
				{ set rdelta [ expr $rdelta + 1 ] } \
			elseif { $new == "pvm_call" } \
				{ set sdelta [ expr $sdelta + 1 ] } \
			elseif { $new == "idle" } \
				{ set idelta [ expr $idelta + 1 ] }

			#
			# Adjust State Counts
			#

			set rcnt [ lindex $state 4 ]
			set scnt [ lindex $state 5 ]
			set icnt [ lindex $state 6 ]

			set rcnt [ expr $rcnt + $rdelta ]
			set scnt [ expr $scnt + $sdelta ]
			set icnt [ expr $icnt + $idelta ]

			set state [ lreplace $state 4 6 $rcnt $scnt $icnt ]

			set ut_state [ lreplace $ut_state 0 0 $state ]
		} \

		else \
		{
			#
			# Create First State
			#

			set state [ list 0 0 0 0 1 0 0 -1 -1 -1 0 ]

			set ut_state [ linsert $ut_state 0 $state ]
		}
	} \

	else \
	{
		set tx [ x_of_time $sec $usec $scale ]

		if { "$state" == "none" } \
		{
			#
			# Create First State
			#

			set rrectid [ $UT_C create rectangle \
				$tx 0 $timex $HT -fill $ut_running_color -outline "" ]

			set state [ list $sec $usec $sec $usec 1 0 0 \
				$rrectid -1 -1 1 ]

			set ut_state [ linsert $ut_state 0 $state ]
		} \

		else \
		{
			#
			# Generate Count Deltas
			#

			set rdelta 0
			set sdelta 0
			set idelta 0

			if { $old == "running" } \
				{ set rdelta [ expr $rdelta - 1 ] } \
			elseif { $old == "pvm_call" } \
				{ set sdelta [ expr $sdelta - 1 ] } \
			elseif { $old == "idle" } \
				{ set idelta [ expr $idelta - 1 ] }

			if { $new == "running" } \
				{ set rdelta [ expr $rdelta + 1 ] } \
			elseif { $new == "pvm_call" } \
				{ set sdelta [ expr $sdelta + 1 ] } \
			elseif { $new == "idle" } \
				{ set idelta [ expr $idelta + 1 ] }

			#
			# Process States
			#

			set index 0

			foreach state $ut_state \
			{
				set ssec	[ lindex $state 0 ]
				set susec	[ lindex $state 1 ]
				set esec	[ lindex $state 2 ]
				set eusec	[ lindex $state 3 ]

				set valid [ lindex $state 10 ]

				#
				# Split State in Two / Add New State
				#

				set cmps [ timeCompare $sec $usec $ssec $susec ]
				set cmpe [ timeCompare $sec $usec $esec $eusec ]
				set cmpE [ timeCompare $ssec $susec $esec $eusec ]

				if { $cmpe == 1 || \
					( ( $cmps == 1 || $cmps == 0 ) \
						&& ( $cmpe == -1 || $cmpe == 0 ) \
						&& $cmpE != 0 ) } \
				{
					if { $valid == 0 } \
					{
						set rcnt [ lindex $state 4 ]
						set scnt [ lindex $state 5 ]
						set icnt [ lindex $state 6 ]

						set rcnt [ expr $rcnt + $rdelta ]
						set scnt [ expr $scnt + $sdelta ]
						set icnt [ expr $icnt + $idelta ]

						set state [ lreplace $state 4 6 \
							$rcnt $scnt $icnt ]

						set ut_state [ lreplace $ut_state \
							$index $index $state ]

						return
					}

					#
					# Adjust End of Old State
					#

					set rrectid	[ lindex $state 7 ]

					if { $rrectid != -1 } \
						{ set_x_coords $UT_C $rrectid -1 $tx }

					set srectid	[ lindex $state 8 ]

					if { $srectid != -1 } \
						{ set_x_coords $UT_C $srectid -1 $tx }

					set irectid	[ lindex $state 9 ]

					if { $irectid != -1 } \
						{ set_x_coords $UT_C $irectid -1 $tx }

					set state [ lreplace $state 2 3 $sec $usec ]

					#
					# Create New State
					#

					set rcnt [ lindex $state 4 ]
					set scnt [ lindex $state 5 ]
					set icnt [ lindex $state 6 ]

					set rcnt [ expr $rcnt + $rdelta ]
					set scnt [ expr $scnt + $sdelta ]
					set icnt [ expr $icnt + $idelta ]

					set c [ calcUtilCoords $rcnt $scnt $icnt ]

					set iy [ lindex $c 0 ]
					set sy [ lindex $c 1 ]
					set ry [ lindex $c 2 ]

					if { $cmpe > 0 } \
						{ set x2 $tx } \

					else \
						{ set x2 [ x_of_time $esec $eusec $scale ] }

					#
					# New Running Rectangle
					#

					if { $ry != $HT } \
					{
						set rrectid [ $UT_C create rectangle \
							$tx $ry $x2 $HT \
							-fill $ut_running_color -outline "" ]
					} \

					else \
						{ set rrectid -1 }

					#
					# New System Rectangle
					#

					if { $sy != $ry } \
					{
						set srectid [ $UT_C create rectangle \
							$tx $sy $x2 $ry \
							-fill $ut_system_color -outline "" ]
					} \

					else \
						{ set srectid -1 }

					#
					# New Idle Rectangle
					#

					if { $iy != $sy } \
					{
						set irectid [ $UT_C create rectangle \
							$tx $iy $x2 $sy \
							-fill $ut_idle_color -outline "" ]
					} \

					else \
						{ set irectid -1 }

					#
					# New State
					#

					if { $cmpe > 0 } \
					{
						set new_state [ list $sec $usec $sec $usec \
							$rcnt $scnt $icnt \
							$rrectid $srectid $irectid 1 ]
					} \

					else \
					{
						set new_state [ list $sec $usec $esec $eusec \
							$rcnt $scnt $icnt \
							$rrectid $srectid $irectid 1 ]
					}

					set ut_state [ lreplace $ut_state $index $index \
						$new_state $state ]

					return
				} \

				else \
				{
					#
					# Update State Counts / Rects
					#

					set rcnt [ lindex $state 4 ]
					set scnt [ lindex $state 5 ]
					set icnt [ lindex $state 6 ]

					set rcnt [ expr $rcnt + $rdelta ]
					set scnt [ expr $scnt + $sdelta ]
					set icnt [ expr $icnt + $idelta ]

					if { $valid == 1 } \
					{
						set c [ calcUtilCoords $rcnt $scnt $icnt ]

						set iy [ lindex $c 0 ]
						set sy [ lindex $c 1 ]
						set ry [ lindex $c 2 ]

						set x1 [ x_of_time $ssec $susec $scale ]
						set x2 [ x_of_time $esec $eusec $scale ]

						#
						# Check Running Rectangle
						#

						set rrectid	[ lindex $state 7 ]

						if { $rrectid != -1 } \
						{
							if { $ry != $HT } \
							{
								set_y_coords $UT_C $rrectid $ry $HT
							} \

							else \
							{
								$UT_C delete $rrectid

								set rrectid -1
							}
						} \

						elseif { $ry != $HT } \
						{
							set rrectid [ $UT_C create rectangle \
								$x1 $ry $x2 $HT \
								-fill $ut_running_color -outline "" ]
						}

						#
						# Check System Rectangle
						#

						set srectid	[ lindex $state 8 ]

						if { $srectid != -1 } \
						{
							if { $sy != $ry } \
							{
								set_y_coords $UT_C $srectid $sy $ry
							} \

							else \
							{
								$UT_C delete $srectid

								set srectid -1
							}
						} \

						elseif { $sy != $ry } \
						{
							set srectid [ $UT_C create rectangle \
								$x1 $sy $x2 $ry \
								-fill $ut_system_color -outline "" ]
						}

						#
						# Check Idle Rectangle
						#

						set irectid	[ lindex $state 9 ]

						if { $irectid != -1 } \
						{
							if { $iy != $sy } \
							{
								set_y_coords $UT_C $irectid $iy $sy
							} \

							else \
							{
								$UT_C delete $irectid

								set irectid -1
							}
						} \

						elseif { $iy != $sy } \
						{
							set irectid [ $UT_C create rectangle \
								$x1 $iy $x2 $sy \
								-fill $ut_idle_color -outline "" ]
						}

						set state [ lreplace $state 4 9 \
							$rcnt $scnt $icnt \
							$rrectid $srectid $irectid ]
					} \

					else \
					{
						set state [ lreplace $state 4 6 \
							$rcnt $scnt $icnt ]
					}

					set ut_state [ lreplace $ut_state \
						$index $index $state ]

					if { $sec == $ssec && $usec == $susec \
						&& $sec == $esec && $usec == $eusec } \
					{
						return
					}
				}

				set index [ expr $index + 1 ]
			}
		}
	}

	$UT_C raise $ut_timeid

	#debug_proc updateUtilization exit
}

proc timeCompare { sec1 usec1 sec2 usec2 } \
{
	#debug_proc timeCompare entry

	if { $sec1 > $sec2 ||
		( $sec1 == $sec2 && $usec1 > $usec2 ) } \
	{
		set result 1
	} \

	elseif { $sec1 == $sec2 && $usec1 == $usec2 } \
		{ set result 0 } \

	else \
		{ set result -1 }

	return $result

	#debug_proc timeCompare exit
}

proc calcUtilCoords { rcnt scnt icnt } \
{
	#debug_proc calcUtilCoords entry

	global ut_max_ntasks
	global ut_cheight

	set NT $ut_max_ntasks
	set HT $ut_cheight

	#
	# Check Max Ntasks
	#

	set tot [ expr $rcnt + $scnt + $icnt ]

	if { $tot > $ut_max_ntasks } \
		{ scaleUtilization $ut_max_ntasks $tot }

	#
	# Calculate Coords
	#

	set iy [ expr $HT - ( $HT * $tot / $NT ) ]

	set sy [ expr $HT - ( $HT * ( $rcnt + $scnt ) / $NT ) ]

	set ry [ expr $HT - ( $HT * $rcnt / $NT ) ]

	#
	# Return Results
	#

	return [ list $iy $sy $ry ]

	#debug_proc calcUtilCoords exit
}

proc scaleUtilization { old new } \
{
	#debug_proc scaleUtilization entry

	global ut_max_ntasks
	global ut_cheight
	global ut_state

	set UT_C .utilization.frame.canvas

	set ut_max_ntasks $new

	.utilization.frame.ntasks configure -text $ut_max_ntasks

	foreach state $ut_state \
	{
		if { $state != "none" } \
		{
			set valid [ lindex $state 10 ]

			if { $valid == 1 } \
			{
				set rcnt [ lindex $state 4 ]
				set scnt [ lindex $state 5 ]
				set icnt [ lindex $state 6 ]

				set c [ calcUtilCoords $rcnt $scnt $icnt ]

				set iy [ lindex $c 0 ]
				set sy [ lindex $c 1 ]
				set ry [ lindex $c 2 ]

				set rrectid	[ lindex $state 7 ]

				if { $rrectid != -1 } \
					{ set_y_coords $UT_C $rrectid $ry $ut_cheight }

				set srectid	[ lindex $state 8 ]

				if { $srectid != -1 } \
					{ set_y_coords $UT_C $srectid $sy $ry }

				set irectid	[ lindex $state 9 ]

				if { $irectid != -1 } \
					{ set_y_coords $UT_C $irectid $iy $sy }
			}
		}
	}

	#debug_proc scaleUtilization exit
}

proc arrangeTasks { } \
{
	#debug_proc arrangeTasks entry

	global border_space
	global st_label_ht
	global row_height
	global st_rect_ht
	global task_list
	global ntask

	set ST_L .xpvm.space_time.labels

	set ST_C .xpvm.space_time.canvas

	set CT_L .call_trace.frame.labels

	set CT_C .call_trace.frame.canvas

	set delta_y [ expr ( $st_label_ht - $st_rect_ht ) / 2 ]

	set tx $border_space

	set ty $border_space

	for { set i 0 } { $i < $ntask } { set i [ expr $i + 1 ] } \
	{
		set t $task_list($i)

		set ly [ expr $ty + ( $st_label_ht / 2 ) ]

		#
		# Space-Time Label
		#

		set labelid [ lindex $t 3 ]

		$ST_L coords $labelid $tx $ly

		#
		# Call Trace Label / Call String
		#

		set ct_labelid [ lindex $t 7 ]
		set ct_callstrid [ lindex $t 8 ]

		$CT_L coords $ct_labelid $tx $ly

		$CT_C coords $ct_callstrid $tx $ly

		#
		# Space-Time State Rectangles
		#

		set s [ lindex $t 4 ]

		foreach state $s \
		{
			set rectid [ lindex $state 0 ]

			set old [ $ST_C coords $rectid ]

			set x1 [ lindex $old 0 ]
			set x2 [ lindex $old 2 ]

			set y1 [ expr $ty + $delta_y ]
			set y2 [ expr $ty + $delta_y + $st_rect_ht ]

			$ST_C coords $rectid $x1 $y1 $x2 $y2
		}

		set ty [ expr $ty + $st_label_ht ]
	}

	arrangeComm

	#debug_proc arrangeTasks exit
}

proc arrangeComm { } \
{
	#debug_proc arrangeComm entry

	global task_index
	global st_rect_ht
	global comm_list
	global task_list
	global ncomm
	global scale

	set ST_C .xpvm.space_time.canvas

	for { set i 0 } { $i < $ncomm } { set i [ expr $i + 1 ] } \
	{
		set c $comm_list($i)

		set src [ lindex $c 0 ]
		set dst [ lindex $c 1 ]

		set sindex $task_index($src)
		set dindex $task_index($dst)

		set stask $task_list($sindex)
		set dtask $task_list($dindex)

		set srectid [ lindex [ lindex [ lindex $stask 4 ] 0 ] 0 ]
		set drectid [ lindex [ lindex [ lindex $dtask 4 ] 0 ] 0 ]

		set scoords [ $ST_C coords $srectid ]
		set dcoords [ $ST_C coords $drectid ]

		set sy [ lindex $scoords 1 ]
		set dy [ lindex $dcoords 1 ]

		if { $sy < $dy } \
		{
			set y1 [ expr $sy + $st_rect_ht ]
			set y2 $dy
		} \

		else \
		{
			set y1 $sy
			set y2 [ expr $dy + $st_rect_ht ]
		}

		set ssec [ lindex $c 4 ]
		set susec [ lindex $c 5 ]

		set dsec [ lindex $c 6 ]
		set dusec [ lindex $c 7 ]

		set x1 [ x_of_time $ssec $susec $scale ]
		set x2 [ x_of_time $dsec $dusec $scale ]

		set lineid [ lindex $c 8 ]

		$ST_C coords $lineid $x1 $y1 $x2 $y2
	}

	#debug_proc arrangeComm exit
}

proc update_time { sec usec label } \
{
	#debug_proc update_time entry

	global st_canvas_height
	global ut_canvas_height
	global st_scroll_mark
	global ut_scroll_mark
	global frame_border
	global timeid_prim
	global st_timeid
	global ut_timeid
	global st_cwidth
	global ut_cwidth
	global st_xview
	global ut_xview
	global timeidx
	global st_usec
	global st_sec
	global scale
	global timex

	set st_usec $usec
	set st_sec $sec

	set new_timex [ x_of_time $sec $usec $scale ]

	if { $new_timex != $timex } \
	{
		set timestr "Time: $label"

		.xpvm.controls.time configure -text $timestr

		set timex $new_timex

		set wt [ expr $timex - $st_scroll_mark + (2 * $frame_border) ]

		if { $wt > $st_cwidth } \
		{
			set ST_SBH .xpvm.space_time.horiz_sb

			set ST_C .xpvm.space_time.canvas

			set st_scroll_mark [ expr $timex - $st_cwidth \
				+ (2 * $frame_border) ]

			if { $timeidx != -1 && $timeid_prim == "ST" } \
			{
				set UT_C .utilization.frame.canvas

				set qtx [ expr $timeidx - $st_xview \
					+ $st_scroll_mark ]

				$ST_C coords $st_timeid $qtx 0 $qtx $st_canvas_height
				$ST_C raise $st_timeid

				$UT_C coords $ut_timeid $qtx 0 $qtx $ut_canvas_height
				$UT_C raise $ut_timeid

				set_query_time $qtx
			}

			$ST_C xview $st_scroll_mark

			set st_xview $st_scroll_mark

			scrollSet $ST_SBH $timex $st_cwidth $st_scroll_mark
		}

		incr_space_time $sec $usec

		set wt [ expr $timex - $ut_scroll_mark + (2 * $frame_border) ]

		if { $wt > $ut_cwidth } \
		{
			set UT_SBH .utilization.frame.horiz_sb

			set UT_C .utilization.frame.canvas

			set ut_scroll_mark [ expr $timex - $ut_cwidth \
				+ (2 * $frame_border) ]

			if { $timeidx != -1 && $timeid_prim == "UT" } \
			{
				set ST_C .xpvm.space_time.canvas

				set qtx [ expr $timeidx - $ut_xview \
					+ $ut_scroll_mark ]

				$UT_C coords $ut_timeid $qtx 0 $qtx $ut_canvas_height
				$UT_C raise $ut_timeid

				$ST_C coords $st_timeid $qtx 0 $qtx $st_canvas_height
				$ST_C raise $st_timeid

				set_query_time $qtx
			}

			$UT_C xview $ut_scroll_mark

			set ut_xview $ut_scroll_mark

			scrollSet $UT_SBH $timex $ut_cwidth $ut_scroll_mark
		}

		incr_utilization $sec $usec

		update
	}

	#debug_proc update_time exit
}

proc incr_space_time { sec usec } \
{
	#debug_proc incr_space_time entry

	global st_timeline
	global task_list
	global st_active
	global ntask
	global timex

	if { $st_active == "FALSE" } \
		{ return }

	set ST_C .xpvm.space_time.canvas

	set old [ $ST_C coords $st_timeline ]

	set y1 [ lindex $old 1 ]
	set y2 [ lindex $old 3 ]

	$ST_C coords $st_timeline $timex $y1 $timex $y2

	for { set i 0 } { $i < $ntask } { set i [ expr $i + 1 ] } \
	{
		set t $task_list($i)

		set active [ lindex $t 6 ]

		if { $active == 1 } \
		{
			set s [ lindex $t 4 ]

			set state [ lindex $s 0 ]

			set rectid [ lindex $state 0 ]

			set old [ $ST_C coords $rectid ]

			set x1 [ lindex $old 0 ]

			set y1 [ lindex $old 1 ]
			set y2 [ lindex $old 3 ]

			$ST_C coords $rectid $x1 $y1 $timex $y2

			set incr_state [ lreplace $state 4 5 $sec $usec ]

			set incr_s [ lreplace $s 0 0 $incr_state ]

			set task_list($i) [ lreplace $t 4 4 $incr_s ]
		}
	}

	#debug_proc incr_space_time exit
}

proc incr_utilization { sec usec } \
{
	#debug_proc incr_utilization entry

	global ut_state
	global timex

	set UT_C .utilization.frame.canvas

	set state [ lindex $ut_state 0 ]

	if { "$state" == "none" } \
		{ return }

	set valid [ lindex $state 10 ]

	if { $valid == 1 } \
	{
		set rrectid	[ lindex $state 7 ]

		if { $rrectid != -1 } \
			{ set_x_coords $UT_C $rrectid -1 $timex }

		set srectid	[ lindex $state 8 ]

		if { $srectid != -1 } \
			{ set_x_coords $UT_C $srectid -1 $timex }

		set irectid	[ lindex $state 9 ]

		if { $irectid != -1 } \
			{ set_x_coords $UT_C $irectid -1 $timex }
	}

	set state [ lreplace $state 2 3 $sec $usec ]

	set ut_state [ lreplace $ut_state 0 0 $state ]

	#debug_proc incr_utilization exit
}

proc new_message { src dst nbytes msgtag ssec susec dsec dusec } \
{
	#debug_proc new_message entry

	global st_comm_color
	global task_index
	global st_rect_ht
	global comm_list
	global task_list
	global ncomm
	global scale

	set ST_C .xpvm.space_time.canvas

	set sindex $task_index($src)
	set dindex $task_index($dst)

	set stask $task_list($sindex)
	set dtask $task_list($dindex)

	set srectid [ lindex [ lindex [ lindex $stask 4 ] 0 ] 0 ]
	set drectid [ lindex [ lindex [ lindex $dtask 4 ] 0 ] 0 ]

	set scoords [ $ST_C coords $srectid ]
	set dcoords [ $ST_C coords $drectid ]

	set sy [ lindex $scoords 1 ]
	set dy [ lindex $dcoords 1 ]

	if { $sy < $dy } \
	{
		set y1 [ expr $sy + $st_rect_ht ]
		set y2 $dy
	} \

	else \
	{
		set y1 $sy
		set y2 [ expr $dy + $st_rect_ht ]
	}

	set x1 [ x_of_time $ssec $susec $scale ]
	set x2 [ x_of_time $dsec $dusec $scale ]

	set lineid [ $ST_C create line $x1 $y1 $x2 $y2 \
		-fill $st_comm_color ]

	set clist [ list $src $dst $nbytes $msgtag \
		$ssec $susec $dsec $dusec $lineid ]

	#
	# Add New Message to Comm List
	#

	if { $ncomm == 0 } \
	{
		set comm_list(0) $clist

		set ncomm 1
	} \

	else \
	{
		set comm_list($ncomm) $clist

		set ncomm [ expr $ncomm + 1 ]
	}

	#debug_proc new_message exit
}

proc task_output { tid output } \
{
	#debug_proc task_output entry

	global border_space
	global frame_border
	global row_height
	global to_saveout
	global to_cheight
	global to_active
	global to_numout
	global to_yview
	global to_lasty
	global fg_color
	global to_list

	set TO_C .task_output.frame.canvas

	set TO_SBV .task_output.frame.vert_sb

	set str "\[t$tid\] $output"

	if { $to_active == "TRUE" } \
	{
		#
		# Add New Output String
		#

		set x $border_space
		set y $to_lasty

		set outid [ $TO_C create text $border_space $y -text $str \
			-anchor nw -fill $fg_color ]

		set to_list [ linsert $to_list 0 $outid ]

		set to_numout [ expr $to_numout + 1 ]

		set to_lasty [ expr $y + $row_height ]

		#
		# Check for Auto-Scroll
		#

		set canvas_end_y [ expr $to_yview + $to_cheight \
			- $frame_border ]

		if { $to_lasty > $canvas_end_y } \
		{
			set to_yview [ expr ( $to_lasty - $to_cheight \
				+ (2 * $frame_border) + ($row_height - 1) ) \
				/ $row_height ]

			$TO_C yview $to_yview

			scrollSet $TO_SBV \
				[ expr $to_lasty / $row_height ] \
				[ expr $to_cheight / $row_height ] \
				$to_yview
		}
	} \

	else \
		{ lappend to_saveout $str }

	#debug_proc task_output exit
}

proc updateTaskOutput { } \
{
	#debug_proc updateTaskOutput entry

	global border_space
	global frame_border
	global row_height
	global to_saveout
	global to_cheight
	global to_active
	global to_numout
	global to_yview
	global to_lasty
	global fg_color
	global to_list

	set TO_C .task_output.frame.canvas

	set TO_SBV .task_output.frame.vert_sb

	foreach str $to_saveout \
	{
		#
		# Add New Output String
		#

		set x $border_space
		set y $to_lasty

		set outid [ $TO_C create text $border_space $y -text $str \
			-anchor nw -fill $fg_color ]

		set to_list [ linsert $to_list 0 $outid ]

		set to_numout [ expr $to_numout + 1 ]

		set to_lasty [ expr $y + $row_height ]
	}

	#
	# Check for Auto-Scroll
	#

	set canvas_end_y [ expr $to_yview + $to_cheight \
		- $frame_border ]

	if { $to_lasty > $canvas_end_y } \
	{
		set to_yview [ expr ( $to_lasty - $to_cheight \
			+ (2 * $frame_border) + ($row_height - 1) ) \
			/ $row_height ]

		$TO_C yview $to_yview

		scrollSet $TO_SBV \
			[ expr $to_lasty / $row_height ] \
			[ expr $to_cheight / $row_height ] \
			$to_yview
	}

	#
	# Reset Save List
	#

	set to_saveout ""

	#debug_proc updateTaskOutput exit
}

proc set_output_file { } \
{
	#debug_proc set_output_file entry

	global output_file

	set TO .task_output

	focus .xpvm

	set file [ $TO.file_entry get ]

	if { $file != $output_file } \
	{
		set output_file $file

		output_file_handle $output_file
	}

	#debug_proc set_output_file exit
}

proc do_spawn { init } \
{
	#debug_proc do_spawn entry

	global spawn_close_on_start
	global spawn_flags_debug
	global spawn_flags_trace
	global spawn_flags_front
	global spawn_flags_compl
	global spawn_init_save
	global spawn_where
	global spawn_subs

	focus .xpvm

	if { $spawn_close_on_start == "ON" } \
	{
		#
		# Use raiseSubMenu{} to lower, just to catch subs.
		#     - make sure no raise.
		#

		set cksd [ winfo ismapped .xpvm.spawn ]

		if { $cksd == 1 } \
		{
			raiseSubMenu .xpvm.spawn .xpvm.tasks_menu \
				.xpvm.tasks_menu.butt_SPAWN .xpvm.spawn.cmd_entry \
				[ expr $spawn_subs ]
		}
	}

	set SP .xpvm.spawn

	set cmd [ $SP.cmd_entry get ]

	if { $cmd == "" } \
		{ return }

	set name [ lindex $cmd 0 ]

	set args [ lreplace $cmd 0 0 ]

	set ntasks [ $SP.ntasks_entry get ]

	if { $ntasks == "" } \
		{ set ntasks 1 }

	set loc [ $SP.loc_entry get ]

	if { $loc != "" } \
	{
		if { $spawn_where == "Host" } \
			{ set where "host $loc" } \

		elseif { $spawn_where == "Arch" } \
			{ set where "arch $loc" } \

		else \
			{ set where "" }
	} \

	else \
		{ set where "" }

	set flags ""

	if { $spawn_flags_debug == "ON" } \
		{ append flags debug }

	if { $spawn_flags_trace == "ON" } \
		{ append flags " trace" }

	if { $spawn_flags_front == "ON" } \
		{ append flags " front" }

	if { $spawn_flags_compl == "ON" } \
		{ append flags " compl" }

	if { $init == "again" } \
		{ set init $spawn_init_save } \

	else \
		{ set spawn_init_save $init }

	set cmd \
		"pvm_tasks spawn $init $name { $args } $ntasks $where $flags"

	eval $cmd

	#debug_proc do_spawn exit
}

proc checkSpawnWhere { } \
{
	#debug_proc checkSpawnWhere entry

	global spawn_host_string
	global spawn_arch_string
	global last_spawn_where
	global spawn_where

	set SP .xpvm.spawn

	set str [ $SP.loc_entry get ]

	if { $last_spawn_where == "Host" } \
		{ set spawn_host_string $str } \

	elseif { $last_spawn_where == "Arch" } \
		{ set spawn_arch_string $str }

	$SP.loc_entry delete 0 end

	if { $spawn_where == "Host" } \
		{ $SP.loc_entry insert 0 $spawn_host_string } \

	elseif { $spawn_where == "Arch" } \
		{ $SP.loc_entry insert 0 $spawn_arch_string }

	set last_spawn_where $spawn_where

	layout_spawn_dialog

	#debug_proc checkSpawnWhere exit
}

proc trace_mask { index label menuvar setflag } \
{
	#debug_proc trace_mask entry

	global $menuvar

	set state [ expr $$menuvar ]

	pvm_trace_mask $index $state

	#debug_proc trace_mask exit
}

proc trace_mask_result { result } \
{
	#debug_proc trace_mask_result entry

	foreach ev $result \
	{
		set index [ lindex $ev 0 ]
		set onoff [ lindex $ev 1 ]

		set menuvar "trace_mask_state_$index"

		global $menuvar

		set $menuvar $onoff
	}

	#debug_proc trace_mask_result exit
}

proc do_kill { index } \
{
	#debug_proc do_kill entry

	global kill_tasklist
	global kill_lasty
	global row_height

	if { $index == "refresh" } \
		{ refresh_tasks kill } \

	elseif { $index == "all" } \
	{
		pvm_tasks kill 0 all

		refresh_tasks kill
	} \

	else \
	{
		if { $index > 0 && $index < $kill_lasty } \
		{
			set i [ expr $index / $row_height ]

			set max [ llength $kill_tasklist ]

			set t [ lindex $kill_tasklist [ expr $max - $i - 2 ] ]

			set name [ lindex $t 1 ]
			set tid [ lindex $t 2 ]

			pvm_tasks kill $tid $name

			refresh_tasks kill
		}
	}

	#debug_proc do_kill exit
}

proc do_signal { index } \
{
	#debug_proc do_signal entry

	global signal_selected
	global signal_tasklist
	global signal_lasty
	global row_height

	if { $index == "refresh" } \
		{ refresh_tasks signal } \

	elseif { $index == "all" } \
		{ pvm_tasks signal 0 $signal_selected } \

	else \
	{
		if { $index > 0 && $index < $signal_lasty } \
		{
			set i [ expr $index / $row_height ]

			set max [ llength $signal_tasklist ]

			set t [ lindex $signal_tasklist [ expr $max - $i - 2 ] ]

			set tid [ lindex $t 2 ]

			pvm_tasks signal $tid $signal_selected
		}
	}

	#debug_proc do_signal exit
}

proc systasks { index label menuvar setflag } \
{
	#debug_proc systasks entry

	global $menuvar

	set state [ expr $$menuvar ]

	eval "pvm_tasks systasks $index $state"

	#debug_proc systasks exit
}

proc reset { index label menuvar setflag } \
{
	#debug_proc reset entry

	if { $index == "pvm" } \
		{ reset_pvm } \

	elseif { $index == "views" } \
		{ reset_views } \

	elseif { $index == "trace_file" } \
		{ reset_trace_file } \

	elseif { $index == "all" } \
	{
		#
		# Reset PVM after interface & trace file
		#     - to get group servers, etc, if desired.
		#
		# Reset Views after Trace File to insure that
		#     TRACE_PENDING is cleared immediately.
		#

		reset_trace_file
		reset_views
		reset_pvm
	}

	#debug_proc reset exit
}

proc handleTraceFileStatus { } \
{
	#debug_proc handleTraceFileStatus entry

	global trace_file_status

	trace_file_status_handle $trace_file_status

	if { $trace_file_status == "PlayBack" } \
	{
		set OV .xpvm.overwrite

		set ckov [ winfo ismapped $OV ]

		if { $ckov == 1 } \
		{
			place forget $OV
		}
	}

	#debug_proc handleTraceFileStatus exit
}

proc set_trace_file { } \
{
	#debug_proc set_trace_file entry

	global trace_file

	set CTRL .xpvm.controls

	focus .xpvm

	set file [ $CTRL.file_entry get ]

	if { $file != $trace_file } \
	{
		set trace_file $file

		trace_file_handle $trace_file
	}

	#debug_proc set_trace_file exit
}

proc prompt_trace_overwrite { file } \
{
	#debug_proc prompt_trace_overwrite entry

	global border_space

	set OV .xpvm.overwrite

	$OV.file configure -text $file

	update

	set lwt [ winfo width $OV.label ]
	set fwt [ winfo width $OV.file ]

	if { $lwt > $fwt } \
		{ set wt $lwt } \

	else \
		{ set wt $fwt }

	set wt [ expr $wt + (2 * $border_space) ]

	set ht [ expr [ winfo y $OV.yes ] + [ winfo height $OV.yes ] \
		+ $border_space ]

	place $OV -x 175 -y 200 -width $wt -height $ht

	#debug_proc prompt_trace_overwrite exit
}

proc add_task { host index task tid sec usec str } \
{
	#debug_proc add_task entry

	global st_running_color
	global st_rect_ht
	global task_index
	global task_list
	global fg_color
	global ntask
	global scale

	set ST_L .xpvm.space_time.labels

	set ST_C .xpvm.space_time.canvas

	set CT_L .call_trace.frame.labels

	set CT_C .call_trace.frame.canvas

	#
	# Update Host Icon State
	#

	updateNetworkHost $index none running

	#
	# Update Utilization View Counts
	#

	updateUtilization none running $sec $usec

	#
	# Create Space-Time Task List Elements
	#

	set label "$host:$task"

	set labelid [ $ST_L create text 0 0 -text $label -anchor w \
		-fill $fg_color ]

	set x [ x_of_time $sec $usec $scale ]

	set y $st_rect_ht

	set rectid [ $ST_C create rectangle $x 0 $x $y \
		-fill $st_running_color ]

	set state [ list $rectid "running" \
		$sec $usec $sec $usec $str ]

	set state_list [ list $state ]

	set comm_list [ list "" ]

	#
	# Create Call Trace Task List Elements
	#

	set ct_labelid [ $CT_L create text 0 0 -text $label -anchor w \
		-fill $fg_color ]

	set ct_callstrid [ $CT_C create text 0 0 -text $str \
		-anchor w -fill $fg_color ]

	#
	# Assemble Task List
	#

	set tlist [ list [ list $host $index ] $task $tid $labelid \
		$state_list $comm_list 1 $ct_labelid $ct_callstrid ]

	#
	# Add New Task to List
	#

	if { $ntask == 0 } \
	{
		set task_list(0) $tlist

		set task_index($tid) 0

		set ntask 1
	} \

	else \
	{
		set t $task_list(0)

		set hst [ lindex [ lindex $t 0 ] 0 ]

		set tsk [ lindex $t 1 ]
		set td [ lindex $t 2 ]

		set i 0

		while { $i < $ntask \
			&& ( $hst < $host \
			|| ( $hst == $host && $tsk < $task )
			|| ( $hst == $host && $tsk == $task && $td < $tid ) ) } \
		{
			set i [ expr $i + 1 ]

			if { $i < $ntask } \
			{
				set t $task_list($i)

				set hst [ lindex [ lindex $t 0 ] 0 ]

				set tsk [ lindex $t 1 ]
				set td [ lindex $t 2 ]
			}
		}

		if { $i < $ntask } \
		{
			for { set j $ntask } { $j > $i } { set j [ expr $j - 1 ] } \
			{
				set jm1 [ expr $j - 1 ]

				set t $task_list($jm1)

				set td [ lindex $t 2 ]

				set task_list($j) $t

				set task_index($td) $j
			}

			set task_list($i) $tlist

			set task_index($tid) $i
		} \

		else \
		{
			set task_list($ntask) $tlist

			set task_index($tid) $ntask
		}

		set ntask [ expr $ntask + 1 ]
	}

	arrangeTasks

	#debug_proc add_task exit
}

proc task_state { tid status sec usec call_str } \
{
	#debug_proc task_state entry

	global st_running_color
	global st_system_color
	global ct_query_index
	global st_idle_color
	global task_index
	global task_list
	global ct_active
	global st_active
	global st_usec
	global st_sec
	global scale
	global timex

	set ST_C .xpvm.space_time.canvas

	set CT_C .call_trace.frame.canvas

	#
	# Find Task
	#

	set index $task_index($tid)

	set t $task_list($index)

	set s [ lindex $t 4 ]

	set state [ lindex $s 0 ]

	set sts [ lindex $state 1 ]

	#
	# Update Call String for Task
	#

	if { $ct_active == "TRUE" } \
	{
		set ct_callstrid [ lindex $t 8 ]

		$CT_C itemconfigure $ct_callstrid -text "$call_str"

		if { $ct_query_index == $index } \
		{
			set str "Time Stamp: $sec.[ pad $usec 6 ]"

			.call_trace.frame.query configure -text $str
		}
	}

	#
	# Check for Task State Change
	#

	if { $sts != $status } \
	{
		#
		# Update Host Icon State
		#

		set host [ lindex [ lindex $t 0 ] 1 ]

		updateNetworkHost $host $sts $status

		#
		# Update Utilization View Counts
		#

		updateUtilization $sts $status $sec $usec

		#
		# Set End of Last State
		#

		set rectid [ lindex $state 0 ]

		set old [ $ST_C coords $rectid ]

		set x1 [ lindex $old 0 ]

		set y1 [ lindex $old 1 ]
		set y2 [ lindex $old 3 ]

		set x [ x_of_time $sec $usec $scale ]

		$ST_C coords $rectid $x1 $y1 $x $y2

		set end_state [ lreplace $state 4 5 $sec $usec ]

		set end_s [ lreplace $s 0 0 $end_state ]

		#
		# Set Color for New State
		#

		if { $status == "running" } \
			{ set color $st_running_color } \

		elseif { $status == "pvm_call" } \
			{ set color $st_system_color } \

		elseif { $status == "idle" } \
			{ set color $st_idle_color }

		#
		# Create New State Rectangle
		#

		set rectid [ $ST_C create rectangle $x $y1 $timex $y2 \
			-fill $color ]

		$ST_C lower $rectid

		set new_state [ list $rectid $status \
			$sec $usec $st_sec $st_usec $call_str ]

		set new_s [ linsert $end_s 0 $new_state ]

		set new_t [ lreplace $t 4 4 $new_s ]

		set task_list($index) $new_t

		update
	}

	#debug_proc task_state exit
}

proc exit_task { tid sec usec str } \
{
	#debug_proc exit_task entry

	global ct_query_index
	global task_index
	global ct_active
	global task_list
	global scale

	set ST_C .xpvm.space_time.canvas

	set CT_C .call_trace.frame.canvas

	#
	# Find Task to Remove
	#

	set index $task_index($tid)

	set t $task_list($index)

	set s [ lindex $t 4 ]

	set state [ lindex $s 0 ]

	set status [ lindex $state 1 ]

	#
	# Update Call String for Task
	#

	if { $ct_active == "TRUE" } \
	{
		set ct_callstrid [ lindex $t 8 ]

		$CT_C itemconfigure $ct_callstrid -text $str

		if { $ct_query_index == $index } \
		{
			set str "Time Stamp: $sec.[ pad $usec 6 ]"

			.call_trace.frame.query configure -text $str
		}
	}

	#
	# Update Host Icon State
	#

	set host [ lindex [ lindex $t 0 ] 1 ]

	updateNetworkHost $host $status dead

	#
	# Update Utilization View Counts
	#

	updateUtilization $status dead $sec $usec

	#
	# Finish Off Space-Time State Rectangle
	#

	set rectid [ lindex $state 0 ]

	set old [ $ST_C coords $rectid ]

	set x1 [ lindex $old 0 ]

	set y1 [ lindex $old 1 ]
	set y2 [ lindex $old 3 ]

	set x2 [ x_of_time $sec $usec $scale ]

	$ST_C coords $rectid $x1 $y1 $x2 $y2

	set state [ lreplace $state 4 5 $sec $usec ]

	set s [ lreplace $s 0 0 $state ]

	set t [ lreplace $t 4 4 $s ]

	set task_list($index) [ lreplace $t 6 6 0 ]

	#debug_proc exit_task exit
}

proc reset_interface { } \
{
	#debug_proc reset_interface entry

	global st_canvas_height
	global net_empty_color
	global st_scroll_mark
	global ut_scroll_mark
	global ut_max_ntasks
	global frame_border
	global st_timeline
	global row_height
	global task_index
	global to_saveout
	global ut_running
	global ut_system
	global comm_list
	global host_list
	global task_list
	global to_numout
	global to_lasty
	global ut_state
	global ut_idle
	global to_list
	global st_usec
	global st_sec
	global depth
	global ncomm
	global nhost
	global ntask
	global timex

	set ST_L .xpvm.space_time.labels

	set ST_C .xpvm.space_time.canvas

	set UT_C .utilization.frame.canvas

	set CT_L .call_trace.frame.labels

	set CT_C .call_trace.frame.canvas

	set TO_C .task_output.frame.canvas

	set NET_C .xpvm.network.canvas

	#
	# Reset Network Host States
	#

	for { set i 0 } { $i < $nhost } { set i [ expr $i + 1 ] } \
	{
		set h $host_list($i)

		set state [ lindex $h 4 ]

		if { $state == "ON" } \
		{
			#
			# Reset Icon Color
			#

			set iconid [ lindex $h 9 ]
			$NET_C itemconfigure $iconid -background $net_empty_color

			if { $depth > 1 } \
			{
				set boxid [ lindex $h 11 ]
				$NET_C itemconfigure $boxid -fill $net_empty_color
			} \

			else \
			{
				if { $net_empty_color == "black" } \
					{ $NET_C itemconfigure $iconid -foreground white } \

				else \
					{ $NET_C itemconfigure $iconid -foreground black }
			}

			#
			# Reset Running / Idle Counts
			#

			set h [ lreplace $h 6 8 0 0 0 ]

			set host_list($i) $h
		}
	}

	#
	# Clear All Tasks
	#

	for { set i 0 } { $i < $ntask } { set i [ expr $i + 1 ] } \
	{
		set t $task_list($i)

		set tid [ lindex $t 2 ]

		#
		# Delete Space-Time Label
		#

		set labelid [ lindex $t 3 ]

		$ST_L delete $labelid

		#
		# Delete Call Trace Label / Call String
		#

		set ct_labelid [ lindex $t 7 ]
		set ct_callstrid [ lindex $t 8 ]

		$CT_L delete $ct_labelid

		$CT_C delete $ct_callstrid

		#
		# Delete Space-Time State Rectangles
		#

		set s [ lindex $t 4 ]

		foreach state $s \
		{
			set rectid [ lindex $state 0 ]

			$ST_C delete $rectid
		}

		#
		# Delete Task
		#

		set task_list($i) [ list "" ]

		set task_index($tid) -1
	}

	set ntask 0

	#
	# Clear Space-Time Message Lines
	#

	for { set i 0 } { $i < $ncomm } { set i [ expr $i + 1 ] } \
	{
		set c $comm_list($i)

		set lineid [ lindex $c 8 ]

		$ST_C delete $lineid

		set comm_list($i) [ list "" ]
	}

	set ncomm 0

	#
	# Clear Task Output Strings
	#

	for { set i 0 } { $i < $to_numout } { set i [ expr $i + 1 ] } \
	{
		set outid [ lindex $to_list $i ]

		$TO_C delete $outid
	}

	set to_lasty $frame_border

	set to_list [ list "" ]

	set to_numout 0

	set to_saveout ""

	#
	# Re-Initialize Time / Space-Time
	#

	.xpvm.controls.time configure -text "Time: 0.000000"

	set st_scroll_mark 0

	set st_usec 0
	set st_sec 0

	set timex $frame_border

	$ST_C coords $st_timeline $timex 0 $timex $st_canvas_height

	#
	# Clear Utilization Rectangles
	#

	foreach state $ut_state \
	{
		if { $state != "none" } \
		{
			set valid [ lindex $state 10 ]

			if { $valid == 1 } \
			{
				set rrectid [ lindex $state 7 ]

				if { $rrectid != -1 } \
					{ $UT_C delete $rrectid }

				set srectid [ lindex $state 8 ]

				if { $srectid != -1 } \
					{ $UT_C delete $srectid }

				set irectid [ lindex $state 9 ]

				if { $irectid != -1 } \
					{ $UT_C delete $irectid }
			}
		}
	}

	#
	# Re-Initialize Utilization
	#

	set ut_max_ntasks 1

	.utilization.frame.ntasks configure -text $ut_max_ntasks

	set ut_scroll_mark 0

	set ut_state [ list none ]

	set ut_running 0
	set ut_system 0
	set ut_idle 0

	#
	# Reset Scrollbars / Canvases
	#

	scrollReset

	#debug_proc reset_interface exit
}

proc scrollReset {} \
{
	#debug_proc scrollReset entry

	global st_canvas_height
	global ct_canvas_height
	global ct_canvas_width
	global to_canvas_width
	global net_cheight
	global net_cwidth
	global row_height
	global net_scroll
	global st_cheight
	global ct_cheight
	global to_cheight
	global st_cwidth
	global ut_cwidth
	global ct_cwidth
	global to_cwidth
	global to_lasty
	global net_size

	set NET_C .xpvm.network.canvas
	set NET_SBH .xpvm.network.horiz_sb
	set NET_SBV .xpvm.network.vert_sb

	set ST_L .xpvm.space_time.labels
	set ST_C .xpvm.space_time.canvas
	set ST_SBH .xpvm.space_time.horiz_sb
	set ST_SBV .xpvm.space_time.vert_sb

	set UT_C .utilization.frame.canvas
	set UT_SBH .utilization.frame.horiz_sb

	set CT_L .call_trace.frame.labels
	set CT_C .call_trace.frame.canvas
	set CT_SBH .call_trace.frame.horiz_sb
	set CT_SBV .call_trace.frame.vert_sb

	set TO_C .task_output.frame.canvas
	set TO_SBH .task_output.frame.horiz_sb
	set TO_SBV .task_output.frame.vert_sb

	scrollInit $NET_C $NET_SBH $net_size $net_cwidth net_xview \
		HORIZ center $net_scroll

	scrollInit $NET_C $NET_SBV $net_size $net_cheight net_yview \
		VERT center $net_scroll

	scrollInit $ST_C $ST_SBH $st_cwidth $st_cwidth st_xview \
		HORIZ low 1

	scrollInit $ST_L $ST_SBV $st_canvas_height $st_cheight st_yview \
		VERT low 1

	scrollInit $ST_C $ST_SBV $st_canvas_height $st_cheight st_yview \
		VERT low 1

	scrollInit $UT_C $UT_SBH $ut_cwidth $ut_cwidth ut_xview HORIZ low 1

	scrollInit $CT_C $CT_SBH $ct_canvas_width $ct_cwidth ct_xview \
		HORIZ low 1

	scrollInit $CT_L $CT_SBV $ct_canvas_height $ct_cheight ct_yview \
		VERT low 1

	scrollInit $CT_C $CT_SBV $ct_canvas_height $ct_cheight ct_yview \
		VERT low 1

	scrollInit $TO_C $TO_SBH $to_canvas_width $to_cwidth to_xview \
		HORIZ low $row_height

	scrollInit $TO_C $TO_SBV $to_lasty $to_cheight to_yview \
		VERT low $row_height

	#debug_proc scrollReset exit
}

proc delete_task { tid } \
{
	#debug_proc delete_task entry

	global task_index
	global task_list
	global ntask

	set ST_L .xpvm.space_time.labels

	set ST_C .xpvm.space_time.canvas

	#
	# Find Task to Remove
	#

	set index $task_index($tid)

	set t $task_list($index)

	set task_index($tid) -1

	#
	# Delete Label
	#

	set labelid [ lindex $t 3 ]

	$ST_L delete $labelid

	#
	# Delete State Rectangles
	#

	set s [ lindex $t 4 ]

	foreach state $s \
	{
		set rectid [ lindex $state 0 ]

		$ST_C delete $rectid
	}

	set last [ expr $ntask - 1 ]

	for { set i $index } { $i < $last } { set i [ expr $i + 1 ] } \
	{
		set ip1 [ expr $1 + 1 ]

		set t $task_list($ip1)

		set td [ lindex $t 2 ]

		set task_list($i) $t

		set task_index($td) $i
	}

	set ntask [ expr $ntask - 1 ]

	arrangeTasks

	#debug_proc delete_task exit
}

proc do_pvm_hosts { index label menuvar setflag } \
{
	#debug_proc do_pvm_hosts entry

	global frame_border
	global main_font
	global fg_color

	if { $menuvar == "none" } \
	{
		if { $index == -1 } \
		{
			#
			# Add Other Host
			#

			set ckmpd [ winfo ismapped .xpvm.other ]

			if { $ckmpd == 0 } \
			{
				set BUTT .xpvm.hosts_menu.butt_Other_Hosts

				set x [ winfo x .xpvm.hosts_menu ]
				set y [ winfo y .xpvm.hosts_menu ]

				set x [ expr $x + [ left $BUTT ] ]
				set y [ expr $y + [ below $BUTT ] ]

				place .xpvm.other -x $x -y $y

				focus .xpvm.other
			} \

			else \
				{ place forget .xpvm.other }
		} \

		else \
		{
			#
			# Add All Hosts
			#

			pvm_hosts $index
		}
	} \

	else \
	{
		#
		# Add / Delete Specific Host
		#

		global $menuvar

		set state [ expr $$menuvar ]

		if { $setflag == "TRUE" } \
		{
			if { $state == "ON" } \
			{
				set $menuvar OFF

				set state OFF
			} \

			else \
			{
				set $menuvar ON

				set state ON
			}
		}

		pvm_hosts $index
	}

	#debug_proc do_pvm_hosts exit
}

proc do_pvm_other_host { } \
{
	#debug_proc do_pvm_other_host entry

	set new_host [ .xpvm.other get ]

	place forget .xpvm.other

	.xpvm.other delete 0 end

	set strlen [ string length $new_host ]

	if { $strlen > 0 } \
	{
		pvm_hosts -1 $new_host
	}

	#debug_proc do_pvm_other_host exit
}

proc checkHostResult { msg } \
{
	#debug_proc checkHostResult entry

	global host_list

	#
	# Get Host & Icon Info / Extract Message
	#

	set arrange 0

	set cnt 0

	foreach i $msg \
	{
		set ck [ lindex $i 0 ]

		if { $ck == "NEW" } \
		{
			set label [ lindex $i 1 ]
			set index [ lindex $i 2 ]
			set type [ lindex $i 3 ]

			addNewNetworkHost $label $index $type

			#
			# Fix Msg
			#

			set msg [ lreplace $msg $cnt $cnt ]
		} \

		elseif { $ck == "ICON" } \
		{
			#
			# Replace Old Host Icon Info
			#

			set index [ lindex $i 1 ]
			set icon [ lindex $i 2 ]
			set iwt [ lindex $i 3 ]
			set iht [ lindex $i 4 ]

			set h $host_list($index)

			set h [ lreplace $h 1 1 $icon ]
			set h [ lreplace $h 2 2 $iwt ]
			set h [ lreplace $h 3 3 $iht ]

			set host_list($index) $h

			#
			# Fix Msg
			#

			set msg [ lreplace $msg $cnt $cnt ]
		} \

		elseif { $ck == "ON" || $ck == "OFF" } \
		{
			#
			# Get Current Host Info
			#

			set index [ lindex $i 1 ]

			set h $host_list($index)

			set name [ lindex $h 0 ]
			set icon [ lindex $h 1 ]
			set iwt [ lindex $h 2 ]
			set iht [ lindex $h 3 ]

			set menuvar [ lindex $h 5 ]

			global $menuvar

			if { $ck == "ON" } \
			{
				#
				# Somewhat Ugly Hack...
				#

				set len [ llength $h ]

				if { $len == 13 } \
				{
					set iconid [ lindex $h 9 ]
					set nameid [ lindex $h 10 ]
					set boxid [ lindex $h 11 ]
					set linkid [ lindex $h 12 ]

					undrawNetworkHost $iconid $nameid $boxid $linkid
				}

				set $menuvar ON

				set ids [ drawNetworkHost $name $icon ]

				set htmp \
					[ list $name $icon $iwt $iht "ON" $menuvar 0 0 0 ]

				set hlist [ concat $htmp $ids ]
			} \

			else \
			{
				set $menuvar OFF

				set iconid [ lindex $h 9 ]
				set nameid [ lindex $h 10 ]
				set boxid [ lindex $h 11 ]
				set linkid [ lindex $h 12 ]

				undrawNetworkHost $iconid $nameid $boxid $linkid

				set hlist [ list $name $icon $iwt $iht "OFF" $menuvar ]
			}

			set host_list($index) $hlist

			set arrange 1

			#
			# Fix Msg
			#

			set msg [ lreplace $msg $cnt $cnt ]
		} \

		else \
			{ set cnt [ expr $cnt + 1 ] }
	}

	if { $arrange == 1 } \
		{ arrangeNetworkHosts }

	if { [ llength $msg ] > 0 } \
		{ setMsg $msg }

	#debug_proc checkHostResult exit
}

proc addNewNetworkHost { label index type } \
{
	#debug_proc addNewNetworkHost entry

	global active_fg_color
	global selector_color
	global fg_color

	set MENU .xpvm.hosts_menu

	#
	# Create Menu State Variable
	#

	set root [ rootName $MENU ]

	set fix_label [ strip_label $label ]

	set menuvar $root\_state_$fix_label\_$index

	global $menuvar

	set $menuvar OFF

	#
	# Create Host List Entry
	#

	addNetworkHost $label dummy 0 0 OFF $menuvar

	if { $type == "PERM" } \
	{
		#
		# Create Menu Button
		#

		set NAME "$MENU.ckbutt_$fix_label"

		set command "do_pvm_hosts $index \"$label\" $menuvar FALSE"

		checkbutton $NAME -text $label -command $command \
			-bd 1 -relief raised -anchor nw \
			-onvalue ON -offvalue OFF -variable $menuvar \
			-selector $selector_color -foreground $fg_color \
			-activeforeground $active_fg_color

		#
		# Place New Menu Button
		#

		set LAST "$MENU.butt_Other_Hosts"

		set x [ expr [ winfo x $LAST ] - 2 ]
		set y [ expr [ winfo y $LAST ] - 2 ]

		place $NAME -x $x -y $y

		update

		place $LAST -y [ below $NAME ]

		update

		set DONE "$MENU.butt_Done"

		place $DONE -y [ below $LAST ]

		update

		#
		# Adjust Menu Height
		#

		set menu_height [ expr [ below $DONE ] + 4 ]

		$MENU configure -height $menu_height

		#
		# Adjust Menu Width
		#

		set width [ winfo width $DONE ]

		set wt [ winfo width $NAME ]

		if { $wt > $width } \
		{
			set menu_width [ expr $wt + 8 ]

			$MENU configure -width $menu_width

			set mil "$root\_list"

			global $mil

			foreach i [ expr $$mil ] \
				{ place $i -width $wt }
		} \

		else \
		{
			place $NAME -width $width
		}
	}

	update

	#debug_proc addNewNetworkHost exit
}

proc addNetworkHost { name icon iwt iht state menuvar } \
{
	#debug_proc addNetworkHost entry

	global row_height
	global host_list
	global nhost

	if { $state == "ON" } \
	{
		set ids [ drawNetworkHost $name $icon ]

		set htmp [ list $name $icon $iwt $iht "ON" $menuvar 0 0 0 ]

		set hlist [ concat $htmp $ids ]
	} \

	else \
	{
		set hlist [ list $name $icon $iwt $iht "OFF" $menuvar ]
	}

	if { $nhost == 0 } \
	{
		set host_list(0) $hlist

		set nhost 1
	} \

	else \
	{
		set host_list($nhost) $hlist

		set nhost [ expr $nhost + 1 ]
	}

	if { $state == "ON" } arrangeNetworkHosts

	#debug_proc addNetworkHost exit
}

proc drawNetworkHost { name icon } \
{
	#debug_proc drawNetworkHost entry

	global net_empty_color
	global net_fg_color
	global net_size

	set NET_C .xpvm.network.canvas

	#
	# Draw Pieces of Network Host Off Screen
	#

	set XY [ expr -2 * $net_size ]

	set boxid [ $NET_C create rectangle $XY $XY $XY $XY \
		-outline $net_fg_color -fill $net_empty_color ]

	set iconid [ $NET_C create bitmap $XY $XY \
		-bitmap $icon -anchor center \
		-foreground $net_fg_color -background $net_empty_color ]

	set nameid [ $NET_C create text $XY $XY \
		-text $name -anchor center \
		-fill $net_fg_color ]

	set linkid [ $NET_C create line $XY $XY $XY $XY \
		-fill $net_fg_color ]

	return [ list $iconid $nameid $boxid $linkid ]

	#debug_proc drawNetworkHost exit
}

proc undrawNetworkHost { iconid nameid boxid linkid } \
{
	#debug_proc undrawNetworkHost entry

	set NET_C .xpvm.network.canvas

	$NET_C delete $iconid $nameid $boxid $linkid

	#debug_proc undrawNetworkHost exit
}

proc updateNetworkHost { index old new } \
{
	#debug_proc updateNetworkHost entry

	global net_running_color
	global net_system_color
	global net_idle_color
	global net_empty_color
	global host_list
	global depth

	set NET_C .xpvm.network.canvas

	set h $host_list($index)

	set state [ lindex $h 4 ]

	if { $state == "ON" } \
	{
		#
		# Calculate New Running / Idle Counts
		#

		set running [ lindex $h 6 ]
		set system [ lindex $h 7 ]
		set idle [ lindex $h 8 ]

		set rng $running
		set sys $system
		set idl $idle

		if { $old == "running" } \
			{ set rng [ expr $rng - 1 ] } \

		elseif { $old == "pvm_call" } \
			{ set sys [ expr $sys - 1 ] } \

		elseif { $old == "idle" } \
			{ set idl [ expr $idl - 1 ] }

		if { $new == "running" } \
			{ set rng [ expr $rng + 1 ] } \

		elseif { $new == "pvm_call" } \
			{ set sys [ expr $sys + 1 ] } \

		elseif { $new == "idle" } \
			{ set idl [ expr $idl + 1 ] }

		#
		# Calculate New Icon Color
		#

		if { $running > 0 } \
			{ set color $net_running_color } \

		elseif { $system > 0 } \
			{ set color $net_system_color } \

		elseif { $idle > 0 } \
			{ set color $net_idle_color } \

		else \
			{ set color $net_empty_color }

		if { $rng > 0 } \
			{ set clr $net_running_color } \

		elseif { $sys > 0 } \
			{ set clr $net_system_color } \

		elseif { $idl > 0 } \
			{ set clr $net_idle_color } \

		else \
			{ set clr $net_empty_color }

		#
		# Update Icon Color
		#

		if { $clr != $color } \
		{
			set iconid [ lindex $h 9 ]
			$NET_C itemconfigure $iconid -background $clr

			if { $depth > 1 } \
			{
				set boxid [ lindex $h 11 ]
				$NET_C itemconfigure $boxid -fill $clr
			} \

			else \
			{
				if { $clr == "black" } \
				{
					$NET_C itemconfigure $iconid -foreground white
				} \

				else \
				{
					$NET_C itemconfigure $iconid -foreground black
				}
			}
		}

		#
		# Update Host Counts
		#

		if { $rng != $running || $sys != $system || $idl != $idle } \
			{ set h [ lreplace $h 6 8 $rng $sys $idl ] }

		set host_list($index) $h
	}

	#debug_proc updateNetworkHost exit
}

proc arrangeNetworkHosts { } \
{
	#debug_proc arrangeNetworkHosts entry

	global net_fg_color
	global icon_border
	global icon_space
	global row_height
	global host_list
	global net_space
	global netline
	global nhost

	#
	# Get Network Width Info
	#

	set infolist [ infoNetworkHosts ]

	set totalwt	[ lindex $infolist 0 ]
	set startwt	[ lindex $infolist 1 ]
	set endwt	[ lindex $infolist 2 ]
	set nactive	[ lindex $infolist 3 ]

	#
	# Initialize Working Vars
	#

	set NET_C .xpvm.network.canvas

	set Xtop [ expr -1 * ( $totalwt / 2 ) ]

	set Xbot [ expr -1 * ( $totalwt / 2 ) ]

	#
	# Place Main Network Bus Line
	#

	set x1 [ expr $Xtop + ( $startwt / 2 ) ]

	set x2 [ expr $Xtop + $totalwt - ( $endwt / 2 ) ]

	if { $x1 != $x2 && $x1 < $x2 } \
	{
		if { $netline == -1 } \
		{
			set netline [ $NET_C create line $x1 0 $x2 0 \
				-fill $net_fg_color ]
		} \

		else \
			{ $NET_C coords $netline $x1 0 $x2 0 }
	} \

	elseif { $netline != -1 } \
	{
		$NET_C delete $netline

		set netline -1
	}

	#
	# Place Individual Hosts
	#

	set name_space $row_height

	set vert TOP

	for { set i 0 } { $i < $nhost } { set i [ expr $i + 1 ] } \
	{
		#
		# Get Host Info
		#

		set h $host_list($i)

		set state [ lindex $h 4 ]

		#
		# If ON, Create Host Image
		#

		if { $state == "ON" } \
		{
			set iwt [ lindex $h 2 ]
			set iht [ lindex $h 3 ]

			set iconid [ lindex $h 9 ]
			set nameid [ lindex $h 10 ]
			set boxid [ lindex $h 11 ]
			set linkid [ lindex $h 12 ]

			#
			# Place Icon
			#

			if { $vert == "TOP" } \
			{
				set ix [ expr $Xtop + ( $iwt / 2 ) ]

				set iy [ expr -1 * ( ( $iht / 2 ) + $name_space \
					+ $icon_border + $net_space ) ]
			} \

			else \
			{
				set ix [ expr $Xbot + ( $iwt / 2 ) ]

				set iy [ expr ( $iht / 2 ) + $icon_border + $net_space ]
			}

			$NET_C coords $iconid $ix $iy

			#
			# Place Host Name
			#

			set ny [ expr $iy + ( $iht / 2 ) + ( $row_height / 2 ) ]

			$NET_C coords $nameid $ix $ny

			#
			# Place Bounding Box
			#

			if { $vert == "TOP" } \
			{
				set bx1 [ expr $Xtop - $icon_border ]

				set bx2 [ expr $Xtop + $iwt + $icon_border ]
			} \

			else \
			{
				set bx1 [ expr $Xbot - $icon_border ]

				set bx2 [ expr $Xbot + $iwt + $icon_border ]
			}

			set by1 [ expr $iy - ( $iht / 2 ) - $icon_border ]

			set by2 [ expr $by1 + $iht + $name_space + $icon_border ]

			$NET_C coords $boxid $bx1 $by1 $bx2 $by2

			#
			# Place Network Link
			#

			if { $nactive > 1 } \
			{
				if { $vert == "TOP" } \
					{ set ly $by2 } \

				else \
					{ set ly $by1 }
			} \

			else \
				{ set ly 0 }

			$NET_C coords $linkid $ix 0 $ix $ly

			#
			# Toggle TOP / BOT vert flag
			#

			if { $vert == "TOP" } \
			{
				set Xtop [ expr $Xtop + $iwt + $icon_space \
					+ ( 2 * $icon_border ) ]

				set vert "BOT"
			} \

			else \
			{
				set Xbot [ expr $Xbot + $iwt + $icon_space \
					+ ( 2 * $icon_border ) ]

				set vert "TOP"
			}
		}
	}

	#debug_proc arrangeNetworkHosts exit
}

proc infoNetworkHosts { } \
{
	#debug_proc infoNetworkHosts entry

	global icon_border
	global icon_space
	global host_list
	global nhost

	#
	# Initialize Working Vars
	#

	set startwt_top -1

	set startwt_bot -1

	set endwt_top -1

	set endwt_bot -1

	set vert "TOP"

	set nactive 0

	set topwt 0

	set botwt 0

	#
	# Process Host List
	#

	for { set i 0 } { $i < $nhost } { set i [ expr $i + 1 ] } \
	{
		set h $host_list($i)

		set state [ lindex $h 4 ]

		if { $state == "ON" } \
		{
			set wt [ lindex $h 2 ]

			if { $vert == "TOP" } \
			{
				set topwt [ expr $topwt + $wt + $icon_space \
					+ ( 2 * $icon_border ) ]

				if { $startwt_top == -1 } \
				{
					set startwt_top $wt
				}

				set endwt_top $wt

				set vert "BOT"
			} \

			else \
			{
				set botwt [ expr $botwt + $wt + $icon_space \
					+ ( 2 * $icon_border ) ]

				if { $startwt_bot == -1 } \
				{
					set startwt_bot $wt
				}

				set endwt_bot $wt

				set vert "TOP"
			}

			set nactive [ expr $nactive + 1 ]
		}
	}

	set topwt [ expr $topwt - $icon_space - ( 2 * $icon_border ) ]

	set botwt [ expr $botwt - $icon_space - ( 2 * $icon_border ) ]

	#
	# Determine Largest Total Width
	#

	if { $topwt > $botwt } \
		{ set totalwt $topwt }\

	else \
		{ set totalwt $botwt }

	#
	# Determine Smallest Starting Host Width
	#

	if { $startwt_bot != -1 } \
	{
		if { $startwt_top < $startwt_bot } \
			{ set startwt $startwt_top }\

		else \
			{ set startwt $startwt_bot }
	} \

	else \
		{ set startwt $startwt_top }

	#
	# Determine Ending Host Width
	#

	set top [ expr $topwt - ( $endwt_top / 2 ) ]

	if { $startwt_bot != -1 } \
	{
		set bot [ expr $botwt - ( $endwt_bot / 2 ) ]

		if { $top > $bot } \
			{ set endwt $endwt_top }\

		else \
			{ set endwt $endwt_bot }
	} \

	else \
		{ set endwt $endwt_top }

	return [ list $totalwt $startwt $endwt $nactive ]

	#debug_proc infoNetworkHosts exit
}

proc viewSelect { view label menuvar setflag } \
{
	#debug_proc viewSelect entry

	global $menuvar

	global min_main_height
	global min_main_width
	global min_net_height
	global min_st_height
	global height_left
	global ctrl_height
	global net_active
	global net_height
	global net_width
	global ct_active
	global to_active
	global st_active
	global ut_active
	global st_height
	global st_width
	global ut_state
	global ctrl_y
	global net_y
	global scale
	global st_y

	set state [ expr $$menuvar ]

	if { $setflag == "TRUE" } \
	{
		if { $state == "ON" } \
		{
			set $menuvar OFF

			set state OFF
		} \

		else \
		{
			set $menuvar ON

			set state ON
		}
	}

	if { $view == "network" } \
	{
		if { $state == "ON" } \
		{
			set min_main_height \
				[ expr $min_main_height + $min_net_height ]

			checkMainHeight

			set net_active TRUE

			if { $st_active == "TRUE" } \
			{
				set net_height [ expr $height_left / 2 ]

				if { $net_height < $min_net_height } \
					{ set net_height $min_net_height }

				set st_height [ expr $height_left - $net_height ]

				if { $st_height < $min_st_height } \
				{
					set net_height [ expr $net_height - \
						( $min_st_height - $st_height ) ]

					set st_height $min_st_height
				}
			} \

			else \
				{ set net_height $height_left }
		} \

		else \
		{
			set net_active FALSE

			set net_height 2

			if { $st_active == "TRUE" } \
				{ set st_height $height_left }

			set min_main_height \
				[ expr $min_main_height - $min_net_height ]
		}

		set ctrl_y [ expr $net_y + $net_height ]

		set st_y [ expr $ctrl_y + $ctrl_height ]

		layout_main_panel

		wm minsize .xpvm $min_main_width $min_main_height
	} \

	elseif { $view == "space_time" } \
	{
		if { $state == "ON" } \
		{
			set min_main_height \
				[ expr $min_main_height + $min_st_height ]

			checkMainHeight

			set st_active TRUE

			if { $net_active == "TRUE" } \
			{
				set net_height [ expr $height_left / 2 ]

				if { $net_height < $min_net_height } \
					{ set net_height $min_net_height }

				set st_height [ expr $height_left - $net_height ]

				if { $st_height < $min_st_height } \
				{
					set net_height [ expr $net_height - \
						( $min_st_height - $st_height ) ]

					set st_height $min_st_height
				}
			} \

			else \
				{ set st_height $height_left }
		} \

		else \
		{
			set st_active FALSE

			set st_height 0

			if { $net_active == "TRUE" } \
				{ set net_height $height_left }

			set min_main_height \
				[ expr $min_main_height - $min_st_height ]
		}

		set ctrl_y [ expr $net_y + $net_height ]

		set st_y [ expr $ctrl_y + $ctrl_height ]

		layout_main_panel

		wm minsize .xpvm $min_main_width $min_main_height
	} \

	elseif { $view == "utilization" } \
	{
		if { $state == "ON" } \
		{
			wm deiconify .utilization

			set ut_active TRUE

			set state [ lindex $ut_state 0 ]

			if { "$state" != "none" } \
			{
				set esec	[ lindex $state 2 ]
				set eusec	[ lindex $state 3 ]

				set rcnt [ lindex $state 4 ]
				set scnt [ lindex $state 5 ]
				set icnt [ lindex $state 6 ]

				set state [ list $esec $eusec $esec $eusec \
					$rcnt $scnt $icnt -1 -1 -1 1 ]

				set ut_state [ linsert $ut_state 0 $state ]
			}
		} \

		else \
		{
			wm withdraw .utilization

			set ut_active FALSE

			set state [ lindex $ut_state 0 ]

			if { "$state" != "none" } \
			{
				set esec	[ lindex $state 2 ]
				set eusec	[ lindex $state 3 ]

				set rcnt [ lindex $state 4 ]
				set scnt [ lindex $state 5 ]
				set icnt [ lindex $state 6 ]

				set state [ list $esec $eusec $esec $eusec \
					$rcnt $scnt $icnt -1 -1 -1 0 ]

				set ut_state [ linsert $ut_state 0 $state ]
			}
		}
	} \

	elseif { $view == "call_trace" } \
	{
		if { $state == "ON" } \
		{
			wm deiconify .call_trace

			set ct_active TRUE

			updateCallTrace
		} \

		else \
		{
			wm withdraw .call_trace

			set ct_active FALSE
		}
	} \

	elseif { $view == "task_output" } \
	{
		if { $state == "ON" } \
		{
			wm deiconify .task_output

			set to_active TRUE

			updateTaskOutput
		} \

		else \
		{
			wm withdraw .task_output

			set to_active FALSE
		}
	}

	#debug_proc viewSelect exit
}

proc checkMainHeight { } \
{
	#debug_proc checkMainHeight entry

	global min_main_height
	global start_main_y
	global height_left
	global main_height
	global ctrl_height

	set ht [ winfo height .xpvm ]

	if { $ht < $min_main_height } \
	{
		set wt [ winfo width .xpvm ]

		set geom "[ expr $wt ]x[ expr $min_main_height ]"

		wm geometry .xpvm $geom

		update

		set height_left \
			[ expr $main_height - $start_main_y - $ctrl_height ]
	}

	#debug_proc checkMainHeight exit
}

proc adjust_main_panel { action y } \
{
	#debug_proc adjust_main_panel entry

	global min_net_height
	global min_st_height
	global ctrl_height
	global hold_motion
	global net_active
	global net_height
	global st_active
	global st_height
	global adjust_y
	global ctrl_y
	global nest_y
	global net_y
	global st_y

	if { $net_active != "TRUE" || $st_active != "TRUE" } \
		{ return }

	set ADJ .xpvm.controls.adjust

	if { $action == "press" } \
	{
		$ADJ configure -state active -relief sunken

		set hold_motion 0

		set nest_y NONE

		set adjust_y $y
	} \

	elseif { $action == "release" } \
	{
		$ADJ configure -state normal -relief raised
	} \

	elseif { $action == "motion" } \
	{
		if { $hold_motion == 0 } \
		{
			set hold_motion 1

			set first 1

			while { $first == 1 || $nest_y != "NONE" } \
			{
				if { $first == 1 } \
					{ set first 0 } \

				else \
				{
					set ry $nest_y

					set nest_y NONE

					set rooty [ winfo rooty $ADJ ]

					set y [ expr $ry - $rooty ]
				}

				set delta_y [ expr $y - $adjust_y ]

				if { $delta_y != 0 } \
				{
					set rooty [ winfo rooty $ADJ ]

					set ry [ expr $y + $rooty ]

					set net_height [ expr $net_height + $delta_y ]

					if { $net_height < $min_net_height } \
					{
						set delta_y [ expr $delta_y + \
							( $min_net_height - $net_height ) ]

						set net_height $min_net_height
					}

					set st_height [ expr $st_height - $delta_y ]

					if { $st_height < $min_st_height } \
					{
						set delta_y [ expr $delta_y - \
							( $min_st_height - $st_height ) ]

						set net_height [ expr $net_height - \
							( $min_st_height - $st_height ) ]

						set st_height $min_st_height
					}

					set ctrl_y [ expr $net_y + $net_height ]

					set st_y [ expr $ctrl_y + $ctrl_height ]

					layout_main_panel

					set rooty [ winfo rooty $ADJ ]

					set adjust_y [ expr $ry - [ winfo rooty $ADJ ] ]
				}
			}

			set hold_motion 0
		} \

		else \
		{
			set rooty [ winfo rooty $ADJ ]

			set nest_y [ expr $rooty + $y ]
		}
	}

	#debug_proc adjust_main_panel exit
}

proc change_st_height { way } \
{
	#debug_proc change_st_height entry

	global st_label_ht
	global st_rect_ht

	if { $way == "shrink" } \
	{
		setMsg "Shrinking Task Height..."

		set st_label_ht [ expr $st_label_ht - 1 ]

		set st_rect_ht [ expr ( 8 * $st_label_ht ) / 20 ]
	} \

	else \
	{
		setMsg "Growing Task Height..."

		set st_label_ht [ expr $st_label_ht + 1 ]

		set st_rect_ht [ expr ( 8 * $st_label_ht ) / 20 ]
	}

	if { $st_label_ht < 4 } \
		{ set st_label_ht 4 }

	if { $st_rect_ht < 3 } \
		{ set st_rect_ht 3 }

	arrangeTasks

	setMsg "Task Height Adjusted."

	#debug_proc change_st_height exit
}

proc resize_main_panel { } \
{
	#debug_proc resize_main_panel entry

	global min_net_height
	global min_st_height
	global start_main_y
	global height_left
	global ctrl_height
	global main_height
	global ctrl_width
	global main_width
	global net_active
	global net_height
	global net_width
	global st_active
	global st_height
	global st_width
	global ctrl_y
	global net_y
	global st_y

	set ht [ winfo height .xpvm ]
	set wt [ winfo width .xpvm ]

	if { $main_width != $wt || $main_height != $ht } \
	{
		set main_height $ht
		set main_width $wt

		set height_left \
			[ expr $main_height - $start_main_y - $ctrl_height ]

		if { $net_active == "TRUE" } \
		{
			set net_height [ expr ( $net_height * $height_left ) \
				/ ( $net_height + $st_height ) ]

			if { $net_height < $min_net_height } \
				{ set net_height $min_net_height }
		} \

		else \
			{ set net_height 2 }

		if { $st_active == "TRUE" } \
		{
			set st_height [ expr $height_left - $net_height ]

			if { $st_height < $min_st_height } \
			{
				set net_height [ expr $net_height + \
					( $min_st_height - $st_height ) ]

				set st_height $min_st_height
			}
		} \

		else \
			{ set st_height 0 }

		set ctrl_width $wt
		set net_width $wt
		set st_width $wt

		set ctrl_y [ expr $net_y + $net_height ]

		set st_y [ expr $ctrl_y + $ctrl_height ]

		layout_main_panel

		fix_menus_resize
	}

	#debug_proc resize_main_panel exit
}

proc layout_main_panel { } \
{
	#debug_proc layout_main_panel entry

	global st_labels_width
	global border_space
	global scroll_width
	global main_height
	global ctrl_height
	global net_cheight
	global main_width
	global ctrl_width
	global net_cwidth
	global row_height
	global st_cheight
	global net_active
	global net_height
	global net_width
	global st_cwidth
	global st_active
	global st_lwidth
	global st_height
	global st_width
	global ctrl_x
	global ctrl_y

	#
	# Status Message Label
	#

	set msg_wt [ expr $main_width - (2 * $border_space) ]

	place .xpvm.message -width $msg_wt

	#
	# Layout Network View
	#

	if { $net_active == "TRUE" } \
	{
		set net_cheight [ expr $net_height - $scroll_width \
			- (2 * $row_height) - (2 * $border_space) ]

		set net_cwidth [ expr $net_width - $scroll_width \
			- (2 * $border_space)]

		layout_net_panel
	} \

	else \
		{ place forget .xpvm.network }

	#
	# Layout View Select & Playback Controls
	#

	set CTRL .xpvm.controls

	set x [ expr $ctrl_width - $border_space ]

	place $CTRL.overwrite -x $x

	update

	set x [ expr [ left $CTRL.overwrite ] - $border_space ]

	place $CTRL.playback -x $x

	update

	set fewt [ expr [ left $CTRL.playback ] \
		- [ winfo x $CTRL.file ] - [ winfo width $CTRL.file ] \
		- $border_space ]

	place $CTRL.file_entry -width $fewt

	place $CTRL -x $ctrl_x -y $ctrl_y \
		-width $ctrl_width -height $ctrl_height

	#
	# Handle Views Menu (if up)
	#

	set ckvm [ winfo ismapped .xpvm.views_menu ]

	if { $ckvm == 1 } \
	{
		set VSB .xpvm.controls.view_select

		set VM .xpvm.views_menu

		set x [ expr $ctrl_x + [ winfo x $VSB ] ]
		set y [ expr $ctrl_y + [ winfo y $VSB ] \
			+ [ winfo height $VSB ] ]

		set ht [ winfo height $VM ]
		set wt [ winfo width $VM ]

		set ex [ expr $x + $wt ]
		set ey [ expr $y + $ht ]

		if { $ex > $main_width } \
			{ set x [ expr $main_width - $wt ] }

		if { $ey > $main_height } \
			{ set y [ expr $main_height - $ht ] }

		if { $x < 0 } { set x 0 }

		if { $y < 0 } { set y 0 }

		place $VM -x $x -y $y
	}

	#
	# Layout Space-Time View
	#

	if { $st_active == "TRUE" } \
	{
		set st_lwidth [ expr $st_labels_width + $scroll_width ]

		set st_cheight [ expr $st_height - $scroll_width \
			- (3 * $row_height) - (7 * $border_space / 2) ]

		set st_cwidth [ expr $st_width - $st_lwidth \
			- (2 * $border_space) ]

		layout_st_panel
	} \

	else \
		{ place forget .xpvm.space_time }

	update

	#debug_proc layout_main_panel exit
}

proc layout_net_panel { } \
{
	#debug_proc layout_net_panel entry

	global border_space
	global scroll_width
	global net_cheight
	global net_cwidth
	global row_height
	global net_scroll
	global net_active
	global net_height
	global net_width
	global net_xview
	global net_yview
	global net_size
	global net_x
	global net_y

	set NET_C .xpvm.network.canvas

	set NET_SBH .xpvm.network.horiz_sb
	set NET_SBV .xpvm.network.vert_sb

	place .xpvm.network -x $net_x -y $net_y \
		-width $net_width -height $net_height

	place .xpvm.network.title -relx 0.41 -y 0

	set net_sbx $border_space

	set net_cy $row_height

	place $NET_SBV -x $net_sbx -y $net_cy \
		-width $scroll_width -height $net_cheight

	scrollSet $NET_SBV \
		[ expr $net_size / $net_scroll ] \
		[ expr $net_cheight / $net_scroll ] \
		$net_yview

	set net_cx [ expr $net_sbx + $scroll_width ]

	place $NET_C -x $net_cx -y $net_cy \
		-width $net_cwidth -height $net_cheight

	set net_sby [ expr $net_cy + $net_cheight ]

	place $NET_SBH -x $net_cx -y $net_sby \
		-width $net_cwidth -height $scroll_width

	scrollSet $NET_SBH \
		[ expr $net_size / $net_scroll ] \
		[ expr $net_cwidth / $net_scroll ] \
		$net_xview


	set kly [ expr $net_sby + $scroll_width + $border_space ]

	set kky [ expr $kly + ($row_height / 6) ]

	place .xpvm.network.close -x $border_space -y $kly

	place .xpvm.network.active_label -relx 0.21 -y $kly
	place .xpvm.network.system_label -relx 0.44 -y $kly
	place .xpvm.network.empty_label -relx 0.70 -y $kly

	update

	place .xpvm.network.active_box \
		-x [ right .xpvm.network.active_label ] -y $kky \
		-width 13 -height 17

	place .xpvm.network.system_box \
		-x [ right .xpvm.network.system_label ] -y $kky \
		-width 13 -height 17

	place .xpvm.network.empty_box \
		-x [ right .xpvm.network.empty_label ] -y $kky \
		-width 13 -height 17

	update

	#debug_proc layout_net_panel exit
}

proc layout_st_panel { } \
{
	#debug_proc layout_st_panel entry

	global st_canvas_height
	global st_labels_width
	global border_space
	global scroll_width
	global row_height
	global st_cheight
	global st_cwidth
	global st_active
	global st_height
	global st_width
	global st_xview
	global st_yview
	global timex
	global st_x
	global st_y

	set ST .xpvm.space_time

	set ST_L $ST.labels

	set ST_C $ST.canvas

	set ST_SBH $ST.horiz_sb
	set ST_SBV $ST.vert_sb

	place $ST -x $st_x -y $st_y -width $st_width -height $st_height

	set stx $border_space
	set sty [ expr $border_space / 2 ]

	place $ST.title -relx 0.32 -y $sty

	set st_cy [ expr $sty + $row_height ]

	place $ST_SBV -x $stx -y $st_cy \
		-width $scroll_width -height $st_cheight

	scrollSet $ST_SBV $st_canvas_height $st_cheight $st_yview

	set st_lx [ expr $stx + $scroll_width ]

	place $ST_L -x $st_lx -y $st_cy \
		-width $st_labels_width -height $st_cheight

	set st_cx [ expr $st_lx + $st_labels_width ]

	place $ST_C -x $st_cx -y $st_cy \
		-width $st_cwidth -height $st_cheight

	set stsby [ expr $st_cy + $st_cheight ]

	place $ST_SBH -x $st_cx -y $stsby \
		-width $st_cwidth -height $scroll_width

	scrollSet $ST_SBH $timex $st_cwidth $st_xview

	set stcby [ expr $stsby + ( $border_space / 2 ) ]

	place $ST.close -x $border_space -y $stcby

	update

	set cbx [ expr $border_space + [ winfo width $ST.close ] ]

	set cbwt [ expr $st_cx - $cbx ]

	set shrinkx [ expr $cbx + ( $cbwt / 3 ) ]

	place $ST.shrink -x $shrinkx -y $stcby -anchor n

	set growx [ expr $cbx + ( 2 * $cbwt / 3 ) ]

	place $ST.grow -x $growx -y $stcby -anchor n

	set stmy [ expr $stcby + $row_height + $border_space ]

	place $ST.query -x $border_space -y $stmy \
		-width [ expr $st_width - (2 * $border_space) ]

	set kly [ expr $stmy + $row_height + ($border_space / 2) ]

	set kky [ expr $kly + ($row_height * 0.4) ]

	place $ST.computing_label -relx 0.10 -y $kly -anchor n
	place $ST.overhead_label -relx 0.36 -y $kly -anchor n
	place $ST.waiting_label -relx 0.60 -y $kly -anchor n
	place $ST.message_label -relx 0.83 -y $kly -anchor n

	update

	place $ST.computing_box \
		-x [ right $ST.computing_label ] -y $kky \
		-width 30 -height 10

	place $ST.overhead_box \
		-x [ right $ST.overhead_label ] -y $kky \
		-width 30 -height 10

	place $ST.waiting_box \
		-x [ right $ST.waiting_label ] -y $kky \
		-width 30 -height 10

	place $ST.message_box \
		-x [ right $ST.message_label ] \
		-y [ expr $kky + 3 ] \
		-width 30 -height 2

	update

	#debug_proc layout_st_panel exit
}

proc layout_spawn_dialog { } \
{
	#debug_proc layout_spawn_dialog entry

	global spawn_flags_trace
	global border_space
	global spawn_where
	global spawn_width

	set SP .xpvm.spawn

	place $SP.cmd -x $border_space -y $border_space

	update

	set nwt [ expr $spawn_width - [ winfo width $SP.cmd ] ]

	place $SP.cmd_entry \
		-x [ right $SP.cmd ] -y $border_space -width $nwt

	place $SP.flags -x $border_space -y [ below $SP.cmd ]

	update

	set indentx [ expr 2 * $border_space ]

	place $SP.flags_debug -x $indentx -y [ below $SP.flags ]

	update

	set try [ below $SP.flags_debug ]

	place $SP.flags_trace -x $indentx -y $try

	if { $spawn_flags_trace == "ON" } \
	{
		place $SP.trace_mask -anchor ne \
			-x [ expr $spawn_width - $border_space ] -y $try
	} \

	else \
		{ place forget $SP.trace_mask }

	update

	place $SP.flags_front \
		-x $indentx -y [ below $SP.flags_trace ]

	update

	place $SP.flags_compl \
		-x $indentx -y [ below $SP.flags_front ]

	update

	place $SP.where -x $border_space -y [ below $SP.flags_compl ]

	update

	place $SP.where_host \
		-x $indentx -y [ below $SP.where ]

	update

	place $SP.where_arch \
		-x $indentx -y [ below $SP.where_host ]

	update

	place $SP.where_default \
		-x $indentx -y [ below $SP.where_arch ]

	update

	if { $spawn_where != "Default" } \
	{
		set ly [ below $SP.where_default ]

		$SP.loc configure -text $spawn_where

		place $SP.loc -x $border_space -y $ly

		update

		set lwt [ expr $spawn_width - [ winfo width $SP.loc ] ]

		place $SP.loc_entry -x [ right $SP.loc ] -y $ly -width $lwt

		set ny [ below $SP.loc ]
	} \

	else \
	{
		place forget $SP.loc

		place forget $SP.loc_entry

		set ny [ below $SP.where_default ]
	}

	place $SP.ntasks -x $border_space -y $ny

	update

	set twt [ expr $spawn_width - [ winfo width $SP.ntasks ] ]

	place $SP.ntasks_entry -x [ right $SP.ntasks ] -y $ny -width $twt

	update

	set y [ below $SP.ntasks ]

	place $SP.close_on_start -x $border_space -y $y

	update

	set y [ below $SP.close_on_start ]

	place $SP.close -x $border_space -y $y

	place $SP.start_append -anchor n -relx 0.50 -y $y

	place $SP.start -anchor ne -x $spawn_width -y $y

	update

	$SP configure \
		-width [ expr $spawn_width + (2 * $border_space) + 8 ] \
		-height [ expr $y + [ winfo height $SP.close ] \
			+ $border_space + 4 ]

	#debug_proc layout_spawn_dialog exit
}

proc layout_kill_dialog { } \
{
	#debug_proc layout_kill_dialog entry

	global scroll_width
	global border_space
	global kill_cheight
	global kill_cwidth
	global kill_height
	global kill_width
	global row_height

	set KL .xpvm.kill

	set KL_C $KL.canvas

	set KL_CW $KL_C.win

	set KL_SBH $KL.horiz_sb
	set KL_SBV $KL.vert_sb

	$KL configure -width $kill_width -height $kill_height

	set kill_cheight [ expr $kill_height - $scroll_width \
		- (2 * $row_height) - (3 * $border_space) ]

	set kill_cwidth [ expr $kill_width - $scroll_width \
		- (2 * $border_space)]

	set x $border_space
	set y [ expr $row_height + ($border_space / 2) ]

	place $KL_SBV -x $x -y $y \
		-width $scroll_width -height $kill_cheight

	set cx [ expr $x + $scroll_width ]

	set ly [ expr $border_space / 2 ]

	place $KL.tasks -x $cx -y $ly

	place $KL_C -x $cx -y $y \
		-width $kill_cwidth -height $kill_cheight
	
	set sby [ expr $y + $kill_cheight ]

	place $KL_SBH -x $cx -y $sby \
		-width $kill_cwidth -height $scroll_width
	
	set cly [ expr $sby + $scroll_width + $border_space ]

	place $KL.close -x $x -y $cly

	place $KL.refresh -relx 0.50 -y $cly -anchor n

	set kax [ expr $kill_width - $border_space ]

	place $KL.kill_all -x $kax -y $cly -anchor ne

	update

	#debug_proc layout_kill_dialog exit
}

proc signal_button { name index } \
{
	#debug_proc signal_button entry

	global active_fg_color
	global selector_color
	global frame_border
	global fg_color
	global SG_LCW

	radiobutton $SG_LCW.$name -text $index -value $index \
		-bd $frame_border -relief flat \
		-variable signal_selected \
		-selector $selector_color -foreground $fg_color \
		-activeforeground $active_fg_color

	#debug_proc signal_button exit
}

proc layout_signal_dialog { } \
{
	#debug_proc layout_signal_dialog entry

	global signal_list_height
	global signal_list_width
	global signal_cheight
	global signal_cwidth
	global signal_height
	global signal_width
	global scroll_width
	global border_space
	global frame_border
	global row_height

	set SG .xpvm.signal

	set SG_C $SG.canvas
	set SG_CW $SG_C.win

	set SG_SBH $SG.horiz_sb
	set SG_SBV $SG.vert_sb

	set SG_LF $SG.list_frame
	set SG_LC $SG_LF.canvas
	set SG_LCW $SG_LC.win

	set SG_LSBV $SG.list_vert_sb

	$SG configure -width $signal_width -height $signal_height

	set signal_cheight [ expr $signal_height - $scroll_width \
		- (2 * $row_height) - (3 * $border_space) ]

	set signal_cwidth [ expr $signal_width - (2 * $scroll_width) \
		- $signal_list_width - (3 * $border_space)]

	set x $border_space
	set y [ expr $row_height + ($border_space / 2) ]

	place $SG_SBV -x $x -y $y \
		-width $scroll_width -height $signal_cheight

	set cx [ expr $x + $scroll_width ]

	set ly [ expr $border_space / 2 ]

	place $SG.tasks -x $cx -y $ly

	place $SG_C -x $cx -y $y \
		-width $signal_cwidth -height $signal_cheight

	set lx [ expr $cx + $signal_cwidth + $border_space ]

	place $SG_LSBV -x $lx -y $y \
		-width $scroll_width -height $signal_cheight

	set lcx [ expr $lx + $scroll_width ]

	place $SG.signals -x $lcx -y $ly

	place $SG_LF -x $lcx -y $y \
		-width $signal_list_width -height $signal_cheight

	place $SG_LC -x 0 -y 0 \
		-width [ expr $signal_list_width - (2 * $frame_border) ] \
		-height [ expr $signal_cheight - (2 * $frame_border) ]

	place $SG_LCW -x 0 -y 0

	set bx $frame_border

	place $SG_LCW.hup	 -x $bx -y $frame_border ; update
	place $SG_LCW.int	 -x $bx -y [ below $SG_LCW.hup ] ;	 update
	place $SG_LCW.quit	 -x $bx -y [ below $SG_LCW.int ] ;	 update
	place $SG_LCW.ill	 -x $bx -y [ below $SG_LCW.quit ] ;	 update
	place $SG_LCW.trap	 -x $bx -y [ below $SG_LCW.ill ] ;	 update
	place $SG_LCW.abrt	 -x $bx -y [ below $SG_LCW.trap ] ;	 update
	place $SG_LCW.emt	 -x $bx -y [ below $SG_LCW.abrt ] ;	 update
	place $SG_LCW.fpe	 -x $bx -y [ below $SG_LCW.emt ] ;	 update
	place $SG_LCW.kill	 -x $bx -y [ below $SG_LCW.fpe ] ;	 update
	place $SG_LCW.bus	 -x $bx -y [ below $SG_LCW.kill ] ;	 update
	place $SG_LCW.segv	 -x $bx -y [ below $SG_LCW.bus ] ;	 update
	place $SG_LCW.sys	 -x $bx -y [ below $SG_LCW.segv ] ;	 update
	place $SG_LCW.pipe	 -x $bx -y [ below $SG_LCW.sys ] ;	 update
	place $SG_LCW.alrm	 -x $bx -y [ below $SG_LCW.pipe ] ;	 update
	place $SG_LCW.term	 -x $bx -y [ below $SG_LCW.alrm ] ;	 update
	place $SG_LCW.urg	 -x $bx -y [ below $SG_LCW.term ] ;	 update
	place $SG_LCW.stop	 -x $bx -y [ below $SG_LCW.urg ] ;	 update
	place $SG_LCW.tstp	 -x $bx -y [ below $SG_LCW.stop ] ;	 update
	place $SG_LCW.cont	 -x $bx -y [ below $SG_LCW.tstp ] ;	 update
	place $SG_LCW.chld	 -x $bx -y [ below $SG_LCW.cont ] ;	 update
	place $SG_LCW.ttin	 -x $bx -y [ below $SG_LCW.chld ] ;	 update
	place $SG_LCW.ttou	 -x $bx -y [ below $SG_LCW.ttin ] ;	 update
	place $SG_LCW.io	 -x $bx -y [ below $SG_LCW.ttou ] ;	 update
	place $SG_LCW.xcpu	 -x $bx -y [ below $SG_LCW.io ] ;	 update
	place $SG_LCW.xfsz	 -x $bx -y [ below $SG_LCW.xcpu ] ;	 update
	place $SG_LCW.vtalrm -x $bx -y [ below $SG_LCW.xfsz ] ;	 update
	place $SG_LCW.prof	 -x $bx -y [ below $SG_LCW.vtalrm ] ; update
	place $SG_LCW.winch	 -x $bx -y [ below $SG_LCW.prof ] ;	 update
	place $SG_LCW.lost	 -x $bx -y [ below $SG_LCW.winch ] ; update
	place $SG_LCW.usr1	 -x $bx -y [ below $SG_LCW.lost ] ;	 update
	place $SG_LCW.usr2	 -x $bx -y [ below $SG_LCW.usr1 ] ;	 update

	set signal_list_height [ expr [ below $SG_LCW.usr2 ] \
		+ $frame_border ]

	set sby [ expr $y + $signal_cheight ]

	place $SG_SBH -x $cx -y $sby \
		-width $signal_cwidth -height $scroll_width
	
	set cly [ expr $sby + $scroll_width + $border_space ]

	place $SG.close -x $x -y $cly

	place $SG.refresh -relx 0.50 -y $cly -anchor n

	set sax [ expr $signal_width - $border_space ]

	place $SG.signal_all -x $sax -y $cly -anchor ne

	update

	#debug_proc layout_signal_dialog exit
}

proc resize_help_win { index } \
{
	#debug_proc resize_help_win entry

	global min_help_height

	global $index\_height
	global $index\_width

	set WIN .$index\_help_win

	set ht [ winfo height $WIN ]
	set wt [ winfo width $WIN ]

	if { [ expr $$index\_width ] != $wt \
		|| [ expr $$index\_height ] != $ht } \
	{
		set $index\_height $ht
		set $index\_width $wt

		layout_help_win $index
	}

	#debug_proc resize_help_win exit
}

proc layout_help_win { index } \
{
	#debug_proc layout_help_win entry

	global border_space
	global scroll_width
	global row_height

	global $index\_canvas_height
	global $index\_canvas_width
	global $index\_cheight
	global $index\_cwidth
	global $index\_height
	global $index\_width
	global $index\_xview
	global $index\_yview

	set WIN .$index\_help_win

	set WIN_C $WIN.canvas

	set WIN_SBH $WIN.horiz_sb
	set WIN_SBV $WIN.vert_sb

	place $WIN.title -relx 0.50 -y 0 -anchor n

	set sbx $border_space

	set cy [ expr $row_height ]

	set $index\_cheight [ expr $$index\_height - $scroll_width \
		- (2 * $row_height) - (2 * $border_space) ]

	set $index\_cwidth [ expr $$index\_width - $scroll_width \
		- (2 * $border_space)]

	place $WIN_SBV -x $sbx -y $cy \
		-width $scroll_width -height [ expr $$index\_cheight ]

	scrollSet $WIN_SBV \
		[ expr $$index\_canvas_height / $row_height ] \
		[ expr $$index\_cheight / $row_height ] \
		[ expr $$index\_yview ]

	set cx [ expr $sbx + $scroll_width ]

	place $WIN_C -x $cx -y $cy \
		-width [ expr $$index\_cwidth ] \
		-height [ expr $$index\_cheight ]

	set sby [ expr $cy + $$index\_cheight ]

	place $WIN_SBH -x $cx -y $sby \
		-width [ expr $$index\_cwidth ] -height $scroll_width

	scrollSet $WIN_SBH \
		[ expr $$index\_canvas_width / $row_height ] \
		[ expr $$index\_cwidth / $row_height ] \
		[ expr $$index\_xview ]

	set cly [ expr $sby + $scroll_width + $border_space ]

	place $WIN.close -x $border_space -y $cly

	update

	#debug_proc layout_help_win exit
}

proc fix_menus_resize { } \
{
	#debug_proc fix_menus_resize entry

	replaceMenu .xpvm.hosts_menu .xpvm.hosts .xpvm

	replaceMenu .xpvm.tasks_menu .xpvm.tasks .xpvm

	replaceMenu .xpvm.reset_menu .xpvm.reset .xpvm

	replaceMenu .xpvm.help_menu .xpvm.help .xpvm
	replaceMenu .xpvm.tasks_help_menu .xpvm.help .xpvm
	replaceMenu .xpvm.views_help_menu .xpvm.help .xpvm

	replaceMenu .xpvm.views_menu .xpvm.controls.view_select .xpvm

	update

	replaceSubMenu .xpvm.spawn .xpvm.tasks_menu \
		.xpvm.tasks_menu.butt_SPAWN .xpvm.spawn.cmd_entry

	replaceSubMenu .xpvm.systasks_menu .xpvm.tasks_menu \
		.xpvm.tasks_menu.butt_SYS_TASKS none

	update

	replaceMenu .xpvm.trace_mask_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.host_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.group_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.task_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.comm_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.buff_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.pack_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.unpack_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.info_ev_menu .xpvm.spawn.trace_mask .xpvm
	replaceMenu .xpvm.misc_ev_menu .xpvm.spawn.trace_mask .xpvm

	#debug_proc fix_menus_resize exit
}

proc resize_ut_panel { } \
{
	#debug_proc resize_ut_panel entry

	global ut_height
	global ut_width

	set ht [ winfo height .utilization ]
	set wt [ winfo width .utilization ]

	if { $ut_width != $wt || $ut_height != $ht } \
	{
		set ut_height $ht
		set ut_width $wt

		layout_ut_panel

		fix_ut_height
	}

	#debug_proc resize_ut_panel exit
}

proc layout_ut_panel { } \
{
	#debug_proc layout_ut_panel entry

	global border_space
	global scroll_width
	global row_height
	global ut_cheight
	global ut_cwidth
	global col_width
	global ut_height
	global ut_width
	global ut_xview
	global timex

	set UT_C .utilization.frame.canvas

	set UT_SBH .utilization.frame.horiz_sb

	set ut_cheight [ expr $ut_height - $scroll_width \
		- $row_height - (5 * $border_space) ]

	set ut_cwidth [ expr $ut_width \
		- (4 * $col_width) - (2 * $border_space) ]

	place .utilization.frame -x 0 -y 0 \
		-width $ut_width -height $ut_height

	set utx [ expr $border_space / 2 ]
	set uty [ expr $border_space / 2 ]

	place .utilization.frame.title -relx 0.33 -y $uty

	set utcy [ expr $uty + $row_height ]

	place .utilization.frame.xN -x $utx -y $utcy \
		-width $col_width -height $row_height

	update

	place .utilization.frame.xT \
		-x $utx -y [ below .utilization.frame.xN ] \
		-width $col_width -height $row_height

	update

	place .utilization.frame.xA \
		-x $utx -y [ below .utilization.frame.xT ] \
		-width $col_width -height $row_height

	update

	place .utilization.frame.xS \
		-x $utx -y [ below .utilization.frame.xA ] \
		-width $col_width -height $row_height

	update

	place .utilization.frame.xK \
		-x $utx -y [ below .utilization.frame.xS ] \
		-width $col_width -height $row_height

	update

	place .utilization.frame.xX \
		-x $utx -y [ below .utilization.frame.xK ] \
		-width $col_width -height $row_height

	set utcx [ expr $utx + ($border_space / 2) + (4 * $col_width) ]

	place .utilization.frame.ntasks -anchor ne -x $utcx -y $utcy

	place .utilization.frame.tick -anchor e \
		-x $utcx -y [ expr $utcy + ($ut_cheight / 2) ] \
		-width 8 -height 2

	place .utilization.frame.zero -anchor se \
		-x $utcx -y [ expr $utcy + $ut_cheight ]

	place $UT_C -x $utcx -y $utcy \
		-width $ut_cwidth -height $ut_cheight

	set utsby [ expr $utcy + $ut_cheight ]

	place $UT_SBH -x $utcx -y $utsby \
		-width $ut_cwidth -height $scroll_width

	scrollSet $UT_SBH $timex $ut_cwidth $ut_xview

	set kly [ expr $utsby + $scroll_width + $border_space ]

	set kky [ expr $kly + ($row_height / 6) ]

	place .utilization.frame.close \
		-x [ expr $col_width + $border_space ] -y $kly

	place .utilization.frame.computing_label -relx 0.21 -y $kly
	place .utilization.frame.overhead_label -relx 0.50 -y $kly
	place .utilization.frame.waiting_label -relx 0.77 -y $kly

	update

	place .utilization.frame.computing_box \
		-x [ right .utilization.frame.computing_label ] -y $kky \
		-width 10 -height 20

	place .utilization.frame.overhead_box \
		-x [ right .utilization.frame.overhead_label ] -y $kky \
		-width 10 -height 20

	place .utilization.frame.waiting_box \
		-x [ right .utilization.frame.waiting_label ] -y $kky \
		-width 10 -height 20

	update

	#debug_proc layout_ut_panel exit
}

proc fix_ut_height { } \
{
	#debug_proc fix_ut_height entry

	global ut_cheight
	global ut_state

	set UT_C .utilization.frame.canvas

	set HT $ut_cheight

	foreach state $ut_state \
	{
		if { "$state" != "none" } \
		{
			set valid [ lindex $state 10 ]

			if { $valid == 1 } \
			{
				set rcnt [ lindex $state 4 ]
				set scnt [ lindex $state 5 ]
				set icnt [ lindex $state 6 ]

				set c [ calcUtilCoords $rcnt $scnt $icnt ]

				set iy [ lindex $c 0 ]
				set sy [ lindex $c 1 ]
				set ry [ lindex $c 2 ]

				set rrectid [ lindex $state 7 ]

				if { $rrectid != -1 } \
					{ set_y_coords $UT_C $rrectid $ry $HT }

				set srectid [ lindex $state 8 ]

				if { $srectid != -1 } \
					{ set_y_coords $UT_C $srectid $sy $ry }

				set irectid [ lindex $state 9 ]

				if { $irectid != -1 } \
					{ set_y_coords $UT_C $irectid $iy $sy }

				update
			}
		}
	}

	#debug_proc fix_ut_height exit
}

proc resize_ct_panel { } \
{
	#debug_proc resize_ct_panel entry

	global ct_height
	global ct_width

	set ht [ winfo height .call_trace ]
	set wt [ winfo width .call_trace ]

	if { $ct_width != $wt || $ct_height != $ht } \
	{
		set ct_height $ht
		set ct_width $wt

		layout_ct_panel
	}

	#debug_proc resize_ct_panel exit
}

proc layout_ct_panel { } \
{
	#debug_proc layout_ct_panel entry

	global ct_canvas_height
	global ct_canvas_width
	global ct_labels_width
	global border_space
	global scroll_width
	global row_height
	global ct_cheight
	global ct_cwidth
	global ct_lwidth
	global ct_height
	global ct_width
	global ct_xview
	global ct_yview

	set CT_L .call_trace.frame.labels

	set CT_C .call_trace.frame.canvas

	set CT_SBH .call_trace.frame.horiz_sb
	set CT_SBV .call_trace.frame.vert_sb

	set ct_lwidth [ expr $ct_labels_width + $scroll_width ]

	set ct_cheight [ expr $ct_height - $scroll_width \
		- $row_height - (3 * $border_space) ]

	set ct_cwidth [ expr $ct_width - $ct_lwidth \
		- (2 * $border_space) ]

	place .call_trace.frame \
		-x 0 -y 0 -width $ct_width -height $ct_height

	set ctx $border_space
	set cty [ expr $border_space / 2 ]

	place .call_trace.frame.title -x $ctx -y $cty

	update

	set qwt [ expr $ct_width - [ winfo width .call_trace.frame.title ] \
		- ( 2 * $border_space ) ]

	place .call_trace.frame.query -width $qwt \
		-x [ right .call_trace.frame.title ] -y $cty

	set cty [ expr $cty + $row_height ]

	place $CT_SBV -x $ctx -y $cty \
		-width $scroll_width -height $ct_cheight

	scrollSet $CT_SBV $ct_canvas_height $ct_cheight $ct_yview

	set ctlx [ expr $ctx + $scroll_width ]

	place $CT_L -x $ctlx -y $cty \
		-width $ct_labels_width -height $ct_cheight

	set ctcx [ expr $ctlx + $ct_labels_width ]

	place $CT_C -x $ctcx -y $cty \
		-width $ct_cwidth -height $ct_cheight

	set ctsby [ expr $cty + $ct_cheight ]

	place $CT_SBH -x $ctcx -y $ctsby \
		-width $ct_cwidth -height $scroll_width

	scrollSet $CT_SBH $ct_canvas_width $ct_cwidth $ct_xview

	set ctclx $border_space
	set ctcly [ expr $ctsby + ($border_space / 2) ]

	place .call_trace.frame.close -x $ctclx -y $ctcly

	update

	#debug_proc layout_ct_panel exit
}

proc resize_to_panel { } \
{
	#debug_proc resize_to_panel entry

	global to_height
	global to_width

	set ht [ winfo height .task_output ]
	set wt [ winfo width .task_output ]

	if { $to_width != $wt || $to_height != $ht } \
	{
		set to_height $ht
		set to_width $wt

		layout_to_panel
	}

	#debug_proc resize_to_panel exit
}

proc layout_to_panel { } \
{
	#debug_proc layout_to_panel entry

	global to_canvas_width
	global border_space
	global scroll_width
	global row_height
	global to_cheight
	global to_cwidth
	global to_height
	global to_lasty
	global to_width
	global to_xview
	global to_yview

	set TO .task_output

	set TO_C $TO.frame.canvas

	set TO_SBH $TO.frame.horiz_sb
	set TO_SBV $TO.frame.vert_sb

	set to_cheight [ expr $to_height - $scroll_width \
		- $row_height - (5 * $border_space) ]

	set to_cwidth [ expr $to_width - $scroll_width \
		- (2 * $border_space) ]

	place $TO.frame \
		-x 0 -y 0 -width $to_width -height $to_height

	set tox $border_space
	set toy [ expr $border_space / 2 ]

	place $TO.frame.title -x $tox -y $toy

	update

	place $TO.file_entry -x [ right $TO.frame.title ] -y $toy

	set toy [ expr $toy + $row_height + ( $border_space / 2 ) ]

	place $TO_SBV -x $tox -y $toy \
		-width $scroll_width -height $to_cheight

	scrollSet $TO_SBV \
		[ expr $to_lasty / $row_height ] \
		[ expr $to_cheight / $row_height ] \
		$to_yview

	set tocx [ expr $tox + $scroll_width ]

	place $TO_C -x $tocx -y $toy \
		-width $to_cwidth -height $to_cheight

	set tosby [ expr $toy + $to_cheight ]

	place $TO_SBH -x $tocx -y $tosby \
		-width $to_cwidth -height $scroll_width

	scrollSet $TO_SBH \
		[ expr $to_canvas_width / $row_height ] \
		[ expr $to_cwidth / $row_height ] \
		$to_xview


	set toclx $border_space
	set tocly [ expr $tosby + $scroll_width + ($border_space / 2) ]

	place $TO.frame.close -x $toclx -y $tocly

	update

	#debug_proc layout_to_panel exit
}

