
static char rcsid[] = 
	"$Id: pvm.c,v 2.310 1994/07/18 18:18:10 kohl Exp $";

#include "xpvm.h"

Tk_TimerProc *process_timer_proc();
Tk_TimerProc *recv_timer_proc();

Tk_IdleProc *process_event_proc();
Tk_IdleProc *recv_event_proc();

Tk_IdleProc *delete_host();
Tk_IdleProc *add_host();

Tk_TimerProc *recv_timer_proc( clientData )
ClientData clientData;
{
	Tk_DoWhenIdle( (Tk_IdleProc *) recv_event_proc, clientData );
}

Tk_IdleProc *recv_event_proc( clientData )
ClientData clientData;
{
	HOST H;

	char tmp[255];

	char *output;

	int *tids;

	int msgtag;
	int before;
	int found;
	int tusec;
	int tsec;
	int ecnt;
	int cnt;
	int eid;
	int len;
	int mid;
	int num;
	int tid;
	int src;
	int cc;
	int n;
	int i;

	int xxx;

	xxx = (int) clientData;

	/* printf( "+" ); fflush( stdout ); */

	if ( FALSE && !(xxx % 100) )
	{
		printf( "." );
		fflush( stdout );
	}

	/* Check for PVM Events */

	before = TRACE_PENDING;

	cnt = 0;

	while ( cnt < 10 &&
		( ( TRACE_OUT != NULL && (mid = pvm_nrecv( -1, -1 )) > 0 )
			|| (mid = pvm_nrecv( -1, 99 )) > 0
			|| (mid = pvm_nrecv( -1, 100 )) > 0 ) )
	{
		pvm_bufinfo( mid, &len, &msgtag, &src );

		/* Host Added */

		if ( msgtag == 99 && src == 0x80000000 )
		{
			pvm_upkint( &num, 1, 1 );

			tids = (int *) malloc( (unsigned) num * sizeof(int) );
			memcheck( tids, "Added Host TIDs" );

			pvm_upkint( tids, num, 1 );

			for ( i=0 ; i < num ; i++ )
				pvm_notify( PvmHostDelete, 100, 1, &(tids[i]) );

			update_hosts( tids, num );

			free( tids );
		}

		/* Host Deleted */

		else if ( msgtag == 100 && src == 0x80000000 )
		{
			pvm_upkint( &tid, 1, 1 );

			H = HOST_LIST;

			found = 0;

			while ( H != NULL && !found )
			{
				if ( H->pvmd_tid == tid )
				{
					if ( H->in_pvm == IN_PVM )
					{
						sprintf( tmp, "checkHostResult { {OFF %d} }",
							H->index );
					
						Tcl_Eval( interp, tmp );

						H->in_pvm = NOT_IN_PVM;
					}

					if ( TRACE_OUT != NULL )
					{
						update_trace_time( -1, -1 );

						store_host_del_event( H->name, tid );

						TRACE_PENDING++;
					}

					found++;
				}

				else
					H = H->next;
			}
		}

		/* PVM Trace Event */

		else if ( msgtag == 666 )
		{
			/* printf( "V" ); fflush( stdout ); */

			if ( TRACE_OUT != NULL )
			{
				/* printf( "S" ); fflush( stdout ); */

				pvm_upkint( &tsec, 1, 1 );
				pvm_upkint( &tusec, 1, 1 );
				pvm_upkint( &tid, 1, 1 );
				pvm_upkint( &eid, 1, 1 );

				update_trace_time( tsec, tusec );

				store_trace_event( tsec, tusec, tid, eid );

				TRACE_OVERWRITE_FLAG = FALSE;

				TRACE_PENDING++;
			}
		}

		/* PVM Output Event */

		else if ( msgtag == 667 )
		{
			/* printf( "O" ); fflush( stdout ); */

			if ( TRACE_OUT != NULL )
			{
				/* printf( "S" ); fflush( stdout ); */

				pvm_upkint( &tid, 1, 1 );
				pvm_upkint( &n, 1, 1 );

				if ( n > 0 )
				{
					output = (char *) malloc( (unsigned) (n + 1)
						* sizeof(char) );
					memcheck( output, "PVM Output String" );

					pvm_upkbyte( output, n, 1 );

					output[n] = '\0';

					ecnt = store_output_event( tid, output, n );
				}

				else
				{
					switch ( n )
					{
						case 0:
						{
							sprintf( tmp, "GOTEOF\n" );

							ecnt = store_output_event( tid, tmp,
								strlen( tmp ) );

							break;
						}

						case -1:
						{
							sprintf( tmp, "GOTSPAWN\n" );

							ecnt = store_output_event( tid, tmp,
								strlen( tmp ) );

							break;
						}

						case -2:
						{
							sprintf( tmp, "CREATION\n" );

							ecnt = store_output_event( tid, tmp,
								strlen( tmp ) );

							break;
						}

						default:
						{
							fprintf( stderr,
							"Console: unknown output msg t%x?\n",
								src );
						}
					}
				}

				TRACE_OVERWRITE_FLAG = FALSE;

				TRACE_PENDING += ecnt;
			}
		}

		/* Unknown Message */

		else
		{
			fprintf( stderr,
				"XPVM Console: msg from t%x code %d len %d ?\n",
				src, msgtag, len );
		}

		pvm_freebuf( mid );

		cnt++;
	}

	if ( TRACE_PENDING != before )
	{
		/* printf( "+ %d -> %d\n", before, TRACE_PENDING ); */

		/* printf( "X" ); fflush( stdout ); */

		if ( TRACE_OUT != NULL )
			fflush( TRACE_OUT );

		TRACE_ACTIVE = TRUE;
	}

	/* System Halt */

	if ( mid < 0 )
	{
		printf( "PVM System Halt - XPVM exiting...\n" );

		exit( 0 );
	}

	/* Set Up Next Event Recv Handler */

	if ( TRACE_ACTIVE && ( TRACE_STATUS == TRACE_FWD
		|| TRACE_STATUS == TRACE_FWDSTEP ) )
	{
		if ( TRACE_PENDING
			|| TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK )
		{
			Tk_DoWhenIdle( (Tk_IdleProc *) process_event_proc,
				(ClientData) NULL );
		}

		else
		{
			Tk_CreateTimerHandler( RECV_TIMER_INTERVAL,
				(Tk_TimerProc *) process_timer_proc,
				(ClientData) NULL );
		}
	}

	else
	{
		Tk_CreateTimerHandler( RECV_TIMER_INTERVAL,
			(Tk_TimerProc *) recv_timer_proc,
			(ClientData) ( xxx + 1 ) );
	}

	/* printf( "W" ); fflush( stdout ); */
}

/* ARGSUSED */
Tk_TimerProc *process_timer_proc( clientData )
ClientData clientData;
{
	Tk_DoWhenIdle( (Tk_IdleProc *) process_event_proc,
		(ClientData) NULL );
}

/* ARGSUSED */
Tk_IdleProc *process_event_proc( clientData )
ClientData clientData;
{
	struct timeval tm;

	TASK T;

	int tusec;
	int tsec;
	int done;
	int cnt;
	int tid;
	int eid;
	int ret;

	/* printf( "-" ); fflush( stdout ); */

	if ( TRACE_STATUS == TRACE_FWD || TRACE_STATUS == TRACE_FWDSTEP )
	{
		/* printf( "F" ); fflush( stdout ); */

		if ( TRACE_PENDING || TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK )
		{
			/* printf( "E" ); fflush( stdout ); */

			done = 0;

			cnt = 0;

			while ( cnt < PROCESS_COUNTER_INTERVAL && !done )
			{
				/* printf( "E(%d)", TRACE_PENDING ); */
				/* fflush( stdout ); */

				ret = read_trace_event( &tsec, &tusec, &tid, &eid );

				/* printf( "%d", ret ); fflush( stdout ); */

				if ( ret )
				{
					/* Time Adjustment Special Cases */

					if ( eid == TEV_SPNTASK )
					{
						/* Just Ignore */
						find_event_end();
					}

					else if ( eid == TEV_NEWTASK
						|| eid == TEV_ENDTASK
						|| eid == TRACE_OUTPUT
						|| eid == TRACE_HOST_ADD
						|| eid == TRACE_HOST_DEL
						|| eid == TRACE_HOST_SYNC )
					{
						process_pvm_event( eid, tid, tsec, tusec );
					}

					else
					{
						T = get_task_tid( tid );

						/* Normal Event */

						if ( T != NULL )
						{
							normalize_time( T, &tsec, &tusec );

							check_time( tsec, tusec );

							process_pvm_event( eid, tid, tsec, tusec );
						}

						/* Unknown Event */

						else
							find_event_end();
					}

					/* Update Trace Globals */

					if ( TRACE_STATUS == TRACE_FWDSTEP )
					{
						TRACE_STATUS = TRACE_STOP;

						set_trace_controls();

						done++;
					}

					if ( TRACE_FILE_STATUS != TRACE_FILE_PLAYBACK )
					{
						if ( TRACE_PENDING > 0 )
							TRACE_PENDING--;

						if ( !TRACE_PENDING )
							done++;
					}

					/* printf( "(%d)", TRACE_PENDING ); */
					/* fflush( stdout ); */
				}

				else
				{
					if ( TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK )
					{
						TRACE_STATUS = TRACE_STOP;

						set_trace_controls();
					}

					TRACE_ACTIVE = FALSE;

					done++;
				}

				cnt++;
			}

			/* printf( "U" ); fflush( stdout ); */
		}

		/* Update Current Time */

		else
		{
			/* printf( "T" ); fflush( stdout ); */

			if ( tasks_alive() )
			{
				/* printf( "t" ); fflush( stdout ); */

				gettimeofday( &tm, (struct timezone *) NULL );

				normalize_time( (TASK) NULL,
					&(tm.tv_sec), &(tm.tv_usec) );

				check_time( tm.tv_sec, tm.tv_usec );
			}

			else
				TRACE_ACTIVE = FALSE;
		}
	}

	/* Set Up Next Event Receiving Proc */

	Tk_DoWhenIdle( (Tk_IdleProc *) recv_event_proc, (ClientData) NULL );

	/* printf( "_" ); fflush( stdout ); */
}

process_pvm_event( eid, tid, tsec, tusec )
int eid;
int tid;
int tsec;
int tusec;
{
	HOST H;

	static char cmd[4200];

	TASK T;

	char refname[1024];
	char result[4096];
	char alias[1024];
	char where[1024];
	char name[1024];
	char tmp[1024];

	char *u_usec_pad;
	char *s_usec_pad;

	char *str;

	char c;

	int u_sec, u_usec;
	int s_sec, s_usec;

	int msgtag;
	int nbytes;
	int count;
	int found;
	int flags;
	int speed;
	int host;
	int ptid;
	int dtid;
	int stid;
	int usec;
	int sec;
	int buf;
	int num;
	int cc;
	int i;

	str = (char *) NULL;

	switch ( eid )
	{
		case TRACE_HOST_ADD:
		{
			read_trace_str( refname, 1024, TRUE );

			read_trace_str( alias, 1024, TRUE );

			read_trace_str( tmp, 1024, TRUE );

			fscanf( TRACE_IN, ", %d", &speed );

			find_event_end();

			sprintf( result,
				"host %s (%s) added: arch=%s tid=0x%x speed=%d",
					refname, alias, tmp, tid, speed );

			if ( TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK )
			{
				handle_playback_host_add( refname, alias, tmp,
					tid, speed );
			}

			str = result;

			break;
		}

		case TRACE_HOST_DEL:
		{
			read_trace_str( name, 1024, TRUE );

			find_event_end();

			sprintf( result, "host %s deleted: tid=0x%x", name, tid );

			if ( TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK )
				handle_playback_host_del( name, tid );

			str = result;

			break;
		}

		case TRACE_HOST_SYNC:
		{
			fscanf( TRACE_IN, ", %d, %d", &sec, &usec );

			find_event_end();

			H = HOST_LIST;

			found = 0;

			while ( H != NULL && !found )
			{
				if ( H->pvmd_tid == tid )
					found++;

				else
					H = H->next;
			}

			if ( found )
			{
				sprintf( result,
					"host %s (%s) sync delta: %d %d",
						H->name, H->alias, sec, usec );
			}

			else
			{
				sprintf( result,
					"host sync delta: %d %d -- error: tid=%x not found",
						sec, usec, tid );
			}

			if ( TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK )
				handle_playback_host_sync( tid, sec, usec );

			str = result;

			break;
		}

		case TRACE_OUTPUT:
		{
			T = get_task_tid( tid );

			if ( T != NULL )
			{
				read_trace_str( tmp, 1024, TRUE );

				find_event_end();

				sprintf( result, "task output: tid=%x str=\"%s\"",
					tid, tmp );

				normalize_time( T, &tsec, &tusec );

				task_output( tid, tmp );

				str = result;
			}

			else
			{
				find_event_end();

				return;
			}

			break;
		}

		case TEV_NEWTASK:
		{
			fscanf( TRACE_IN, ", %d, %d, %d", &ptid, &host, &flags );

			read_trace_str( name, 1024, TRUE );

			find_event_end();

			if ( !TRACE_GROUP_TASKS && GROUPTASK( name ) )
				return;

			sprintf( result,
				"New Task %s: tid=%x ptid=%x host=%x flags=%d",
				name, tid, ptid, host, flags );

			/* Create New Task Structure */

			if ( TASK_LIST == NULL )
				T = TASK_LIST = create_task();

			else
			{
				T = TASK_LIST;

				while ( T->next != NULL )
					T = T->next;

				T->next = create_task();

				T = T->next;
			}

			T->tid = tid;

			T->name = copy_str( name );

			T->ptid = ptid;

			T->pvmd_tid = host;

			T->flags = flags;

			T->status = TASK_ALIVE;

			/* Handle New Task Times */

			if ( BASE_TIME.tv_sec == -1 )
			{
				sync_time( host, &tsec, &tusec );

				BASE_TIME.tv_sec = tsec;
				BASE_TIME.tv_usec = tusec;

				update_time( 0, 0 );

				tsec = tusec = 0;
			}

			else
			{
				normalize_time( T, &tsec, &tusec );

				check_time( tsec, tusec );
			}

			add_task( T, tsec, tusec, result );

			str = result;

			break;
		}

		case TEV_ENDTASK:
		{
			T = get_task_tid( tid );

			if ( T != NULL && T->status != TASK_DEAD )
			{
				fscanf( TRACE_IN, ", %d, %d, %d, %d, %d",
					&flags, &u_sec, &u_usec, &s_sec, &s_usec );

				find_event_end();

				u_usec_pad = pad_num( u_usec, 6 );
				s_usec_pad = pad_num( s_usec, 6 );

				sprintf( result,
					"End Task tid=%x status=0x%x user=%d.%s sys=%d.%s",
						tid, flags, u_sec, u_usec_pad,
						s_sec, s_usec_pad );

				free( u_usec_pad );
				free( s_usec_pad );

				normalize_time( T, &tsec, &tusec );

				check_time( tsec, tusec );

				remove_task( tid, tsec, tusec, result );

				str = result;
			}

			else
			{
				find_event_end();

				return;
			}

			break;
		}

		case TEV_ADDHOSTS0:
		{
			strcpy( result, "pvm_addhosts0()" );

			fscanf( TRACE_IN, ", %d", &num );

			while ( fscanf( TRACE_IN, "%c", &c ) == 1 && c != '{' );
				/* printf( "(%c)", c ); */

			/* printf( "(%c)", c ); */

			for ( i=0 ; i < num ; i++ )
			{
				read_trace_str( name, 1024, FALSE );

				sprintf( tmp, " %s", name );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE );
			}

			while ( fscanf( TRACE_IN, "%c", &c ) == 1 && c != '}' );
				/* printf( "(%c)", c ); */

			/* printf( "(%c)", c ); */

			find_event_end();

			str = result;

			break;
		}

		case TEV_ADDHOSTS1:
		{
			fscanf( TRACE_IN, ", %d", &cc );

			find_event_end();

			sprintf( result, "pvm_addhosts1() cc=%d", cc );

			str = result;

			break;
		}

		case TEV_SPAWN0:
		{
			read_trace_str( name, 1024, TRUE );

			fscanf( TRACE_IN, ", %d", &flags );

			read_trace_str( where, 1024, TRUE );

			fscanf( TRACE_IN, ", %d", &count );

			find_event_end();

			sprintf( result, "pvm_spawn0() %d copies of %s",
				count, name );

			if ( *where != '\0' )
			{
				sprintf( tmp, " on %s", where );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE ); 
			}

			str = result;

			break;
		}

		case TEV_SPAWN1:
		{
			fscanf( TRACE_IN, ", %d", &num );

			sprintf( result, "pvm_spawn1() %d successful", num );

			while ( fscanf( TRACE_IN, "%c", &c ) == 1 && c != '{' );
				/* printf( "(%c)", c ); */

			/* printf( "(%c)", c ); */

			if ( num > 0 )
			{
				append_cmd_str( result, ":", 4096,
					(char *) NULL, FALSE );

				for ( i=0 ; i < num ; i++ )
				{
					if ( i )
						fscanf( TRACE_IN, ", %d", &stid );

					else
						fscanf( TRACE_IN, "%d", &stid );

					sprintf( tmp, " %x", stid );

					append_cmd_str( result, tmp, 4096,
						(char *) NULL, FALSE );
				}
			}

			while ( fscanf( TRACE_IN, "%c", &c ) == 1 && c != '}' );
				/* printf( "(%c)", c ); */

			/* printf( "(%c)", c ); */

			find_event_end();

			str = result;

			break;
		}

		case TEV_EXIT0:
		{
			find_event_end();

			strcpy( result, "pvm_exit()" );

			remove_task( tid, tsec, tusec, result );

			str = result;

			break;
		}

		case TEV_SEND0:
		{
			fscanf( TRACE_IN, ", %d, %d", &dtid, &msgtag );

			find_event_end();

			sprintf( result, "pvm_send0() to %x, msgtag=%d",
				dtid, msgtag );

			send_message( tid, dtid, msgtag, tsec, tusec );

			str = result;

			break;
		}

		case TEV_MCAST0:
		{
			fscanf( TRACE_IN, ", %d, %d", &num, &msgtag );

			sprintf( result, "pvm_mcast0() msgtag=%d", msgtag );

			while ( fscanf( TRACE_IN, "%c", &c ) == 1 && c != '{' );
				/* printf( "(%c)", c ); */

			/* printf( "(%c)", c ); */

			if ( num > 0 )
			{
				append_cmd_str( result, " to:", 4096,
					(char *) NULL, FALSE );

				for ( i=0 ; i < num ; i++ )
				{
					if ( i )
						fscanf( TRACE_IN, ", %d", &dtid );

					else
						fscanf( TRACE_IN, "%d", &dtid );

					sprintf( tmp, " %x", dtid );

					append_cmd_str( result, tmp, 4096,
						(char *) NULL, FALSE );

					if ( dtid != tid )
						send_message( tid, dtid, msgtag, tsec, tusec );
				}
			}

			while ( fscanf( TRACE_IN, "%c", &c ) == 1 && c != '}' );
				/* printf( "(%c)", c ); */

			/* printf( "(%c)", c ); */

			find_event_end();

			str = result;

			break;
		}

		case TEV_PSEND0:
		{
			fscanf( TRACE_IN, ", %d, %d", &dtid, &msgtag );

			find_event_end();

			sprintf( result, "pvm_psend0() to %x, msgtag=%d",
				dtid, msgtag );

			send_message( tid, dtid, msgtag, tsec, tusec );

			str = result;

			break;
		}

		case TEV_RECV1:
		{
			fscanf( TRACE_IN, ", %d, %d, %d, %d",
				&buf, &nbytes, &msgtag, &stid );

			find_event_end();

			sprintf( result, "pvm_recv1() buf=%d", buf );

			if ( nbytes >= 0 )
			{
				sprintf( tmp, ", %d bytes from %x, msgtag=%d",
					nbytes, stid, msgtag );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE );

				recv_message( tid, stid, msgtag, nbytes, tsec, tusec );
			}

			str = result;

			break;
		}

		case TEV_NRECV1:
		{
			fscanf( TRACE_IN, ", %d, %d, %d, %d",
				&buf, &nbytes, &msgtag, &stid );

			find_event_end();

			strcpy( result, "pvm_nrecv1()" );

			if ( buf > 0 )
			{
				sprintf( tmp, " buf=%d", buf );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE );

				if ( nbytes >= 0 )
				{
					sprintf( tmp, ", %d bytes from %x, msgtag=%d",
						nbytes, stid, msgtag );

					append_cmd_str( result, tmp, 4096,
						(char *) NULL, FALSE );

					recv_message( tid, stid, msgtag, nbytes,
						tsec, tusec );
				}
			}

			else
			{
				append_cmd_str( result, " no message", 4096,
					(char *) NULL, FALSE );
			}

			str = result;

			break;
		}

		case TEV_PRECV1:
		{
			fscanf( TRACE_IN, ", %d, %d, %d, %d",
				&buf, &nbytes, &msgtag, &stid );

			find_event_end();

			sprintf( result, "pvm_precv1() buf=%d", buf );

			if ( nbytes >= 0 )
			{
				sprintf( tmp, ", %d bytes from %x, msgtag=%d",
					nbytes, stid, msgtag );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE );

				recv_message( tid, stid, msgtag, nbytes, tsec, tusec );
			}

			str = result;

			break;
		}

		case TEV_TRECV1:
		{
			fscanf( TRACE_IN, ", %d, %d, %d, %d",
				&buf, &nbytes, &msgtag, &stid );

			find_event_end();

			sprintf( result, "pvm_trecv1() buf=%d", buf );

			if ( nbytes >= 0 )
			{
				sprintf( tmp, ", %d bytes from %x, msgtag=%d",
					nbytes, stid, msgtag );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE );

				recv_message( tid, stid, msgtag, nbytes, tsec, tusec );
			}

			str = result;

			break;
		}

		default:
			str = pvm_event_string( eid );
	}

	switch ( TEV_TYPE[ eid ] )
	{
		case ENTRY_TEV:
		{
			sprintf( cmd, "task_state %x pvm_call %d %d \"%s\"",
				tid, tsec, tusec, str );

			break;
		}

		case EXIT_TEV:
		{
			sprintf( cmd, "task_state %x running %d %d \"%s\"",
				tid, tsec, tusec, str );

			break;
		}

		case BLOCK_TEV:
		{
			sprintf( cmd, "task_state %x idle %d %d \"%s\"",
				tid, tsec, tusec, str );

			break;
		}

		case IGNORE_TEV:
		{
			sprintf( cmd, "" );

			break;
		}
	}

	if ( !tflag && strcmp( cmd, "" ) )
		Tcl_Eval( interp, cmd );

	if ( eflag )
	{
		printf( "PVM Event: %d %d %x %s\n", tsec, tusec, tid, str );

		fflush( stdout );
	}

	if ( str != NULL && str != result )
		free( str );
}

char *pvm_event_string( eid )
int eid;
{
	char result[4096];
	char tmp[2048];
	char buf[1024];

	char *fmt;
	char *str;

	int keeplist[10];

	int vecflag;
	int veclen;
	int index;
	int nkeep;
	int keep;
	int ival;
	int sep;

	fmt = tev_formats[ eid ].fmt;

	if ( fmt != NULL )
	{
		nkeep = 0;

		if ( *fmt != '=' )
			sprintf( result, "%s", tev_formats[ eid ].name );

		else
			sprintf( result, "%s() ", tev_formats[ eid ].name );
	
		while ( *fmt )
		{
			if ( *fmt == '%' )
			{
				fmt++;

				if ( *fmt == '*' )
				{
					keep = TRUE;

					fmt++;
				}

				else
					keep = FALSE;

				if ( *fmt == '$' )
				{
					fmt++;

					index = *fmt - '0';

					fmt++;

					veclen = ( index >= 0 && index < nkeep )
						? keeplist[index] : 0;

					vecflag = TRUE;

					sep = FALSE;
				}

				else
				{
					veclen = 1;

					vecflag = FALSE;
				}

				while ( veclen > 0 )
				{
					veclen--;

					if ( vecflag )
					{
						if ( sep )
						{
							append_cmd_str( result, " ", 4096,
								(char *) NULL, FALSE );
						}

						sep = TRUE;
					}

					switch ( *fmt )
					{
						case 'd':
						{
							fscanf( TRACE_IN, ", %d", &ival );
		
							sprintf( tmp, " %d", ival );
		
							append_cmd_str( result, tmp, 4096,
								(char *) NULL, FALSE );
	
							break;
						}
		
						/* decimal result code */
						case 'R':
						{
							fscanf( TRACE_IN, ", %d", &ival );
		
							sprintf( tmp, " %d", ival );
	
							append_cmd_str( result, tmp, 4096,
								(char *) NULL, FALSE );
	
							if ( ival < 0 )
							{
								if ( ival <= 0 && ival > -pvm_nerr )
								{
									sprintf( tmp, " (%s)",
										pvm_errlist[ -ival ] );
								}
								
								else
								{
									sprintf( tmp, " %d (Unknown Error)",
										ival );
								}
	
								append_cmd_str( result, tmp, 4096,
									(char *) NULL, FALSE );
							}
		
							break;
						}
		
						/* hex result code / decimal if negative */
						case 'r':
						{
							fscanf( TRACE_IN, ", %d", &ival );
		
							if ( ival < 0 )
							{
								if ( ival <= 0 && ival > -pvm_nerr )
								{
									sprintf( tmp, " %d (%s)",
										ival, pvm_errlist[ -ival ] );
								}
	
								else
								{
									sprintf( tmp, " %d (Unknown Error)",
										ival );
								}
							}
							
							else
								sprintf( tmp, " 0x%x", ival );
		
							append_cmd_str( result, tmp, 4096,
								(char *) NULL, FALSE );
	
							break;
						}
		
						case 'x':
						{
							fscanf( TRACE_IN, ", %d", &ival );
		
							sprintf( tmp, " 0x%x", ival );
		
							append_cmd_str( result, tmp, 4096,
								(char *) NULL, FALSE );
		
							break;
						}
		
						case 'S':
						{
							read_trace_str( buf, 1024, TRUE );
		
							sprintf( tmp, " \"%s\"", buf );
		
							append_cmd_str( result, tmp, 4096,
								(char *) NULL, FALSE );
		
							break;
						}
		
						default:
						{
							sprintf( tmp, "%%%c", *fmt );
		
							append_cmd_str( result, tmp, 4096,
								(char *) NULL, FALSE );
	
							break;
						}
					}
				}
	
				if ( *fmt )
					fmt++;
				
				if ( keep )
				{
					keeplist[nkeep] = ival < 0 ? 0 : ival;

					nkeep++;
				}
			}
			
			else
			{
				sprintf( tmp, "%c", *fmt++ );

				append_cmd_str( result, tmp, 4096,
					(char *) NULL, FALSE );
			}
		}
	}

	else
		sprintf( result, "%s()", tev_formats[ eid ].name );

	find_event_end();

	str = copy_str( result );

	return( str );
}

task_output( tid, str )
int tid;
char *str;
{
	char tmp[4096];

	if ( !strcmp( str, "GOTEOF" ) )
	{
		sprintf( tmp, "task_output %x EOF", tid );

		if ( OUTPUT_FP != NULL )
		{
			fprintf( OUTPUT_FP, "[t%x] EOF\n", tid );

			fflush( OUTPUT_FP );
		}
	}

	else if ( strcmp( str, "CREATION" ) && strcmp( str, "GOTSPAWN" ) )
	{
		sprintf( tmp, "task_output %x {%s}", tid, str );

		if ( OUTPUT_FP != NULL )
		{
			fprintf( OUTPUT_FP, "[t%x] %s\n", tid, str );

			fflush( OUTPUT_FP );
		}
	}

	else
		return;

	Tcl_Eval( interp, tmp );
}

send_message( src, dst, msgtag, sec, usec )
int src;
int dst;
int msgtag;
int sec;
int usec;
{
	MSG M;

	MSG last;

	/* printf("S"); fflush( stdout ); */

	if ( FALSE && eflag )
	{
		printf( "\tsent %x to %x, msgtag=%d at %d.%d\n",
			src, dst, msgtag, sec, usec );
	}

	M = MSG_LIST;

	last = (MSG) NULL;

	while ( M != NULL )
	{
		if ( M->dst_tid == dst && M->src_tid == src
			&& M->msgtag == msgtag
			&& M->sendtime.tv_sec == -1 && M->sendtime.tv_usec == -1 )
		{
			M->sendtime.tv_sec = sec;
			M->sendtime.tv_usec = usec;

			update_message( M );

			if ( last != NULL )
				last->next = M->next;

			else
				MSG_LIST = M->next;

			free_msg( &M );

			NMSGS--;

			/* printf(">"); fflush( stdout ); */

			return;
		}

		else
		{
			last = M;

			M = M->next;
		}
	}

	/* Didn't Find Matching Recv, Make New Message */

	if ( last == NULL )
	{
		M = MSG_LIST = create_msg();

		NMSGS = 1;
	}

	else
	{
		last->next = create_msg();

		M = last->next;

		NMSGS++;
	}

	M->src_tid = src;
	M->dst_tid = dst;

	M->msgtag = msgtag;

	M->sendtime.tv_sec = sec;
	M->sendtime.tv_usec = usec;

	/* printf("]"); fflush( stdout ); */
}

recv_message( dst, src, msgtag, nbytes, sec, usec )
int dst;
int src;
int msgtag;
int nbytes;
int sec;
int usec;
{
	MSG M;

	MSG last;

	/* printf("R"); fflush( stdout ); */

	if ( FALSE && eflag )
	{
		printf( "\trecvd %x from %x, msgtag=%d, %d bytes at %d.%d\n",
			dst, src, msgtag, nbytes, sec, usec );
	}

	M = MSG_LIST;

	last = (MSG) NULL;

	while ( M != NULL )
	{
		if ( M->dst_tid == dst && M->src_tid == src
			&& M->msgtag == msgtag
			&& M->recvtime.tv_sec == -1 && M->recvtime.tv_usec == -1 )
		{
			M->nbytes = nbytes;

			M->recvtime.tv_sec = sec;
			M->recvtime.tv_usec = usec;

			update_message( M );

			if ( last != NULL )
				last->next = M->next;

			else
				MSG_LIST = M->next;

			free_msg( &M );

			NMSGS--;

			/* printf(">"); fflush( stdout ); */

			return;
		}

		else
		{
			last = M;

			M = M->next;
		}
	}

	/* Didn't Find Matching Send, Make New Message */

	if ( last == NULL )
	{
		M = MSG_LIST = create_msg();

		NMSGS = 1;
	}

	else
	{
		last->next = create_msg();

		M = last->next;

		NMSGS++;
	}

	M->src_tid = src;
	M->dst_tid = dst;

	M->msgtag = msgtag;

	M->nbytes = nbytes;

	M->recvtime.tv_sec = sec;
	M->recvtime.tv_usec = usec;

	/* printf("]"); fflush( stdout ); */
}

update_message( M )
MSG M;
{
	static char cmd[1024];

	sprintf( cmd, "new_message %x %x %d %d %d %d %d %d",
		M->src_tid, M->dst_tid, M->nbytes, M->msgtag,
		M->sendtime.tv_sec, M->sendtime.tv_usec,
		M->recvtime.tv_sec, M->recvtime.tv_usec );

	if ( !tflag )
		Tcl_Eval( interp, cmd );
}

add_task( T, tsec, tusec, str )
TASK T;
int tsec;
int tusec;
char *str;
{
	static char cmd[1024];

	HOST H;

	int found;

	H = HOST_LIST;

	found = 0;

	while ( H != NULL && !found )
	{
		if ( ( ( H->in_pvm == IN_PVM
				&& TRACE_FILE_STATUS == TRACE_FILE_OVERWRITE )
			|| ( H->in_pvm == PLAYBACK_ADDED
				&& TRACE_FILE_STATUS == TRACE_FILE_PLAYBACK ) )
			&& H->pvmd_tid == T->pvmd_tid )
		{
			found++;
		}

		else
			H = H->next;
	}

	if ( !found )
	{
		printf( "\nError: Missing Host for pvmd_tid=%x\n\n",
			T->pvmd_tid );

		return;
	}

	sprintf( cmd, "add_task %s %d %s %x %d %d \"%s\"",
		host_name( H, FALSE ), H->index, T->name,
		T->tid, tsec, tusec, str );

	if ( !tflag )
		Tcl_Eval( interp, cmd );
}

remove_task( tid, tsec, tusec, str )
int tid;
int tsec;
int tusec;
char *str;
{
	TASK T;

	T = TASK_LIST;

	while ( T != NULL )
	{
		if ( T->tid == tid )
		{
			exit_task( T, tsec, tusec, str );
	
			T->status = TASK_DEAD;

			return;
		}
	
		T = T->next;
	}
}

exit_task( T, tsec, tusec, str )
TASK T;
int tsec;
int tusec;
char *str;
{
	static char cmd[255];

	sprintf( cmd, "exit_task %x %d %d \"%s\"",
		T->tid, tsec, tusec, str );

	if ( !tflag )
		Tcl_Eval( interp, cmd );
}

normalize_time( T, psec, pusec )
TASK T;
int *psec;
int *pusec;
{
	/* Adjust Host Delay Time */

	if ( T != NULL )
		sync_time( T->pvmd_tid, psec, pusec );

	/* Adjust Time Relative to Base Time */

	if ( BASE_TIME.tv_sec != -1 )
	{
		*psec -= BASE_TIME.tv_sec;
		*pusec -= BASE_TIME.tv_usec;
	
		if ( *pusec < 0 )
		{
			*pusec += 1000000;
	
			(*psec)--;
		}
	}

	else
	{
		*psec = 0;
		*pusec = 0;
	}
}

sync_time( host, psec, pusec )
int host;
int *psec;
int *pusec;
{
	HOST H;

	int found;

	H = HOST_LIST;

	found = 0;

	while ( H != NULL && !found )
	{
		if ( H->pvmd_tid == host )
		{
			*psec += H->delta.tv_sec;
			*pusec += H->delta.tv_usec;

			if ( *pusec > 1000000 )
			{
				*pusec -= 1000000;
	
				(*psec)++;
			}

			else if ( *pusec < 0 )
			{
				*pusec += 1000000;
	
				(*psec)--;
			}

			found++;
		}

		else
			H = H->next;
	}
}

check_time( tsec, tusec )
{
	int flag;

	if ( BASE_TIME.tv_sec == -1 )
		return;

	flag = 0;

	if ( tsec > CURRENT_TIME.tv_sec )
		flag++;
	
	else if ( tsec == CURRENT_TIME.tv_sec
		&& tusec > CURRENT_TIME.tv_usec )
	{
		flag++;
	}

	if ( flag )
		update_time( tsec, tusec );
}

update_time( sec, usec )
int sec;
int usec;
{
	static char cmd[255];

	char *usec_pad;

	/* hack( sec, usec ); */

	CURRENT_TIME.tv_sec = sec;
	CURRENT_TIME.tv_usec = usec;

	usec_pad = pad_num( CURRENT_TIME.tv_usec, 6 );

	sprintf( cmd, "update_time %ld %ld %d.%s",
		CURRENT_TIME.tv_sec, CURRENT_TIME.tv_usec,
		CURRENT_TIME.tv_sec, usec_pad );

	free( usec_pad );

	if ( !tflag )
		Tcl_Eval( interp, cmd );
}

update_trace_time( sec, usec )
int sec;
int usec;
{
	struct timeval tm;

	if ( sec == -1 )
	{
		gettimeofday( &tm, (struct timezone *) NULL );

		sec = tm.tv_sec;
		usec = tm.tv_usec;
	}

	if ( sec > TRACE_TIME.tv_sec ||
		( sec == TRACE_TIME.tv_sec && usec > TRACE_TIME.tv_usec ) )
	{
		TRACE_TIME.tv_sec = sec;
		TRACE_TIME.tv_usec = usec;
	}
}


/* Test Hack */
/*
hack( sec, usec )
int sec;
int usec;
{
	ARCH get_arch_id();

	ARCH A;

	Tk_Window tkwin;

	XGCValues gcv;

	Pixmap p;

	GC gc;

	int winid;
	int mask;
	int i;

	if ( sec >= 2 )
	{
		printf( "sec=%d\n", sec );

		gcv.foreground = BlackPixelOfScreen( Tk_Screen( Top ) );
		gcv.background = WhitePixelOfScreen( Tk_Screen( Top ) );

		gcv.function = GXcopy;

		mask = GCForeground | GCBackground | GCFunction;

		gc = Tk_GetGC( Top, mask, &gcv );

		A = get_arch_id( sec );

		if ( A != NULL )
		{
			p = Tk_GetBitmap( interp, Top, Tk_GetUid( A->name ) );

			tkwin = Tk_NameToWindow( interp,
				".xpvm.space_time.canvas", Top );

			winid = Tk_WindowId( tkwin );

			printf( "p=%ld tkwin=%x winid=%ld\n", p, tkwin, winid );

			for ( i=0 ; i < 10 ; i++ )
			{
				XCopyPlane( Disp, p, winid, gc,
					0, 0, A->width, A->height, 10 * sec, 100 * i, 1 );
			}
		}
	}
}
*/
/* End of Test Hack */

add_all_hosts()
{
	HOST H;

	ARCH A;

	struct pvmhostinfo *HP;

	struct pvmhostinfo *hostp;

	char result[4096];
	char tmp[4192];

	char **hosts;

	char *iconstr;

	int *infos;
	
	int nhosts;
	int found;
	int narch;
	int nhost;
	int i, j;
	int chk;
	int cc;

	Tcl_Eval( interp, "setMsg \"Adding All Hosts...\"" );

	H = HOST_LIST;

	nhosts = 0;

	while ( H != NULL )
	{
		if ( H->in_pvm == NOT_IN_PVM )
			nhosts++;

		H = H->next;
	}

	if ( nhosts )
	{
		hosts = (char **) malloc( (unsigned) nhosts * sizeof(char *) );
		memcheck( hosts, "Add All Hosts List" );

		infos = (int *) malloc( (unsigned) nhosts * sizeof(int) );
		memcheck( infos, "Add All Hosts Infos" );

		H = HOST_LIST;

		i = 0;

		while ( H != NULL )
		{
			if ( H->in_pvm == NOT_IN_PVM )
				hosts[i++] = copy_str( H->refname );

			H = H->next;
		}

		cc = pvm_addhosts( hosts, nhosts, infos );

		if ( cc < 0 )
		{
			pvm_perror( "Add All Hosts" );

			strcpy( result, "Error Adding All Hosts." );
		}

		else
		{
			chk = nhosts - cc;

			if ( chk < nhosts )
			{
				cc = pvm_config( &nhost, &narch, &hostp );

				if ( cc < 0 )
				{
					pvm_perror( "Checking Configuration" );

					error_exit();
				}
			}

			if ( chk )
				strcpy( result, "Error Adding Hosts: " );

			else
				strcpy( result, "All Hosts Added. " );

			for ( i=0 ; i < nhosts ; i++ )
			{
				H = HOST_LIST;

				while ( H != NULL && strcmp( H->refname, hosts[i] ) )
					H = H->next;

				if ( infos[i] < 0 )
				{
					sprintf( tmp, "%s ", hosts[i] );

					append_cmd_str( result, tmp, 4096,
						"checkHostResult", TRUE );

					sprintf( tmp, "{OFF %d} ", H->index );

					append_cmd_str( result, tmp, 4096,
						"checkHostResult", TRUE );
				}

				else
				{
					H->in_pvm = IN_PVM;

					if ( H != NULL && H->arch == NULL )
					{
						found = 0;

						for ( j=0 ; j < nhost && !found ; j++ )
						{
							HP = &(hostp[j]);

							if ( !strcmp( H->name, HP->hi_name )
								|| !strcmp( H->alias, HP->hi_name ) )
							{
								free( H->name );

								free( H->alias );

								H->name = copy_str( HP->hi_name );

								H->alias = host_alias_str( H->name );

								H->arch = check_arch( H, HP->hi_arch );

								H->pvmd_tid = HP->hi_tid;

								H->speed = HP->hi_speed;

								found++;
							}
						}

						if ( found )
						{
							A = get_arch_code( H->arch );

							if ( A != NULL )
							{
								iconstr = get_arch_icon_str( A );

								sprintf( tmp, "{ICON %d %s} ",
									H->index, iconstr );

								append_cmd_str( result, tmp, 4096,
									"checkHostResult", TRUE );

								free( iconstr );
							}

							pvm_hostsync( H->pvmd_tid,
								(struct timeval *) NULL, &(H->delta) );
						}
					}

					sprintf( tmp, "{ON %d} ", H->index );

					append_cmd_str( result, tmp, 4096,
						"checkHostResult", TRUE );
				}
			}
		}

		sprintf( tmp, "checkHostResult { %s }", result );

		Tcl_Eval( interp, tmp );

		for ( i=0 ; i < nhosts ; i++ )
			free( hosts[i] );

		free( hosts );

		free( infos );
	}
}

do_add_host( H )
HOST H;
{
	Tk_DoWhenIdle( (Tk_IdleProc *) add_host, (ClientData) H );
}

Tk_IdleProc *add_host( clientData )
ClientData clientData;
{
	HOST H;

	ARCH A;

	struct pvmhostinfo *HP;

	struct pvmhostinfo *hostp;

	char result[4096];
	char tmp[2048];

	char *iconstr;

	int found;
	int narch;
	int nhost;
	int infos;
	int cc;
	int i;

	H = (HOST) clientData;

	sprintf( result, "setMsg \"Adding Host %s...\"",
		host_name( H, TRUE ) );

	Tcl_Eval( interp, result );

	cc = pvm_addhosts( &(H->refname), 1, &infos );

	if ( cc < 0 || infos < 0 )
	{
		pvm_perror( H->refname );

		sprintf( result, "Error Adding Host %s. ",
			host_name( H, TRUE ) );

		sprintf( tmp, "{OFF %d} ", H->index );

		append_cmd_str( result, tmp, 4096,
			"checkHostResult", TRUE );

		sprintf( tmp, "checkHostResult { %s }", result );

		Tcl_Eval( interp, tmp );
	}

	else
	{
		/* Mark Host as Added */

		H->in_pvm = IN_PVM;

		sprintf( result, "Host %s Added. ", host_name( H, TRUE ) );

		/* Update Configuration Info */

		cc = pvm_config( &nhost, &narch, &hostp );

		if ( cc < 0 )
		{
			pvm_perror( "Checking Configuration" );

			error_exit();
		}

		found = 0;

		for ( i=0 ; i < nhost && !found ; i++ )
		{
			HP = &(hostp[i]);

			if ( !strcmp( H->name, HP->hi_name )
				|| !strcmp( H->alias, HP->hi_name ) )
			{
				free( H->name );

				free( H->alias );

				H->name = copy_str( HP->hi_name );

				H->alias = host_alias_str( H->name );

				H->arch = check_arch( H, HP->hi_arch );

				H->pvmd_tid = HP->hi_tid;

				H->speed = HP->hi_speed;

				if ( (A = get_arch_code( H->arch )) != NULL )
				{
					iconstr = get_arch_icon_str( A );

					sprintf( tmp, "{ICON %d %s} ", H->index, iconstr );

					append_cmd_str( result, tmp, 4096,
						"checkHostResult", TRUE );

					free( iconstr );
				}

				pvm_hostsync( H->pvmd_tid,
					(struct timeval *) NULL, &(H->delta) );

				found++;
			}
		}

		/* Update Interface */

		sprintf( tmp, "{ON %d} ", H->index );

		append_cmd_str( result, tmp, 4096,
			"checkHostResult", TRUE );

		sprintf( tmp, "checkHostResult { %s }", result );

		Tcl_Eval( interp, tmp );
	}
}

do_delete_host( H )
HOST H;
{
	Tk_DoWhenIdle( (Tk_IdleProc *) delete_host, (ClientData) H );
}

Tk_IdleProc *delete_host( clientData )
ClientData clientData;
{
	HOST H;

	struct pvmhostinfo *HP;

	struct pvmhostinfo *hostp;

	char result[4096];
	char tmp[2048];

	char *strcat();

	int found;
	int infos;
	int narch;
	int nhost;
	int cc;
	int i;

	H = (HOST) clientData;

	if ( LOCALHOST( H->name ) )
	{
		sprintf( result, "Error Deleting XPVM's Host, %s. ",
			host_name( H, TRUE ) );

		sprintf( tmp, "{ON %d} ", H->index );

		append_cmd_str( result, tmp, 4096,
			"checkHostResult", TRUE );
	}

	else
	{
		sprintf( result, "setMsg \"Deleting Host %s...\"",
			host_name( H, TRUE ) );
	
		Tcl_Eval( interp, result );
	
		cc = pvm_delhosts( &(H->name), 1, &infos );
	
		if ( cc < 0 || infos < 0 )
		{
			pvm_perror( H->name );
	
			sprintf( result, "Error Deleting Host %s. ",
				host_name( H, TRUE ) );
	
			cc = pvm_config( &nhost, &narch, &hostp );
	
			if ( cc < 0 )
			{
				strcat( result, "Config Call Failed. " );
	
				sprintf( tmp, "{ON %d} ", H->index );
	
				append_cmd_str( result, tmp, 4096,
					"checkHostResult", TRUE );
			}
	
			else
			{
				found = 0;
	
				for ( i=0 ; i < nhost && !found ; i++ )
				{
					HP = &(hostp[i]);
	
					if ( !strcmp( H->name, HP->hi_name )
						|| !strcmp( H->alias, HP->hi_name ) )
					{
						found++;
					}
				}
	
				if ( !found )
					sprintf( tmp, "{OFF %d} ", H->index );
	
				else
					sprintf( tmp, "{ON %d} ", H->index );
	
				append_cmd_str( result, tmp, 4096,
					"checkHostResult", TRUE );
			}
		}
	
		else
		{
			/* Mark Host as Deleted */
	
			H->in_pvm = NOT_IN_PVM;
	
			H->arch = (char *) NULL;
	
			sprintf( result, "Host %s Deleted. ",
				host_name( H, TRUE ) );
	
			sprintf( tmp, "{OFF %d} ", H->index );
	
			append_cmd_str( result, tmp, 4096,
				"checkHostResult", TRUE );
		}
	}

	sprintf( tmp, "checkHostResult { %s }", result );

	Tcl_Eval( interp, tmp );
}

clear_hosts_for_playback()
{
	HOST H;

	char result[4096];
	char tmp[2048];

	int flag;

	strcpy( result, "" );

	H = HOST_LIST;

	while ( H != NULL )
	{
		flag = 0;

		if ( H->in_pvm == IN_PVM )
			flag++;

		else if ( H->in_pvm == PLAYBACK_ADDED )
		{
			H->in_pvm = PLAYBACK_UNUSED;

			flag++;
		}

		if ( flag )
		{
			sprintf( tmp, "{OFF %d} ", H->index );

			append_cmd_str( result, tmp, 4096,
				"checkHostResult", TRUE );
		}

		H = H->next;
	}

	sprintf( tmp, "checkHostResult { %s }", result );

	Tcl_Eval( interp, tmp );
}

restore_hosts_from_playback()
{
	HOST H;

	char result[4096];
	char tmp[2048];

	strcpy( result, "" );

	H = HOST_LIST;

	while ( H != NULL )
	{
		if ( H->in_pvm == IN_PVM )
		{
			sprintf( tmp, "{ON %d} ", H->index );

			append_cmd_str( result, tmp, 4096,
				"checkHostResult", TRUE );

			if ( !LOCALHOST( H->name ) )
			{
				pvm_hostsync( H->pvmd_tid,
					(struct timeval *) NULL, &(H->delta) );
			}
		}

		else if ( H->in_pvm == PLAYBACK_ADDED )
		{
			H->in_pvm = PLAYBACK_UNUSED;

			sprintf( tmp, "{OFF %d} ", H->index );

			append_cmd_str( result, tmp, 4096,
				"checkHostResult", TRUE );
		}

		H = H->next;
	}

	sprintf( tmp, "checkHostResult { %s }", result );

	Tcl_Eval( interp, tmp );
}

handle_playback_host_add( refname, alias, arch, tid, speed )
char *refname;
char *alias;
char *arch;
int tid;
int speed;
{
	HOST H;

	HOST last;

	ARCH A;

	char result[4096];
	char name[1024];
	char tmp[2048];

	char *iconstr;

	int found;

	sscanf( refname, "%s", name );

	H = HOST_LIST;

	last = (HOST) NULL;

	found = 0;

	while ( H != NULL && !found )
	{
		if ( !strcmp( H->name, name ) && !strcmp( H->alias, alias )
			&& H->arch != NULL && !strcmp( H->arch, arch )
			&& H->pvmd_tid == tid )
		{
			if ( H->in_pvm == PLAYBACK_UNUSED )
				found++;

			else if ( H->in_pvm == PLAYBACK_ADDED )
				return;

			else
			{
				last = H;

				H = H->next;
			}
		}

		else
		{
			last = H;

			H = H->next;
		}
	}

	if ( found )
	{
		H->in_pvm = PLAYBACK_ADDED;

		strcpy( result, "" );
	}

	else
	{
		if ( last == NULL )
			H = HOST_LIST = create_host();

		else
			H = last->next = create_host();

		H->in_pvm = PLAYBACK_ADDED;

		H->refname = copy_str( refname );

		H->name = copy_str( name );

		H->alias = copy_str( alias );

		H->arch = copy_str( arch );

		H->pvmd_tid = tid;

		H->speed = speed;

		H->index = NHOSTS;

		sprintf( result, "{NEW %s %d TMP} ",
			host_name( H, FALSE ), MAX_HID + NHOSTS );

		NHOSTS++;

		if ( (A = get_arch_code( H->arch )) != NULL )
		{
			iconstr = get_arch_icon_str( A );

			sprintf( tmp, "{ICON %d %s} ", H->index, iconstr );

			append_cmd_str( result, tmp, 4096,
				"checkHostResult", TRUE );

			free( iconstr );
		}
	}

	/* Update Interface */

	sprintf( tmp, "{ON %d} ", H->index );

	append_cmd_str( result, tmp, 4096,
		"checkHostResult", TRUE );

	sprintf( tmp, "checkHostResult { %s }", result );

	Tcl_Eval( interp, tmp );
}

handle_playback_host_del( name, tid )
char *name;
int tid;
{
	HOST H;

	char result[4096];
	char tmp[2048];

	int found;

	H = HOST_LIST;

	found = 0;

	while ( H != NULL && !found )
	{
		if ( !strcmp( H->name, name ) && H->pvmd_tid == tid
			&& H->in_pvm == PLAYBACK_ADDED )
		{
			found++;
		}

		else
			H = H->next;
	}

	if ( found )
	{
		H->in_pvm = PLAYBACK_UNUSED;

		sprintf( result, "{OFF %d} ", H->index );

		sprintf( tmp, "checkHostResult { %s }", result );

		Tcl_Eval( interp, tmp );
	}
}

handle_playback_host_sync( tid, sec, usec )
int tid;
int sec;
int usec;
{
	HOST H;

	int found;

	H = HOST_LIST;

	found = 0;

	while ( H != NULL && !found )
	{
		if ( H->pvmd_tid == tid )
		{
			H->delta.tv_sec = sec;
			H->delta.tv_usec = usec;

			found++;
		}

		H = H->next;
	}
}

char *check_arch( H, arch )
HOST H;
char *arch;
{
	char *tmp;

	if ( Xflag )
	{
		if ( !strcmp( H->alias, "msr" ) )
			tmp = "PGON";

		else if ( !strcmp( H->alias, "icarus" ) )
			tmp = "I860";

		else if ( !strcmp( H->alias, "sparky" ) )
			tmp = "KSR1";

		else if ( !strcmp( H->alias, "rigel" ) )
			tmp = "CRAY";

		else if ( !strcmp( H->alias, "ig" ) )
			tmp = "CM5";

		else if ( !strcmp( H->alias, "honk" ) )
			tmp = arch;

		else
			tmp = arch;
	}

	else
		tmp = arch;

	return( copy_str( tmp ) );
}

char *host_name( H, full )
HOST H;
int full;
{
	char str[1024];

	char *tmp;

	int hacked;

	hacked = 0;

	if ( Xflag )
	{
		if ( !strcmp( H->alias, "msr" ) )
			{ tmp = "xps5"; hacked++; }

		else if ( !strcmp( H->alias, "icarus" ) )
			{ tmp = "rx"; hacked++; }

		else if ( !strcmp( H->alias, "sparky" ) )
			{ tmp = "ksr"; hacked++; }

		else
			tmp = H->alias;
	}

	else
		tmp = H->alias;

	if ( full && !hacked && strcmp( H->name, tmp ) )
		sprintf( str, "%s (%s)", H->name, tmp );

	else
		sprintf( str, "%s", tmp );

	return( copy_str( str ) );
}

